-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 66 to version 67
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Microsoft SQL Server
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------

-- Drop views which has a new definition or depend on changed tables
DROP VIEW IWA_TaskQuery
GO


-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_RoleDeleteTrigger
GO

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_UserDeleteTrigger
GO

-- Drop unique constraint which depend on changed columns or was deleted
-- Store Procedure to drop a unique constraint
CREATE PROCEDURE IWA_Drop_Unique
@tablename varchar(100)
AS
DECLARE @parentid integer
DECLARE @uqname varchar(100)
DECLARE table_cursor CURSOR FOR SELECT id FROM sysobjects WHERE name = @tablename
OPEN  table_cursor
FETCH NEXT FROM table_cursor INTO @parentid
IF @@FETCH_STATUS<>0
BEGIN
  RAISERROR ('TABLE %s not found in table sysobjects', 16, 1, @tablename)
  CLOSE table_cursor
  DEALLOCATE table_cursor
  RETURN
END
DECLARE uq_cursor CURSOR FOR
SELECT name from sysobjects WHERE parent_obj = @parentid AND xtype = 'UQ'
CLOSE table_cursor
DEALLOCATE table_cursor
OPEN uq_cursor
FETCH NEXT FROM uq_cursor INTO @uqname
IF @@FETCH_STATUS<>0
BEGIN
  RAISERROR('Unique constraint of table %s not found in table sysobjects', 16, 1, @tablename);
  CLOSE uq_cursor
  DEALLOCATE uq_cursor
  RETURN
END
WHILE @@FETCH_STATUS=0
BEGIN
  EXEC('ALTER TABLE '+@tablename+' DROP CONSTRAINT '+@uqname)
  FETCH NEXT FROM uq_cursor INTO @uqname
END
CLOSE uq_cursor
DEALLOCATE uq_cursor
GO

EXECUTE IWA_Drop_Unique 'IWA_Application'
GO
DECLARE @defname VARCHAR(100), @cmd VARCHAR(1000)
SET @defname = 
(SELECT name
FROM sysobjects so JOIN sysconstraints sc
ON so.id = sc.constid
WHERE object_name(so.parent_obj) = 'IWA_Application'
AND so.xtype = 'D'
AND sc.colid =
 (SELECT colid FROM syscolumns
 WHERE id = object_id('dbo.IWA_Application') AND
 name = 'ExternalSecuritySystemName'))
SET @cmd = 'ALTER TABLE IWA_Application DROP CONSTRAINT '
+ @defname
EXEC(@cmd)

GO

-- Dropped columns of table IWA_Application
ALTER TABLE IWA_Application DROP COLUMN SystemUserId
GO

ALTER TABLE IWA_Application DROP COLUMN ExternalSecuritySystemName
GO


-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_Application ADD UNIQUE (Name)
GO

-- Create new indexes of table IWA_User
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_User') AND name='IWA_User_StateIndex')
  CREATE INDEX IWA_User_StateIndex ON IWA_User ("State")
GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_RoleDeleteTrigger
  ON IWA_Role FOR DELETE AS
  IF (@@ROWCOUNT > 0)
  BEGIN

    DELETE IWA_Role FROM IWA_Role, deleted
    WHERE IWA_Role.ParentRoleId = deleted.RoleId

    DELETE IWA_RoleProperty FROM IWA_RoleProperty, deleted
    WHERE IWA_RoleProperty.RoleId = deleted.RoleId

    DELETE IWA_RoleRoleMember FROM IWA_RoleRoleMember, deleted
    WHERE IWA_RoleRoleMember.RoleId = deleted.RoleId

    DELETE IWA_RoleRoleMember FROM IWA_RoleRoleMember, deleted
    WHERE IWA_RoleRoleMember.RoleMemberId = deleted.RoleId

    DELETE IWA_UserRole FROM IWA_UserRole, deleted
    WHERE IWA_UserRole.RoleId = deleted.RoleId

    DELETE IWA_UserSubstitute FROM IWA_UserSubstitute, deleted
    WHERE IWA_UserSubstitute.SubstituteForRoleId = deleted.RoleId

    UPDATE IWA_StartElement    SET IWA_StartElement.ActivatorRoleId=NULL
    FROM IWA_StartElement, deleted
    WHERE IWA_StartElement.ActivatorRoleId = deleted.RoleId

    UPDATE IWA_StartEventElement    SET IWA_StartEventElement.ActivatorRoleId=NULL
    FROM IWA_StartEventElement, deleted
    WHERE IWA_StartEventElement.ActivatorRoleId = deleted.RoleId

    UPDATE IWA_WebServiceProcStartElement    SET IWA_WebServiceProcStartElement.ActivatorRoleId=NULL
    FROM IWA_WebServiceProcStartElement, deleted
    WHERE IWA_WebServiceProcStartElement.ActivatorRoleId = deleted.RoleId

    UPDATE IWA_Case    SET IWA_Case.OwnerRoleId=NULL
    FROM IWA_Case, deleted
    WHERE IWA_Case.OwnerRoleId = deleted.RoleId

    UPDATE IWA_Task    SET IWA_Task.ActivatorRoleId=NULL
    FROM IWA_Task, deleted
    WHERE IWA_Task.ActivatorRoleId = deleted.RoleId

    UPDATE IWA_Task    SET IWA_Task.ExpiryActivatorRoleId=NULL
    FROM IWA_Task, deleted
    WHERE IWA_Task.ExpiryActivatorRoleId = deleted.RoleId

    DELETE IWA_AccessControl FROM IWA_AccessControl, deleted
    WHERE IWA_AccessControl.RoleId = deleted.RoleId

    END
GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_UserDeleteTrigger
  ON IWA_User FOR DELETE AS

  UPDATE IWA_Task  SET IWA_Task.State=4, IWA_Task.WorkerUserName=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.WorkerUserId = deleted.UserId AND IWA_Task."State" = 8

  DELETE IWA_UserRole FROM IWA_UserRole, deleted
  WHERE IWA_UserRole.UserId = deleted.UserId

  DELETE IWA_UserProperty FROM IWA_UserProperty, deleted
  WHERE IWA_UserProperty.UserId = deleted.UserId

  DELETE IWA_UserAbsence FROM IWA_UserAbsence, deleted
  WHERE IWA_UserAbsence.UserId = deleted.UserId

  DELETE IWA_UserSubstitute FROM IWA_UserSubstitute, deleted
  WHERE IWA_UserSubstitute.UserId = deleted.UserId

  DELETE IWA_UserSubstitute FROM IWA_UserSubstitute, deleted
  WHERE IWA_UserSubstitute.SubstituteUserId = deleted.UserId

  UPDATE IWA_StartElement  SET IWA_StartElement.ActivatorUserId=NULL
  FROM IWA_StartElement, deleted
  WHERE IWA_StartElement.ActivatorUserId = deleted.UserId

  UPDATE IWA_Case  SET IWA_Case.CreatorUserId=NULL
  FROM IWA_Case, deleted
  WHERE IWA_Case.CreatorUserId = deleted.UserId

  UPDATE IWA_Case  SET IWA_Case.OwnerUserId=NULL
  FROM IWA_Case, deleted
  WHERE IWA_Case.OwnerUserId = deleted.UserId

  UPDATE IWA_Task  SET IWA_Task.WorkerUserId=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.WorkerUserId = deleted.UserId

  UPDATE IWA_Task  SET IWA_Task.ActivatorUserId=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.ActivatorUserId = deleted.UserId

  UPDATE IWA_Task  SET IWA_Task.ExpiryActivatorUserId=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.ExpiryActivatorUserId = deleted.UserId

  UPDATE IWA_WorkflowEvent  SET IWA_WorkflowEvent.UserId=NULL
  FROM IWA_WorkflowEvent, deleted
  WHERE IWA_WorkflowEvent.UserId = deleted.UserId

  UPDATE IWA_Note  SET IWA_Note.UserId=NULL
  FROM IWA_Note, deleted
  WHERE IWA_Note.UserId = deleted.UserId

  DELETE IWA_UserLocation FROM IWA_UserLocation, deleted
  WHERE IWA_UserLocation.UserId = deleted.UserId

  UPDATE IWA_SignalEvent  SET IWA_SignalEvent.SentByUserId=NULL
  FROM IWA_SignalEvent, deleted
  WHERE IWA_SignalEvent.SentByUserId = deleted.UserId

  UPDATE IWA_PageArchive  SET IWA_PageArchive.UserId=NULL
  FROM IWA_PageArchive, deleted
  WHERE IWA_PageArchive.UserId = deleted.UserId

  UPDATE IWA_SecurityDescriptor  SET IWA_SecurityDescriptor.OwnerUserId=NULL
  FROM IWA_SecurityDescriptor, deleted
  WHERE IWA_SecurityDescriptor.OwnerUserId = deleted.UserId

  DELETE IWA_AccessControl FROM IWA_AccessControl, deleted
  WHERE IWA_AccessControl.UserId = deleted.UserId


GO


-- Recreate views which has a new definition or depend on changed tables
CREATE VIEW IWA_TaskQuery
(
  TaskId,
  CaseId,
  BusinessCaseId,
  ProcessModelId,
  ApplicationId,
  StartTaskSwitchEventId,
  EndTaskSwitchEventId,
  TaskStartId,
  TaskEndId,
  WorkerUserId,
  WorkerUserName,
  WorkerUserDisplayName,
  WorkerSessionId,
  ActivatorRoleId,
  ActivatorUserId,
  ActivatorName,
  ActivatorDisplayName,
  ActivatorAvailable,
  ExpiryActivatorRoleId,
  ExpiryActivatorUserId,
  ExpiryActivatorName,
  ExpiryActivatorDisplayName,
  ExpiryPriority,
  ExpiryTimestamp,
  ExpiryTaskStartElementPid,
  IsExpired,
  ExpiredCreatorTaskId,
  TimeoutedCreatorIntrmdtEventId,
  DelayTimestamp,
  "State",
  RequestPath,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  Priority,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendar,
  WorkingTime,
  BusinessRuntime,
  FailedTimeoutTimestamp,
  NumberOfFailures,
  NumberOfResumes,
  Category,
  IsUpdatedOnStart,
  IsOffline,
  CurrentPriority,
  CurrentActivatorName,
  CurrentActivatorDisplayName,
  CurrentActivatorRoleId,
  CurrentActivatorUserId
)
AS
  SELECT
    IWA_Task.TaskId,
    IWA_Task.CaseId,
    IWA_Task.BusinessCaseId,
    IWA_Task.ProcessModelId,
    IWA_Task.ApplicationId,
    IWA_Task.StartTaskSwitchEventId,
    IWA_Task.EndTaskSwitchEventId,
    IWA_Task.TaskStartId,
    IWA_Task.TaskEndId,
    IWA_Task.WorkerUserId,
    IWA_Task.WorkerUserName,
    CASE WHEN WorkerUserId IS NOT NULL AND LEN(WorkerUser.FullName) > 0 THEN WorkerUser.FullName WHEN WorkerUserId IS NOT NULL THEN WorkerUser.Name ELSE NULL END,
    IWA_Task.WorkerSessionId,
    IWA_Task.ActivatorRoleId,
    IWA_Task.ActivatorUserId,
    IWA_Task.ActivatorName,
    CASE WHEN IWA_Task.ActivatorUserId IS NOT NULL AND LEN(ActivatorUser.FullName) > 0 THEN ActivatorUser.FullName WHEN IWA_Task.ActivatorUserId IS NOT NULL THEN ActivatorUser.Name WHEN IWA_Task.ActivatorRoleId IS NOT NULL AND LEN(ActivatorRole.DisplayNameTemplate) > 0 THEN ActivatorRole.DisplayNameTemplate WHEN IWA_Task.ActivatorRoleId IS NOT NULL THEN ActivatorRole.Name ELSE NULL END,
    CASE WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorRoleId IS NULL AND IWA_Task.ActivatorUserId IS NULL THEN 0 WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorUserId IS NOT NULL AND ActivatorUser."State" > 0 THEN 0 WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorRoleId IS NULL AND IWA_Task.ExpiryActivatorUserId IS NULL THEN 0 WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorUserId IS NOT NULL AND ExpiryActivatorUser."State" > 0 THEN 0 ELSE 1 END,
    IWA_Task.ExpiryActivatorRoleId,
    IWA_Task.ExpiryActivatorUserId,
    IWA_Task.ExpiryActivatorName,
    CASE WHEN IWA_Task.ExpiryActivatorUserId IS NOT NULL AND LEN(ExpiryActivatorUser.FullName) > 0 THEN ExpiryActivatorUser.FullName WHEN IWA_Task.ExpiryActivatorUserId IS NOT NULL THEN ExpiryActivatorUser.Name WHEN IWA_Task.ExpiryActivatorRoleId IS NOT NULL AND LEN(ExpiryActivatorRole.DisplayNameTemplate) > 0 THEN ExpiryActivatorRole.DisplayNameTemplate WHEN IWA_Task.ExpiryActivatorRoleId IS NOT NULL THEN ExpiryActivatorRole.Name ELSE NULL END,
    IWA_Task.ExpiryPriority,
    IWA_Task.ExpiryTimestamp,
    IWA_Task.ExpiryTaskStartElementPid,
    IWA_Task.IsExpired,
    IWA_Task.ExpiredCreatorTaskId,
    IWA_Task.TimeoutedCreatorIntrmdtEventId,
    IWA_Task.DelayTimestamp,
    IWA_Task."State",
    IWA_Task.RequestPath,
    IWA_Task.DisplayNameTemplate,
    IWA_Task.Name,
    IWA_Task.DisplayDescriptionTemplate,
    IWA_Task.Description,
    IWA_Task.Priority,
    IWA_Task.StartTimestamp,
    IWA_Task.EndTimestamp,
    IWA_Task.BusinessCalendar,
    IWA_Task.WorkingTime,
    IWA_Task.BusinessRuntime,
    IWA_Task.FailedTimeoutTimestamp,
    IWA_Task.NumberOfFailures,
    IWA_Task.NumberOfResumes,
    IWA_Task.Category,
    IWA_Task.IsUpdatedOnStart,
    IWA_Task.IsOffline,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryPriority WHEN 0 THEN IWA_Task.Priority END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorName WHEN 0 THEN IWA_Task.ActivatorName END,
    CASE WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorUserId IS NOT NULL AND LEN(ExpiryActivatorUser.FullName) > 0 THEN ExpiryActivatorUser.FullName WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorUserId IS NOT NULL THEN ExpiryActivatorUser.Name WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorRoleId IS NOT NULL AND LEN(ExpiryActivatorRole.DisplayNameTemplate) > 0 THEN ExpiryActivatorRole.DisplayNameTemplate WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorRoleId IS NOT NULL THEN ExpiryActivatorRole.Name WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorUserId IS NOT NULL AND LEN(ActivatorUser.FullName) > 0 THEN ActivatorUser.FullName WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorUserId IS NOT NULL THEN ActivatorUser.Name WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorRoleId IS NOT NULL AND LEN(ActivatorRole.DisplayNameTemplate) > 0 THEN ActivatorRole.DisplayNameTemplate WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorRoleId IS NOT NULL THEN ActivatorRole.Name ELSE NULL END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorRoleId WHEN 0 THEN IWA_Task.ActivatorRoleId END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorUserId WHEN 0 THEN IWA_Task.ActivatorUserId END
  FROM IWA_Task
    LEFT OUTER JOIN IWA_User AS ActivatorUser ON IWA_Task.ActivatorUserId = ActivatorUser.UserId
    LEFT OUTER JOIN IWA_Role AS ActivatorRole ON IWA_Task.ActivatorRoleId = ActivatorRole.RoleId
    LEFT OUTER JOIN IWA_User AS ExpiryActivatorUser ON IWA_Task.ExpiryActivatorUserId = ExpiryActivatorUser.UserId
    LEFT OUTER JOIN IWA_Role AS ExpiryActivatorRole ON IWA_Task.ExpiryActivatorRoleId = ExpiryActivatorRole.RoleId
    LEFT OUTER JOIN IWA_User AS WorkerUser ON IWA_Task.WorkerUserId = WorkerUser.UserId
GO


-- Drop temporary created stored procedures needed for conversion
DROP PROCEDURE IWA_Drop_Unique
GO

-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=67
GO
