-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 67 to version 68
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Oracle
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------

-- Drop views which has a new definition or depend on changed tables
DROP VIEW IWA_TaskQuery;

DROP VIEW IWA_CaseQuery;

DROP VIEW IWA_ProcessStart;


-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ApplicationDeleteTrg;

-- Drop trigger that has been deleted
DROP TRIGGER IWA_UserDeleteTrigger;

-- Create new added tables
CREATE TABLE IWA_SecurityMember
(
  SecurityMemberId VARCHAR2(210) NOT NULL,
  Name VARCHAR2(200) NOT NULL,
  MemberName VARCHAR2(201) NOT NULL,
  DisplayName VARCHAR2(200),
  ApplicationId NUMBER(20) NOT NULL,
  Enabled NUMBER(1) DEFAULT 0 NOT NULL,
  "TYPE" NUMBER(10) NOT NULL,
  PRIMARY KEY (SecurityMemberId)
)
TABLESPACE ${tablespaceName};

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_SecurityMemberNameIdx ON IWA_SecurityMember (Name) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_SecurityMemberMemberNameIdx ON IWA_SecurityMember (MemberName) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_SecurityMemberDisplayNameIdx ON IWA_SecurityMember (DisplayName) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_SecurityMemberEnabledIdx ON IWA_SecurityMember (Enabled) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_SecurityMemberTypeIdx ON IWA_SecurityMember ("TYPE") TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

-- Added columns of table IWA_Role
ALTER TABLE IWA_Role ADD
  SecurityMemberId VARCHAR2(210);

-- Added columns of table IWA_User
ALTER TABLE IWA_User ADD
  SecurityMemberId VARCHAR2(210);

-- Added columns of table IWA_Case
ALTER TABLE IWA_Case ADD
  CreatorId VARCHAR2(210);
ALTER TABLE IWA_Case ADD
  OwnerId VARCHAR2(210);

-- Added columns of table IWA_Task
ALTER TABLE IWA_Task ADD
  WorkerId VARCHAR2(210);
ALTER TABLE IWA_Task ADD
  ActivatorId VARCHAR2(210);
ALTER TABLE IWA_Task ADD
  OriginalActivatorId VARCHAR2(210);
ALTER TABLE IWA_Task ADD
  ExpiryActivatorId VARCHAR2(210);

-- Added columns of table IWA_SignalEvent
ALTER TABLE IWA_SignalEvent ADD SentById VARCHAR(210) NULL;

-- Migrate Priority
ALTER TABLE IWA_Task RENAME COLUMN Priority TO OriginalPriority;
ALTER TABLE IWA_Task ADD Priority NUMBER(10) NULL;
UPDATE IWA_Task SET Priority = CASE WHEN IsExpired = 1 THEN ExpiryPriority ELSE OriginalPriority END;
ALTER TABLE IWA_Task MODIFY Priority NUMBER(10) NOT NULL;

-- Migrate IWA_User
INSERT INTO IWA_SecurityMember (SecurityMemberId, Name, DisplayName, MemberName, ApplicationId, Enabled, Type)
  SELECT CONCAT('USER-', UserId), Name, FullName, CONCAT('#', Name), ApplicationId, 1, 1 FROM IWA_User;
UPDATE IWA_User SET SecurityMemberId = CONCAT('USER-', UserId);
ALTER TABLE IWA_User MODIFY SecurityMemberId VARCHAR2(210) NOT NULL;
ALTER TABLE IWA_User ADD FOREIGN KEY (SecurityMemberId) REFERENCES IWA_SecurityMember(SecurityMemberId);

-- Migrate IWA_Role
INSERT INTO IWA_SecurityMember (SecurityMemberId, Name, DisplayName, MemberName, ApplicationId, Enabled, Type)
  SELECT CONCAT('ROLE-', RoleId), Name, DisplayNameTemplate, Name, ApplicationId, 1, 0 FROM IWA_Role;
UPDATE IWA_Role SET SecurityMemberId = CONCAT('ROLE-', RoleId);
ALTER TABLE IWA_Role MODIFY SecurityMemberId VARCHAR2(210) NOT NULL;
ALTER TABLE IWA_Role ADD FOREIGN KEY (SecurityMemberId) REFERENCES IWA_SecurityMember(SecurityMemberId);

-- Migrate IWA_Case.CreatorId
UPDATE IWA_Case SET CreatorId = CASE
   WHEN CreatorUserId IS NOT NULL THEN CONCAT('USER-', CreatorUserId)
   WHEN CreatorUserName IS NOT NULL THEN 'USER-' || ApplicationId || '-' || CreatorUserName
   ELSE NULL
  END;
INSERT INTO IWA_SecurityMember (SecurityMemberId, Name, DisplayName, MemberName, ApplicationId, Enabled, Type)
  SELECT DISTINCT
    CreatorId,
    CASE WHEN CreatorUserName IS NOT NULL THEN CreatorUserName ELSE CreatorId END,
    CASE WHEN CreatorUserName IS NOT NULL THEN CreatorUserName ELSE CreatorId END,
    CONCAT('#', CASE WHEN CreatorUserName IS NOT NULL THEN CreatorUserName ELSE CreatorId END),
    ApplicationId,
    0,
    1
  FROM IWA_Case
  WHERE IWA_Case.CreatorId IS NOT NULL AND
        IWA_Case.CreatorId NOT IN (SELECT SecurityMemberId FROM IWA_SecurityMember);
ALTER TABLE IWA_Case ADD FOREIGN KEY (CreatorId) REFERENCES IWA_SecurityMember(SecurityMemberId);

-- Migrate IWA_Case.OwnerId
UPDATE IWA_Case SET OwnerName = NULL WHERE OwnerName = '#';

UPDATE IWA_Case SET OwnerId = CASE
   WHEN OwnerRoleId IS NOT NULL THEN CONCAT('ROLE-', OwnerRoleId)
   WHEN OwnerUserId IS NOT NULL THEN CONCAT('USER-', OwnerUserId)
   WHEN OwnerName LIKE '#%' THEN 'USER-' || ApplicationId || '-' || SUBSTR(OwnerName, 2)
   WHEN OwnerName IS NOT NULL THEN 'ROLE-' || ApplicationId || '-' || OwnerName
   ELSE NULL
  END;
INSERT INTO IWA_SecurityMember (SecurityMemberId, Name, DisplayName, MemberName, ApplicationId, Enabled, Type)
  SELECT DISTINCT
    OwnerId,
    CASE
      WHEN OwnerName LIKE '#%' THEN SUBSTR(OwnerName, 2)
      WHEN OwnerName IS NOT NULL THEN OwnerName
      ELSE OwnerId
    END,
    CASE
      WHEN OwnerName LIKE '#%' THEN SUBSTR(OwnerName, 2)
      WHEN OwnerName IS NOT NULL THEN OwnerName
      ELSE OwnerId
    END,
    CASE
      WHEN OwnerName IS NOT NULL THEN OwnerName
      WHEN OwnerId LIKE 'USER-%' THEN CONCAT('#', OwnerId)
      ELSE OwnerId
    END,
    ApplicationId,
    0,
    CASE WHEN OwnerId LIKE 'USER-%' THEN 1 ELSE 0 END
  FROM IWA_Case
  WHERE IWA_Case.OwnerId IS NOT NULL AND
        IWA_Case.OwnerId NOT IN (SELECT SecurityMemberId FROM IWA_SecurityMember);
ALTER TABLE IWA_Case ADD FOREIGN KEY (OwnerId) REFERENCES IWA_SecurityMember(SecurityMemberId);

-- Migrate IWA_Task.WorkerId
UPDATE IWA_Task SET WorkerId = CASE
   WHEN WorkerUserId IS NOT NULL THEN CONCAT('USER-', WorkerUserId)
   WHEN WorkerUserName IS NOT NULL THEN 'USER-' || ApplicationId || '-' || WorkerUserName
   ELSE NULL
  END;
INSERT INTO IWA_SecurityMember (SecurityMemberId, Name, DisplayName, MemberName, ApplicationId, Enabled, Type)
  SELECT DISTINCT
    WorkerId,
    CASE WHEN WorkerUserName IS NOT NULL THEN WorkerUserName ELSE WorkerId END,
    CASE WHEN WorkerUserName IS NOT NULL THEN WorkerUserName ELSE WorkerId END,
    CONCAT('#', CASE WHEN WorkerUserName IS NOT NULL THEN WorkerUserName ELSE WorkerId END),
    ApplicationId,
    0,
    1
  FROM IWA_Task
  WHERE IWA_Task.WorkerId IS NOT NULL AND
        IWA_Task.WorkerId NOT IN (SELECT SecurityMemberId FROM IWA_SecurityMember);
ALTER TABLE IWA_Task ADD FOREIGN KEY (WorkerId) REFERENCES IWA_SecurityMember(SecurityMemberId);

-- Migrate IWA_Task.OriginalActivatorId
UPDATE IWA_Task SET ActivatorName = NULL WHERE ActivatorName = '#';

UPDATE IWA_Task SET OriginalActivatorId =
  CASE
   WHEN ActivatorUserId IS NOT NULL THEN CONCAT('USER-', ActivatorUserId)
   WHEN ActivatorRoleId IS NOT NULL THEN CONCAT('ROLE-', ActivatorRoleId)
   WHEN ActivatorName LIKE '#%' THEN 'USER-' || ApplicationId || '-' || SUBSTR(ActivatorName, 2)
   WHEN ActivatorName IS NOT NULL THEN 'ROLE-' || ApplicationId || '-' || ActivatorName
   ELSE NULL
  END;
INSERT INTO IWA_SecurityMember (SecurityMemberId, Name, DisplayName, MemberName, ApplicationId, Enabled, Type)
  SELECT DISTINCT
    OriginalActivatorId,
    CASE
      WHEN ActivatorName LIKE '#%' THEN SUBSTR(ActivatorName, 2)
      WHEN ActivatorName IS NOT NULL THEN ActivatorName
      ELSE OriginalActivatorId
    END,
    CASE
      WHEN ActivatorName LIKE '#%' THEN SUBSTR(ActivatorName, 2)
      WHEN ActivatorName IS NOT NULL THEN ActivatorName
      ELSE OriginalActivatorId
    END,
    CASE
      WHEN ActivatorName IS NOT NULL THEN ActivatorName
      WHEN OriginalActivatorId LIKE 'USER-%' THEN CONCAT('#', OriginalActivatorId)
      ELSE OriginalActivatorId
    END,
    ApplicationId,
    0,
    CASE WHEN OriginalActivatorId LIKE 'USER-%' THEN 1 ELSE 0 END
  FROM IWA_Task
  WHERE IWA_Task.OriginalActivatorId IS NOT NULL AND
        IWA_Task.OriginalActivatorId NOT IN (SELECT SecurityMemberId FROM IWA_SecurityMember);
ALTER TABLE IWA_Task ADD FOREIGN KEY (OriginalActivatorId) REFERENCES IWA_SecurityMember(SecurityMemberId);

-- Migrate IWA_Task.ExpiryActivatorId
UPDATE IWA_Task SET ExpiryActivatorName = NULL WHERE ExpiryActivatorName = '#';

UPDATE IWA_Task SET ExpiryActivatorId =
  CASE
   WHEN ExpiryActivatorUserId IS NOT NULL THEN CONCAT('USER-', ExpiryActivatorUserId)
   WHEN ExpiryActivatorRoleId IS NOT NULL THEN CONCAT('ROLE-', ExpiryActivatorRoleId)
   WHEN ExpiryActivatorName LIKE '#%' THEN 'USER-' || ApplicationId || '-' || SUBSTR(ExpiryActivatorName, 2)
   WHEN ExpiryActivatorName IS NOT NULL THEN 'ROLE-' || ApplicationId || '-' || ExpiryActivatorName
   ELSE NULL
  END;
INSERT INTO IWA_SecurityMember (SecurityMemberId, Name, DisplayName, MemberName, ApplicationId, Enabled, Type)
  SELECT DISTINCT
    ExpiryActivatorId,
    CASE
      WHEN ExpiryActivatorName LIKE '#%' THEN SUBSTR(ExpiryActivatorName, 2)
      WHEN ExpiryActivatorName IS NOT NULL THEN ExpiryActivatorName
      ELSE ExpiryActivatorId
    END,
    CASE
      WHEN ExpiryActivatorName LIKE '#%' THEN SUBSTR(ExpiryActivatorName, 2)
      WHEN ExpiryActivatorName IS NOT NULL THEN ExpiryActivatorName
      ELSE ExpiryActivatorId
    END,
    CASE
      WHEN ExpiryActivatorName IS NOT NULL THEN ExpiryActivatorName
      WHEN ExpiryActivatorId LIKE 'USER-%' THEN CONCAT('#', ExpiryActivatorId)
      ELSE ExpiryActivatorId
    END,
    ApplicationId,
    0,
    CASE WHEN ExpiryActivatorId LIKE 'USER-%' THEN 1 ELSE 0 END
  FROM IWA_Task
  WHERE IWA_Task.ExpiryActivatorId IS NOT NULL AND
        IWA_Task.ExpiryActivatorId NOT IN (SELECT SecurityMemberId FROM IWA_SecurityMember);
ALTER TABLE IWA_Task ADD FOREIGN KEY (ExpiryActivatorId) REFERENCES IWA_SecurityMember(SecurityMemberId);

-- Migrate IWA_Task.ActivatorId (CurrentActivator)
UPDATE IWA_Task SET ActivatorId = CASE WHEN IsExpired = 1 THEN ExpiryActivatorId ELSE OriginalActivatorId END;
ALTER TABLE IWA_Task ADD FOREIGN KEY (ActivatorId) REFERENCES IWA_SecurityMember(SecurityMemberId);

-- Migrate StartElement
ALTER TABLE IWA_StartElement ADD ActivatorId VARCHAR(210) REFERENCES IWA_SecurityMember(SecurityMemberId);
UPDATE IWA_StartElement SET ActivatorId =
  CASE
   WHEN ActivatorRoleId IS NOT NULL THEN CONCAT('ROLE-', ActivatorRoleId)
   WHEN ActivatorUserId IS NOT NULL THEN CONCAT('USER-', ActivatorUserId)
   ELSE NULL
  END;

-- Migrate StartEventElement
ALTER TABLE IWA_StartEventElement ADD ActivatorId VARCHAR(210) REFERENCES IWA_SecurityMember(SecurityMemberId);
UPDATE IWA_StartEventElement SET ActivatorId =
  CASE
   WHEN ActivatorRoleId IS NOT NULL THEN CONCAT('ROLE-', ActivatorRoleId)
   ELSE NULL
  END;

-- Migrate WebServiceProcStartElement
ALTER TABLE IWA_WebServiceProcStartElement ADD ActivatorId VARCHAR(210) REFERENCES IWA_SecurityMember(SecurityMemberId);
UPDATE IWA_WebServiceProcStartElement SET ActivatorId =
  CASE
   WHEN ActivatorRoleId IS NOT NULL THEN CONCAT('ROLE-', ActivatorRoleId)
   ELSE NULL
  END;

-- Migrate IWA_WorkflowEvent.UserId
DROP INDEX IWA_WorkflowEvent_UserIdIdx;
ALTER TABLE IWA_WorkflowEvent RENAME COLUMN UserId TO WorkerUserId;
ALTER TABLE IWA_WorkflowEvent ADD UserId VARCHAR(210);
UPDATE IWA_WorkflowEvent SET UserId = CASE
   WHEN WorkerUserId IS NOT NULL THEN CONCAT('USER-', WorkerUserId)
   WHEN UserName IS NOT NULL AND UserName NOT LIKE ('Unknown User (Session %') THEN 'USER-' || ApplicationId || '-' || UserName
   ELSE NULL
  END;
INSERT INTO IWA_SecurityMember (SecurityMemberId, Name, DisplayName, MemberName, ApplicationId, Enabled, Type)
  SELECT DISTINCT
    UserId,
    CASE WHEN UserName IS NOT NULL THEN UserName ELSE UserId END,
    CASE WHEN UserName IS NOT NULL THEN UserName ELSE UserId END,
    CONCAT('#', CASE WHEN UserName IS NOT NULL THEN UserName ELSE UserId END),
    ApplicationId,
    0,
    1
  FROM IWA_WorkflowEvent
  WHERE IWA_WorkflowEvent.UserId IS NOT NULL AND
        IWA_WorkflowEvent.UserId NOT IN (SELECT SecurityMemberId FROM IWA_SecurityMember);
ALTER TABLE IWA_WorkflowEvent ADD FOREIGN KEY (UserId) REFERENCES IWA_SecurityMember(SecurityMemberId);

-- Migrate IWA_SignalEvent.SentById
UPDATE IWA_SignalEvent SET SentById = CASE
   WHEN SentByUserId IS NOT NULL THEN CONCAT('USER-', SentByUserId)
   WHEN SentByUserName IS NOT NULL THEN 'USER-' || ApplicationId || '-' || SentByUserName
   ELSE NULL
  END;
INSERT INTO IWA_SecurityMember (SecurityMemberId, Name, DisplayName, MemberName, ApplicationId, Enabled, Type)
  SELECT DISTINCT
    SentById,
    CASE WHEN SentByUserName IS NOT NULL THEN SentByUserName ELSE SentById END,
    CASE WHEN SentByUserName IS NOT NULL THEN SentByUserName ELSE SentById END,
    CONCAT('#', CASE WHEN SentByUserName IS NOT NULL THEN SentByUserName ELSE SentById END),
    ApplicationId,
    0,
    1
  FROM IWA_SignalEvent
  WHERE IWA_SignalEvent.SentById IS NOT NULL AND
        IWA_SignalEvent.SentById NOT IN (SELECT SecurityMemberId FROM IWA_SecurityMember);

ALTER TABLE IWA_SignalEvent ADD FOREIGN KEY (SentById) REFERENCES IWA_SecurityMember(SecurityMemberId);


DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_SignalEvent_SentById ON IWA_SignalEvent (SentById) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ApplicationDeleteTrg
AFTER DELETE ON IWA_Application
FOR EACH ROW
BEGIN
  DELETE IWA_SignalEvent
  WHERE IWA_SignalEvent.ApplicationId = :old.ApplicationId;

  DELETE IWA_Role
  WHERE IWA_Role.ApplicationId = :old.ApplicationId;

  DELETE IWA_Library
  WHERE IWA_Library.ApplicationId = :old.ApplicationId;

  DELETE IWA_ContentManagementSystem
  WHERE IWA_ContentManagementSystem.ApplicationId = :old.ApplicationId;

  DELETE IWA_User
  WHERE IWA_User.ApplicationId = :old.ApplicationId;

  DELETE IWA_ProcessModel
  WHERE IWA_ProcessModel.ApplicationId = :old.ApplicationId;

  DELETE IWA_SecurityMember
  WHERE IWA_SecurityMember.ApplicationId = :old.ApplicationId;

  DELETE IWA_SecurityDescriptor
  WHERE IWA_SecurityDescriptor.SecurityDescriptorId = :old.SecurityDescriptorId;

END;
;


-- Create new indexes of table IWA_Role
DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_Role_SecurityMemberIdIndex ON IWA_Role (SecurityMemberId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

-- Create new indexes of table IWA_User
DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_User_SecurityMemberIdIndex ON IWA_User (SecurityMemberId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

-- Create new indexes of table IWA_StartElement
DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_StartElement_ActivatorIdIndex ON IWA_StartElement (ActivatorId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

-- Create new indexes of table IWA_StartEventElement
DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_StartEventElement_ActivatorIdIndex ON IWA_StartEventElement (ActivatorId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

-- Create new indexes of table IWA_WebServiceProcStartElement
DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_WebServiceProcStartElement_ActivatorIdIndex ON IWA_WebServiceProcStartElement (ActivatorId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

-- Create new indexes of table IWA_Case
DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_Case_CreatorIdIndex ON IWA_Case (CreatorId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_Case_OwnerIdIndex ON IWA_Case (OwnerId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

-- Create new indexes of table IWA_Task
DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_Task_WorkerIdIndex ON IWA_Task (WorkerId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_Task_ActivatorIdIndex ON IWA_Task (ActivatorId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_Task_OriginalActivatorIdIndex ON IWA_Task (OriginalActivatorId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_Task_ExpiryActivatorIdIndex ON IWA_Task (ExpiryActivatorId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

-- Create new indexes of table IWA_WorkflowEvent
DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_WorkflowEvent_UserIdIndex ON IWA_WorkflowEvent (UserId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

-- Recreate views which has a new definition or depend on changed tables
CREATE VIEW IWA_TaskQuery
(
  TaskId,
  CaseId,
  BusinessCaseId,
  ProcessModelId,
  ApplicationId,
  StartTaskSwitchEventId,
  EndTaskSwitchEventId,
  TaskStartId,
  TaskEndId,
  WorkerId,
  WorkerUserId,
  WorkerUserName,
  WorkerUserDisplayName,
  WorkerSessionId,
  ActivatorId,
  OriginalActivatorId,
  ActivatorRoleId,
  ActivatorUserId,
  ActivatorName,
  ActivatorDisplayName,
  ActivatorAvailable,
  ExpiryActivatorId,
  ExpiryActivatorRoleId,
  ExpiryActivatorUserId,
  ExpiryActivatorName,
  ExpiryActivatorDisplayName,
  ExpiryPriority,
  ExpiryTimestamp,
  ExpiryTaskStartElementPid,
  IsExpired,
  ExpiredCreatorTaskId,
  TimeoutedCreatorIntrmdtEventId,
  DelayTimestamp,
  State,
  RequestPath,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  Priority,
  OriginalPriority,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendar,
  WorkingTime,
  BusinessRuntime,
  FailedTimeoutTimestamp,
  NumberOfFailures,
  NumberOfResumes,
  Category,
  IsUpdatedOnStart,
  IsOffline,
  CurrentActivatorName,
  CurrentActivatorDisplayName,
  CurrentActivatorRoleId,
  CurrentActivatorUserId
)
AS
  SELECT
    IWA_Task.TaskId,
    IWA_Task.CaseId,
    IWA_Task.BusinessCaseId,
    IWA_Task.ProcessModelId,
    IWA_Task.ApplicationId,
    IWA_Task.StartTaskSwitchEventId,
    IWA_Task.EndTaskSwitchEventId,
    IWA_Task.TaskStartId,
    IWA_Task.TaskEndId,
    IWA_Task.WorkerId,
    IWA_Task.WorkerUserId,
    WorkerUser.Name,
    WorkerUser.DisplayName,
    IWA_Task.WorkerSessionId,
    IWA_Task.ActivatorId,
    IWA_Task.OriginalActivatorId,
    IWA_Task.ActivatorRoleId,
    IWA_Task.ActivatorUserId,
    OriginalActivator.MemberName,
    OriginalActivator.DisplayName,
    CurrentActivator.Enabled,
    IWA_Task.ExpiryActivatorId,
    IWA_Task.ExpiryActivatorRoleId,
    IWA_Task.ExpiryActivatorUserId,
    ExpiryActivator.MemberName,
    ExpiryActivator.DisplayName,
    IWA_Task.ExpiryPriority,
    IWA_Task.ExpiryTimestamp,
    IWA_Task.ExpiryTaskStartElementPid,
    IWA_Task.IsExpired,
    IWA_Task.ExpiredCreatorTaskId,
    IWA_Task.TimeoutedCreatorIntrmdtEventId,
    IWA_Task.DelayTimestamp,
    IWA_Task.State,
    IWA_Task.RequestPath,
    IWA_Task.DisplayNameTemplate,
    IWA_Task.Name,
    IWA_Task.DisplayDescriptionTemplate,
    IWA_Task.Description,
    IWA_Task.Priority,
    IWA_Task.OriginalPriority,
    IWA_Task.StartTimestamp,
    IWA_Task.EndTimestamp,
    IWA_Task.BusinessCalendar,
    IWA_Task.WorkingTime,
    IWA_Task.BusinessRuntime,
    IWA_Task.FailedTimeoutTimestamp,
    IWA_Task.NumberOfFailures,
    IWA_Task.NumberOfResumes,
    IWA_Task.Category,
    IWA_Task.IsUpdatedOnStart,
    IWA_Task.IsOffline,
    CurrentActivator.MemberName,
    CurrentActivator.DisplayName,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorRoleId WHEN 0 THEN IWA_Task.ActivatorRoleId END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorUserId WHEN 0 THEN IWA_Task.ActivatorUserId END
  FROM IWA_Task
    LEFT OUTER JOIN IWA_SecurityMember CurrentActivator ON IWA_Task.ActivatorId = CurrentActivator.SecurityMemberId
    LEFT OUTER JOIN IWA_SecurityMember OriginalActivator ON IWA_Task.OriginalActivatorId = OriginalActivator.SecurityMemberId
    LEFT OUTER JOIN IWA_SecurityMember ExpiryActivator ON IWA_Task.ExpiryActivatorId = ExpiryActivator.SecurityMemberId
    LEFT OUTER JOIN IWA_SecurityMember WorkerUser ON IWA_Task.WorkerId = WorkerUser.SecurityMemberId;

CREATE VIEW IWA_CaseQuery
(
  CaseId,
  BusinessCaseId,
  Kind,
  ApplicationId,
  ProcessModelId,
  TaskStartId,
  CreatorId,
  CreatorUserId,
  CreatorUserName,
  CreatorUserDisplayName,
  CreatorTaskId,
  EnvironmentId,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendar,
  WorkingTime,
  BusinessRuntime,
  State,
  Priority,
  Stage,
  OwnerId,
  OwnerRoleId,
  OwnerUserId,
  OwnerName,
  Category
)
AS
  SELECT
    IWA_Case.CaseId,
    IWA_Case.BusinessCaseId,
    IWA_Case.Kind,
    IWA_Case.ApplicationId,
    IWA_Case.ProcessModelId,
    IWA_Case.TaskStartId,
    IWA_Case.CreatorId,
    IWA_Case.CreatorUserId,
    Creator.Name,
    Creator.DisplayName,
    IWA_Case.CreatorTaskId,
    IWA_Case.EnvironmentId,
    IWA_Case.DisplayNameTemplate,
    IWA_Case.Name,
    IWA_Case.DisplayDescriptionTemplate,
    IWA_Case.Description,
    IWA_Case.StartTimestamp,
    IWA_Case.EndTimestamp,
    IWA_Case.BusinessCalendar,
    IWA_Case.WorkingTime,
    IWA_Case.BusinessRuntime,
    IWA_Case.State,
    IWA_Case.Priority,
    IWA_Case.Stage,
    IWA_Case.OwnerId,
    IWA_Case.OwnerRoleId,
    IWA_Case.OwnerUserId,
    Owner.MemberName,
    IWA_Case.Category
  FROM IWA_Case
    LEFT OUTER JOIN IWA_SecurityMember Creator ON IWA_Case.CreatorId = Creator.SecurityMemberId
    LEFT OUTER JOIN IWA_SecurityMember Owner ON IWA_Case.OwnerId = Owner.SecurityMemberId;

CREATE VIEW IWA_ProcessStart
(
  TaskElementId,
  ProcessModelVersionId,
  Name,
  Description,
  ProcessElementId,
  TaskStartId,
  StartRequestPath,
  UserFriendlyStartRequestPath,
  ActivatorId
)
AS
  SELECT
    IWA_TaskElement.TaskElementId,
    IWA_TaskElement.ProcessModelVersionId,
    IWA_TaskElement.Name,
    IWA_TaskElement.Description,
    IWA_TaskElement.ProcessElementId,
    IWA_TaskStart.TaskStartId,
    IWA_TaskStart.StartRequestPath,
    IWA_TaskStart.UserFriendlyStartRequestPath,
    IWA_StartElement.ActivatorId
  FROM IWA_TaskElement,
    IWA_TaskStart,
    IWA_StartElement
  WHERE IWA_TaskElement.TaskElementId = IWA_TaskStart.TaskElementId AND IWA_TaskStart.TaskStartId = IWA_StartElement.TaskStartId
UNION ALL
  SELECT
    IWA_TaskElement.TaskElementId,
    IWA_TaskElement.ProcessModelVersionId,
    IWA_TaskElement.Name,
    IWA_TaskElement.Description,
    IWA_TaskElement.ProcessElementId,
    IWA_TaskStart.TaskStartId,
    IWA_TaskStart.StartRequestPath,
    IWA_TaskStart.UserFriendlyStartRequestPath,
    IWA_StartEventElement.ActivatorId
  FROM IWA_TaskElement,
    IWA_TaskStart,
    IWA_StartEventElement
  WHERE IWA_TaskElement.TaskElementId = IWA_TaskStart.TaskElementId AND IWA_TaskStart.TaskStartId = IWA_StartEventElement.TaskStartId
UNION ALL
  SELECT
    IWA_TaskElement.TaskElementId,
    IWA_TaskElement.ProcessModelVersionId,
    IWA_TaskElement.Name,
    IWA_TaskElement.Description,
    IWA_TaskElement.ProcessElementId,
    IWA_TaskStart.TaskStartId,
    IWA_TaskStart.StartRequestPath,
    IWA_TaskStart.UserFriendlyStartRequestPath,
    IWA_WebServiceProcStartElement.ActivatorId
  FROM IWA_TaskElement,
    IWA_TaskStart,
    IWA_WebServiceProcStartElement
  WHERE IWA_TaskElement.TaskElementId = IWA_TaskStart.TaskElementId AND IWA_TaskStart.TaskStartId = IWA_WebServiceProcStartElement.TaskStartId;

CREATE VIEW IWA_SignalEventQuery
(
  SignalEventId,
  ApplicationId,
  SignalCode,
  SentTimestamp,
  SentById,
  SentByUserName,
  SentByUserId,
  SentByTaskId,
  SentByProcessElementPid
)
AS
  SELECT
    IWA_SignalEvent.SignalEventId,
    IWA_SignalEvent.ApplicationId,
    IWA_SignalEvent.SignalCode,
    IWA_SignalEvent.SentTimestamp,
    IWA_SignalEvent.SentById,
    IWA_SecurityMember.Name,
    IWA_User.UserId,
    IWA_SignalEvent.SentByTaskId,
    IWA_SignalEvent.SentByProcessElementPid
  FROM IWA_SignalEvent
    LEFT OUTER JOIN IWA_SecurityMember ON IWA_SignalEvent.SentById = IWA_SecurityMember.SecurityMemberId
    LEFT OUTER JOIN IWA_User ON IWA_SecurityMember.SecurityMemberId = IWA_User.SecurityMemberId;


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=68;
