-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 67 to version 68
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Postgre SQL
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------

-- Drop views which has a new definition or depend on changed tables
DROP VIEW IWA_TaskQuery;

DROP VIEW IWA_CaseQuery;

DROP VIEW IWA_ProcessStart;


-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_UserDeleteTrigger ON IWA_User;

-- Create new added tables
CREATE TABLE IWA_SecurityMember
(
  SecurityMemberId VARCHAR(210) NOT NULL,
  Name VARCHAR(200) NOT NULL,
  MemberName VARCHAR(201) NOT NULL,
  DisplayName VARCHAR(200),
  ApplicationId BIGINT NOT NULL REFERENCES IWA_Application(ApplicationId) ON DELETE CASCADE,
  Enabled DECIMAL(1) NOT NULL DEFAULT 0,
  "Type" INTEGER NOT NULL,
  PRIMARY KEY (SecurityMemberId)
);

CREATE INDEX IF NOT EXISTS IWA_SecurityMemberNameIdx
ON IWA_SecurityMember (Name varchar_pattern_ops);

CREATE INDEX IF NOT EXISTS IWA_SecurityMemberMemberNameIdx
ON IWA_SecurityMember (MemberName varchar_pattern_ops);

CREATE INDEX IF NOT EXISTS IWA_SecurityMemberDisplayNameIdx
ON IWA_SecurityMember (DisplayName varchar_pattern_ops);

CREATE INDEX IF NOT EXISTS IWA_SecurityMemberEnabledIdx
ON IWA_SecurityMember (Enabled);

CREATE INDEX IF NOT EXISTS IWA_SecurityMemberTypeIdx
ON IWA_SecurityMember ("Type");


-- Added columns of table IWA_Role
ALTER TABLE IWA_Role ADD COLUMN
  SecurityMemberId VARCHAR(210) REFERENCES IWA_SecurityMember(SecurityMemberId);

-- Added columns of table IWA_User
ALTER TABLE IWA_User ADD COLUMN
  SecurityMemberId VARCHAR(210) REFERENCES IWA_SecurityMember(SecurityMemberId);

-- Added columns of table IWA_Case
ALTER TABLE IWA_Case ADD COLUMN
  CreatorId VARCHAR(210);
ALTER TABLE IWA_Case ADD COLUMN
  OwnerId VARCHAR(210);

-- Added columns of table IWA_Task
ALTER TABLE IWA_Task ADD COLUMN
  WorkerId VARCHAR(210);
ALTER TABLE IWA_Task ADD COLUMN
  ActivatorId VARCHAR(210);
ALTER TABLE IWA_Task ADD COLUMN
  OriginalActivatorId VARCHAR(210);
ALTER TABLE IWA_Task ADD COLUMN
  ExpiryActivatorId VARCHAR(210);

-- Added columns of table IWA_SignalEvent
ALTER TABLE IWA_SignalEvent ADD COLUMN SentById VARCHAR(210) NULL;

-- Migrate Priority
ALTER TABLE IWA_Task RENAME COLUMN Priority TO OriginalPriority;
ALTER TABLE IWA_Task ADD COLUMN Priority INTEGER NULL;
UPDATE IWA_Task SET Priority = CASE WHEN IsExpired = 1 THEN ExpiryPriority ELSE OriginalPriority END;
ALTER TABLE IWA_Task ALTER COLUMN Priority SET NOT NULL;

-- Migrate IWA_User
INSERT INTO IWA_SecurityMember (SecurityMemberId, Name, DisplayName, MemberName, ApplicationId, Enabled, "Type")
  SELECT CONCAT('USER-', UserId), Name, FullName, CONCAT('#', Name), ApplicationId, 1, 1 FROM IWA_User;
UPDATE IWA_User SET SecurityMemberId = CONCAT('USER-', UserId);
ALTER TABLE IWA_User ALTER COLUMN SecurityMemberId SET NOT NULL;

-- Migrate IWA_Role
INSERT INTO IWA_SecurityMember (SecurityMemberId, Name, DisplayName, MemberName, ApplicationId, Enabled, "Type")
  SELECT CONCAT('ROLE-', RoleId), Name, DisplayNameTemplate, Name, ApplicationId, 1, 0 FROM IWA_Role;
UPDATE IWA_Role SET SecurityMemberId = CONCAT('ROLE-', RoleId);
ALTER TABLE IWA_Role ALTER COLUMN SecurityMemberId SET NOT NULL;

-- Migrate IWA_Case.CreatorId
UPDATE IWA_Case SET CreatorId = CASE
   WHEN CreatorUserId IS NOT NULL THEN CONCAT('USER-', CreatorUserId)
   WHEN CreatorUserName IS NOT NULL THEN CONCAT('USER-', ApplicationId, '-', CreatorUserName)
   ELSE NULL
  END;
INSERT INTO IWA_SecurityMember (SecurityMemberId, Name, DisplayName, MemberName, ApplicationId, Enabled, "Type")
  SELECT DISTINCT
    CreatorId,
    CASE WHEN CreatorUserName IS NOT NULL THEN CreatorUserName ELSE CreatorId END,
    CASE WHEN CreatorUserName IS NOT NULL THEN CreatorUserName ELSE CreatorId END,
    CONCAT('#', CASE WHEN CreatorUserName IS NOT NULL THEN CreatorUserName ELSE CreatorId END),
    ApplicationId,
    0,
    1
  FROM IWA_Case
  WHERE IWA_Case.CreatorId IS NOT NULL AND
        IWA_Case.CreatorId NOT IN (SELECT SecurityMemberId FROM IWA_SecurityMember);
ALTER TABLE IWA_Case ADD FOREIGN KEY (CreatorId) REFERENCES IWA_SecurityMember(SecurityMemberId);

-- Migrate IWA_Case.OwnerId
UPDATE IWA_Case SET OwnerName = NULL WHERE OwnerName = '#';

UPDATE IWA_Case SET OwnerId = CASE
	 WHEN OwnerRoleId IS NOT NULL THEN CONCAT('ROLE-', OwnerRoleId)
	 WHEN OwnerUserId IS NOT NULL THEN CONCAT('USER-', OwnerUserId)
	 WHEN OwnerName LIKE '#%' THEN CONCAT('USER-', ApplicationId, '-', SUBSTRING(OwnerName, 2))
   WHEN OwnerName IS NOT NULL THEN CONCAT('ROLE-', ApplicationId, '-', OwnerName)
	 ELSE NULL
	END;
INSERT INTO IWA_SecurityMember (SecurityMemberId, Name, DisplayName, MemberName, ApplicationId, Enabled, "Type")
  SELECT DISTINCT
    OwnerId,
    CASE
      WHEN OwnerName LIKE '#%' THEN SUBSTRING(OwnerName, 2)
      WHEN OwnerName IS NOT NULL THEN OwnerName
      ELSE OwnerId
    END,
    CASE
      WHEN OwnerName LIKE '#%' THEN SUBSTRING(OwnerName, 2)
      WHEN OwnerName IS NOT NULL THEN OwnerName
      ELSE OwnerId
    END,
    CASE
      WHEN OwnerName IS NOT NULL THEN OwnerName
      WHEN OwnerId LIKE 'USER-%' THEN CONCAT('#', OwnerId)
      ELSE OwnerId
    END,
    ApplicationId,
    0,
    CASE WHEN OwnerId LIKE 'USER-%' THEN 1 ELSE 0 END
  FROM IWA_Case
  WHERE IWA_Case.OwnerId IS NOT NULL AND
        IWA_Case.OwnerId NOT IN (SELECT SecurityMemberId FROM IWA_SecurityMember);
ALTER TABLE IWA_Case ADD FOREIGN KEY (OwnerId) REFERENCES IWA_SecurityMember(SecurityMemberId);

-- Migrate IWA_Task.WorkerId
UPDATE IWA_Task SET WorkerId = CASE
	 WHEN WorkerUserId IS NOT NULL THEN CONCAT('USER-', WorkerUserId)
	 WHEN WorkerUserName IS NOT NULL THEN CONCAT('USER-', ApplicationId, '-', WorkerUserName)
	 ELSE NULL
	END;
INSERT INTO IWA_SecurityMember (SecurityMemberId, Name, DisplayName, MemberName, ApplicationId, Enabled, "Type")
  SELECT DISTINCT
    WorkerId,
    CASE WHEN WorkerUserName IS NOT NULL THEN WorkerUserName ELSE WorkerId END,
    CASE WHEN WorkerUserName IS NOT NULL THEN WorkerUserName ELSE WorkerId END,
    CONCAT('#', CASE WHEN WorkerUserName IS NOT NULL THEN WorkerUserName ELSE WorkerId END),
    ApplicationId,
    0,
    1
  FROM IWA_Task
  WHERE IWA_Task.WorkerId IS NOT NULL AND
        IWA_Task.WorkerId NOT IN (SELECT SecurityMemberId FROM IWA_SecurityMember);
ALTER TABLE IWA_Task ADD FOREIGN KEY (WorkerId) REFERENCES IWA_SecurityMember(SecurityMemberId);

-- Migrate IWA_Task.OriginalActivatorId
UPDATE IWA_Task SET ActivatorName = NULL WHERE ActivatorName = '#';

UPDATE IWA_Task SET OriginalActivatorId =
  CASE
   WHEN ActivatorUserId IS NOT NULL THEN CONCAT('USER-', ActivatorUserId)
   WHEN ActivatorRoleId IS NOT NULL THEN CONCAT('ROLE-', ActivatorRoleId)
   WHEN ActivatorName LIKE '#%' THEN CONCAT('USER-', ApplicationId, '-', SUBSTRING(ActivatorName, 2))
   WHEN ActivatorName IS NOT NULL THEN CONCAT('ROLE-', ApplicationId, '-', ActivatorName)
   ELSE NULL
  END;
INSERT INTO IWA_SecurityMember (SecurityMemberId, Name, DisplayName, MemberName, ApplicationId, Enabled, "Type")
  SELECT DISTINCT
    OriginalActivatorId,
    CASE
      WHEN ActivatorName LIKE '#%' THEN SUBSTRING(ActivatorName, 2)
      WHEN ActivatorName IS NOT NULL THEN ActivatorName
      ELSE OriginalActivatorId
    END,
    CASE
      WHEN ActivatorName LIKE '#%' THEN SUBSTRING(ActivatorName, 2)
      WHEN ActivatorName IS NOT NULL THEN ActivatorName
      ELSE OriginalActivatorId
    END,
    CASE
      WHEN ActivatorName IS NOT NULL THEN ActivatorName
      WHEN OriginalActivatorId LIKE 'USER-%' THEN CONCAT('#', OriginalActivatorId)
      ELSE OriginalActivatorId
    END,
    ApplicationId,
    0,
    CASE WHEN OriginalActivatorId LIKE 'USER-%' THEN 1 ELSE 0 END
  FROM IWA_Task
  WHERE IWA_Task.OriginalActivatorId IS NOT NULL AND
        IWA_Task.OriginalActivatorId NOT IN (SELECT SecurityMemberId FROM IWA_SecurityMember);
ALTER TABLE IWA_Task ADD FOREIGN KEY (OriginalActivatorId) REFERENCES IWA_SecurityMember(SecurityMemberId);

-- Migrate IWA_Task.ExpiryActivatorId
UPDATE IWA_Task SET ExpiryActivatorName = NULL WHERE ExpiryActivatorName = '#';

UPDATE IWA_Task SET ExpiryActivatorId =
  CASE
   WHEN ExpiryActivatorUserId IS NOT NULL THEN CONCAT('USER-', ExpiryActivatorUserId)
   WHEN ExpiryActivatorRoleId IS NOT NULL THEN CONCAT('ROLE-', ExpiryActivatorRoleId)
   WHEN ExpiryActivatorName LIKE '#%' THEN CONCAT('USER-', ApplicationId, '-', SUBSTRING(ExpiryActivatorName, 2))
   WHEN ExpiryActivatorName IS NOT NULL THEN CONCAT('ROLE-', ApplicationId, '-', ExpiryActivatorName)
   ELSE NULL
  END;
INSERT INTO IWA_SecurityMember (SecurityMemberId, Name, DisplayName, MemberName, ApplicationId, Enabled, "Type")
  SELECT DISTINCT
    ExpiryActivatorId,
    CASE
      WHEN ExpiryActivatorName LIKE '#%' THEN SUBSTRING(ExpiryActivatorName, 2)
      WHEN ExpiryActivatorName IS NOT NULL THEN ExpiryActivatorName
      ELSE ExpiryActivatorId
    END,
    CASE
      WHEN ExpiryActivatorName LIKE '#%' THEN SUBSTRING(ExpiryActivatorName, 2)
      WHEN ExpiryActivatorName IS NOT NULL THEN ExpiryActivatorName
      ELSE ExpiryActivatorId
    END,
    CASE
      WHEN ExpiryActivatorName IS NOT NULL THEN ExpiryActivatorName
      WHEN ExpiryActivatorId LIKE 'USER-%' THEN CONCAT('#', ExpiryActivatorId)
      ELSE ExpiryActivatorId
    END,
    ApplicationId,
    0,
    CASE WHEN ExpiryActivatorId LIKE 'USER-%' THEN 1 ELSE 0 END
  FROM IWA_Task
  WHERE IWA_Task.ExpiryActivatorId IS NOT NULL AND
        IWA_Task.ExpiryActivatorId NOT IN (SELECT SecurityMemberId FROM IWA_SecurityMember);
ALTER TABLE IWA_Task ADD FOREIGN KEY (ExpiryActivatorId) REFERENCES IWA_SecurityMember(SecurityMemberId);

-- Migrate IWA_Task.ActivatorId (CurrentActivator)
UPDATE IWA_Task SET ActivatorId = CASE WHEN IsExpired = 1 THEN ExpiryActivatorId ELSE OriginalActivatorId END;
ALTER TABLE IWA_Task ADD FOREIGN KEY (ActivatorId) REFERENCES IWA_SecurityMember(SecurityMemberId);

-- Migrate StartElement
ALTER TABLE IWA_StartElement ADD COLUMN ActivatorId VARCHAR(210) REFERENCES IWA_SecurityMember(SecurityMemberId) ON DELETE SET NULL;
UPDATE IWA_StartElement SET ActivatorId =
  CASE
   WHEN ActivatorRoleId IS NOT NULL THEN CONCAT('ROLE-', ActivatorRoleId)
   WHEN ActivatorUserId IS NOT NULL THEN CONCAT('USER-', ActivatorUserId)
   ELSE NULL
  END;

-- Migrate StartEventElement
ALTER TABLE IWA_StartEventElement ADD COLUMN ActivatorId VARCHAR(210) REFERENCES IWA_SecurityMember(SecurityMemberId) ON DELETE SET NULL;
UPDATE IWA_StartEventElement SET ActivatorId =
  CASE
   WHEN ActivatorRoleId IS NOT NULL THEN CONCAT('ROLE-', ActivatorRoleId)
   ELSE NULL
  END;

-- Migrate WebServiceProcStartElement
ALTER TABLE IWA_WebServiceProcStartElement ADD COLUMN ActivatorId VARCHAR(210) REFERENCES IWA_SecurityMember(SecurityMemberId) ON DELETE SET NULL;
UPDATE IWA_WebServiceProcStartElement SET ActivatorId =
  CASE
   WHEN ActivatorRoleId IS NOT NULL THEN CONCAT('ROLE-', ActivatorRoleId)
   ELSE NULL
  END;

-- Convert IWA_WebServiceProcStartElement.WebServiceProcessId from foreign key constraint to trigger
ALTER TABLE IWA_WebServiceProcStartElement DROP CONSTRAINT iwa_webserviceprocstartelement_webserviceprocessid_fkey;
DROP FUNCTION IF EXISTS IWA_WebServiceProcessDeleteTriggerFunc();

CREATE FUNCTION IWA_WebServiceProcessDeleteTriggerFunc() RETURNS TRIGGER AS '
  BEGIN
    DELETE FROM IWA_WebServiceProcStartElement
    WHERE IWA_WebServiceProcStartElement.WebServiceProcessId = OLD.WebServiceProcessId;

    RETURN OLD;
  END;
' LANGUAGE plpgsql;

CREATE TRIGGER IWA_WebServiceProcessDeleteTrigger AFTER DELETE
ON IWA_WebServiceProcess FOR EACH ROW
EXECUTE PROCEDURE IWA_WebServiceProcessDeleteTriggerFunc();

-- Migrate IWA_WorkflowEvent.UserId
DROP INDEX IF EXISTS IWA_WorkflowEvent_UserIdIdx;
ALTER TABLE IWA_WorkflowEvent RENAME COLUMN UserId TO WorkerUserId;
ALTER TABLE IWA_WorkflowEvent ADD COLUMN UserId VARCHAR(210);
UPDATE IWA_WorkflowEvent SET UserId = CASE
   WHEN WorkerUserId IS NOT NULL THEN CONCAT('USER-', WorkerUserId)
   WHEN UserName IS NOT NULL AND UserName NOT LIKE ('Unknown User (Session %') THEN CONCAT('USER-', ApplicationId, '-', UserName)
   ELSE NULL
  END;
INSERT INTO IWA_SecurityMember (SecurityMemberId, Name, DisplayName, MemberName, ApplicationId, Enabled, "Type")
  SELECT DISTINCT
    UserId,
    CASE WHEN UserName IS NOT NULL THEN UserName ELSE UserId END,
    CASE WHEN UserName IS NOT NULL THEN UserName ELSE UserId END,
    CONCAT('#', CASE WHEN UserName IS NOT NULL THEN UserName ELSE UserId END),
    ApplicationId,
    0,
    1
  FROM IWA_WorkflowEvent
  WHERE IWA_WorkflowEvent.UserId IS NOT NULL AND
        IWA_WorkflowEvent.UserId NOT IN (SELECT SecurityMemberId FROM IWA_SecurityMember);
ALTER TABLE IWA_WorkflowEvent ADD FOREIGN KEY (UserId) REFERENCES IWA_SecurityMember(SecurityMemberId);

-- Migrate IWA_SignalEvent.SentById
UPDATE IWA_SignalEvent SET SentById = CASE
   WHEN SentByUserId IS NOT NULL THEN CONCAT('USER-', SentByUserId)
   WHEN SentByUserName IS NOT NULL THEN CONCAT('USER-', ApplicationId, '-', SentByUserName)
   ELSE NULL
  END;
INSERT INTO IWA_SecurityMember (SecurityMemberId, Name, DisplayName, MemberName, ApplicationId, Enabled, "Type")
  SELECT DISTINCT
    SentById,
    CASE WHEN SentByUserName IS NOT NULL THEN SentByUserName ELSE SentById END,
    CASE WHEN SentByUserName IS NOT NULL THEN SentByUserName ELSE SentById END,
    CONCAT('#', SentByUserName),
    ApplicationId,
    0,
    1
  FROM IWA_SignalEvent
  WHERE IWA_SignalEvent.SentById IS NOT NULL AND
        IWA_SignalEvent.SentById NOT IN (SELECT SecurityMemberId FROM IWA_SecurityMember);
ALTER TABLE IWA_SignalEvent ADD FOREIGN KEY (SentById) REFERENCES IWA_SecurityMember(SecurityMemberId);

CREATE INDEX IF NOT EXISTS IWA_SignalEvent_SentById
ON IWA_SignalEvent (SentById varchar_pattern_ops);


-- Recreate trigger which depend on changed table(s)
DROP FUNCTION IF EXISTS IWA_UserDeleteTriggerFunc();

CREATE FUNCTION IWA_UserDeleteTriggerFunc() RETURNS TRIGGER AS '
  BEGIN
    UPDATE IWA_Case
    SET OwnerUserId=NULL
    WHERE IWA_Case.OwnerUserId = OLD.UserId;

    UPDATE IWA_Task
    SET WorkerUserId=NULL
    WHERE IWA_Task.WorkerUserId = OLD.UserId;

    UPDATE IWA_Task
    SET ActivatorUserId=NULL
    WHERE IWA_Task.ActivatorUserId = OLD.UserId;

    UPDATE IWA_Task
    SET ExpiryActivatorUserId=NULL
    WHERE IWA_Task.ExpiryActivatorUserId = OLD.UserId;

    RETURN OLD;
  END;
' LANGUAGE plpgsql;


CREATE TRIGGER IWA_UserDeleteTrigger AFTER DELETE
ON IWA_User FOR EACH ROW
EXECUTE PROCEDURE IWA_UserDeleteTriggerFunc();


-- Create new indexes of table IWA_Role
CREATE INDEX IF NOT EXISTS IWA_Role_SecurityMemberIdIndex
ON IWA_Role (SecurityMemberId varchar_pattern_ops);


-- Create new indexes of table IWA_User
CREATE INDEX IF NOT EXISTS IWA_User_SecurityMemberIdIndex
ON IWA_User (SecurityMemberId varchar_pattern_ops);


-- Create new indexes of table IWA_StartElement
CREATE INDEX IF NOT EXISTS IWA_StartElement_ActivatorIdIndex
ON IWA_StartElement (ActivatorId varchar_pattern_ops);


-- Create new indexes of table IWA_StartEventElement
CREATE INDEX IF NOT EXISTS IWA_StartEventElement_ActivatorIdIndex
ON IWA_StartEventElement (ActivatorId varchar_pattern_ops);


-- Create new indexes of table IWA_WebServiceProcStartElement
CREATE INDEX IF NOT EXISTS IWA_WebServiceProcStartElement_ActivatorIdIndex
ON IWA_WebServiceProcStartElement (ActivatorId varchar_pattern_ops);


-- Create new indexes of table IWA_Case
CREATE INDEX IF NOT EXISTS IWA_Case_CreatorIdIndex
ON IWA_Case (CreatorId varchar_pattern_ops);

CREATE INDEX IF NOT EXISTS IWA_Case_OwnerIdIndex
ON IWA_Case (OwnerId varchar_pattern_ops);


-- Create new indexes of table IWA_Task
CREATE INDEX IF NOT EXISTS IWA_Task_WorkerIdIndex
ON IWA_Task (WorkerId varchar_pattern_ops);

CREATE INDEX IF NOT EXISTS IWA_Task_ActivatorIdIndex
ON IWA_Task (ActivatorId varchar_pattern_ops);

CREATE INDEX IF NOT EXISTS IWA_Task_OriginalActivatorIdIndex
ON IWA_Task (OriginalActivatorId varchar_pattern_ops);

CREATE INDEX IF NOT EXISTS IWA_Task_ExpiryActivatorIdIndex
ON IWA_Task (ExpiryActivatorId varchar_pattern_ops);


-- Create new indexes of table IWA_WorkflowEvent
CREATE INDEX IF NOT EXISTS IWA_WorkflowEvent_UserIdIndex
ON IWA_WorkflowEvent (UserId varchar_pattern_ops);


-- Recreate views which has a new definition or depend on changed tables
CREATE VIEW IWA_TaskQuery
(
  TaskId,
  CaseId,
  BusinessCaseId,
  ProcessModelId,
  ApplicationId,
  StartTaskSwitchEventId,
  EndTaskSwitchEventId,
  TaskStartId,
  TaskEndId,
  WorkerId,
  WorkerUserId,
  WorkerUserName,
  WorkerUserDisplayName,
  WorkerSessionId,
  ActivatorId,
  OriginalActivatorId,
  ActivatorRoleId,
  ActivatorUserId,
  ActivatorName,
  ActivatorDisplayName,
  ActivatorAvailable,
  ExpiryActivatorId,
  ExpiryActivatorRoleId,
  ExpiryActivatorUserId,
  ExpiryActivatorName,
  ExpiryActivatorDisplayName,
  ExpiryPriority,
  ExpiryTimestamp,
  ExpiryTaskStartElementPid,
  IsExpired,
  ExpiredCreatorTaskId,
  TimeoutedCreatorIntrmdtEventId,
  DelayTimestamp,
  "State",
  RequestPath,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  Priority,
  OriginalPriority,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendar,
  WorkingTime,
  BusinessRuntime,
  FailedTimeoutTimestamp,
  NumberOfFailures,
  NumberOfResumes,
  Category,
  IsUpdatedOnStart,
  IsOffline,
  CurrentActivatorName,
  CurrentActivatorDisplayName,
  CurrentActivatorRoleId,
  CurrentActivatorUserId
)
AS
  SELECT
    IWA_Task.TaskId,
    IWA_Task.CaseId,
    IWA_Task.BusinessCaseId,
    IWA_Task.ProcessModelId,
    IWA_Task.ApplicationId,
    IWA_Task.StartTaskSwitchEventId,
    IWA_Task.EndTaskSwitchEventId,
    IWA_Task.TaskStartId,
    IWA_Task.TaskEndId,
    IWA_Task.WorkerId,
    IWA_Task.WorkerUserId,
    WorkerUser.Name,
    WorkerUser.DisplayName,
    IWA_Task.WorkerSessionId,
    IWA_Task.ActivatorId,
    IWA_Task.OriginalActivatorId,
    IWA_Task.ActivatorRoleId,
    IWA_Task.ActivatorUserId,
    OriginalActivator.MemberName,
    OriginalActivator.DisplayName,
    CurrentActivator.Enabled,
    IWA_Task.ExpiryActivatorId,
    IWA_Task.ExpiryActivatorRoleId,
    IWA_Task.ExpiryActivatorUserId,
    ExpiryActivator.MemberName,
    ExpiryActivator.DisplayName,
    IWA_Task.ExpiryPriority,
    IWA_Task.ExpiryTimestamp,
    IWA_Task.ExpiryTaskStartElementPid,
    IWA_Task.IsExpired,
    IWA_Task.ExpiredCreatorTaskId,
    IWA_Task.TimeoutedCreatorIntrmdtEventId,
    IWA_Task.DelayTimestamp,
    IWA_Task."State",
    IWA_Task.RequestPath,
    IWA_Task.DisplayNameTemplate,
    IWA_Task.Name,
    IWA_Task.DisplayDescriptionTemplate,
    IWA_Task.Description,
    IWA_Task.Priority,
    IWA_Task.OriginalPriority,
    IWA_Task.StartTimestamp,
    IWA_Task.EndTimestamp,
    IWA_Task.BusinessCalendar,
    IWA_Task.WorkingTime,
    IWA_Task.BusinessRuntime,
    IWA_Task.FailedTimeoutTimestamp,
    IWA_Task.NumberOfFailures,
    IWA_Task.NumberOfResumes,
    IWA_Task.Category,
    IWA_Task.IsUpdatedOnStart,
    IWA_Task.IsOffline,
    CurrentActivator.MemberName,
    CurrentActivator.DisplayName,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorRoleId WHEN 0 THEN IWA_Task.ActivatorRoleId END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorUserId WHEN 0 THEN IWA_Task.ActivatorUserId END
  FROM IWA_Task
    LEFT OUTER JOIN IWA_SecurityMember AS CurrentActivator ON IWA_Task.ActivatorId = CurrentActivator.SecurityMemberId
    LEFT OUTER JOIN IWA_SecurityMember AS OriginalActivator ON IWA_Task.OriginalActivatorId = OriginalActivator.SecurityMemberId
    LEFT OUTER JOIN IWA_SecurityMember AS ExpiryActivator ON IWA_Task.ExpiryActivatorId = ExpiryActivator.SecurityMemberId
    LEFT OUTER JOIN IWA_SecurityMember AS WorkerUser ON IWA_Task.WorkerId = WorkerUser.SecurityMemberId;

CREATE VIEW IWA_CaseQuery
(
  CaseId,
  BusinessCaseId,
  Kind,
  ApplicationId,
  ProcessModelId,
  TaskStartId,
  CreatorId,
  CreatorUserId,
  CreatorUserName,
  CreatorUserDisplayName,
  CreatorTaskId,
  EnvironmentId,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendar,
  WorkingTime,
  BusinessRuntime,
  "State",
  Priority,
  Stage,
  OwnerId,
  OwnerRoleId,
  OwnerUserId,
  OwnerName,
  Category
)
AS
  SELECT
    IWA_Case.CaseId,
    IWA_Case.BusinessCaseId,
    IWA_Case.Kind,
    IWA_Case.ApplicationId,
    IWA_Case.ProcessModelId,
    IWA_Case.TaskStartId,
    IWA_Case.CreatorId,
    IWA_Case.CreatorUserId,
    Creator.Name,
    Creator.DisplayName,
    IWA_Case.CreatorTaskId,
    IWA_Case.EnvironmentId,
    IWA_Case.DisplayNameTemplate,
    IWA_Case.Name,
    IWA_Case.DisplayDescriptionTemplate,
    IWA_Case.Description,
    IWA_Case.StartTimestamp,
    IWA_Case.EndTimestamp,
    IWA_Case.BusinessCalendar,
    IWA_Case.WorkingTime,
    IWA_Case.BusinessRuntime,
    IWA_Case."State",
    IWA_Case.Priority,
    IWA_Case.Stage,
    IWA_Case.OwnerId,
    IWA_Case.OwnerRoleId,
    IWA_Case.OwnerUserId,
    Owner.MemberName,
    IWA_Case.Category
  FROM IWA_Case
    LEFT OUTER JOIN IWA_SecurityMember AS Creator ON IWA_Case.CreatorId = Creator.SecurityMemberId
    LEFT OUTER JOIN IWA_SecurityMember AS Owner ON IWA_Case.OwnerId = Owner.SecurityMemberId;

CREATE VIEW IWA_ProcessStart
(
  TaskElementId,
  ProcessModelVersionId,
  Name,
  Description,
  ProcessElementId,
  TaskStartId,
  StartRequestPath,
  UserFriendlyStartRequestPath,
  ActivatorId
)
AS
  SELECT
    IWA_TaskElement.TaskElementId,
    IWA_TaskElement.ProcessModelVersionId,
    IWA_TaskElement.Name,
    IWA_TaskElement.Description,
    IWA_TaskElement.ProcessElementId,
    IWA_TaskStart.TaskStartId,
    IWA_TaskStart.StartRequestPath,
    IWA_TaskStart.UserFriendlyStartRequestPath,
    IWA_StartElement.ActivatorId
  FROM IWA_TaskElement,
    IWA_TaskStart,
    IWA_StartElement
  WHERE IWA_TaskElement.TaskElementId = IWA_TaskStart.TaskElementId AND IWA_TaskStart.TaskStartId = IWA_StartElement.TaskStartId
UNION ALL
  SELECT
    IWA_TaskElement.TaskElementId,
    IWA_TaskElement.ProcessModelVersionId,
    IWA_TaskElement.Name,
    IWA_TaskElement.Description,
    IWA_TaskElement.ProcessElementId,
    IWA_TaskStart.TaskStartId,
    IWA_TaskStart.StartRequestPath,
    IWA_TaskStart.UserFriendlyStartRequestPath,
    IWA_StartEventElement.ActivatorId
  FROM IWA_TaskElement,
    IWA_TaskStart,
    IWA_StartEventElement
  WHERE IWA_TaskElement.TaskElementId = IWA_TaskStart.TaskElementId AND IWA_TaskStart.TaskStartId = IWA_StartEventElement.TaskStartId
UNION ALL
  SELECT
    IWA_TaskElement.TaskElementId,
    IWA_TaskElement.ProcessModelVersionId,
    IWA_TaskElement.Name,
    IWA_TaskElement.Description,
    IWA_TaskElement.ProcessElementId,
    IWA_TaskStart.TaskStartId,
    IWA_TaskStart.StartRequestPath,
    IWA_TaskStart.UserFriendlyStartRequestPath,
    IWA_WebServiceProcStartElement.ActivatorId
  FROM IWA_TaskElement,
    IWA_TaskStart,
    IWA_WebServiceProcStartElement
  WHERE IWA_TaskElement.TaskElementId = IWA_TaskStart.TaskElementId AND IWA_TaskStart.TaskStartId = IWA_WebServiceProcStartElement.TaskStartId;

CREATE VIEW IWA_SignalEventQuery
(
  SignalEventId,
  ApplicationId,
  SignalCode,
  SentTimestamp,
  SentById,
  SentByUserName,
  SentByUserId,
  SentByTaskId,
  SentByProcessElementPid
)
AS
  SELECT
    IWA_SignalEvent.SignalEventId,
    IWA_SignalEvent.ApplicationId,
    IWA_SignalEvent.SignalCode,
    IWA_SignalEvent.SentTimestamp,
    IWA_SignalEvent.SentById,
    IWA_SecurityMember.Name,
    IWA_User.UserId,
    IWA_SignalEvent.SentByTaskId,
    IWA_SignalEvent.SentByProcessElementPid
  FROM IWA_SignalEvent
    LEFT OUTER JOIN IWA_SecurityMember ON IWA_SignalEvent.SentById = IWA_SecurityMember.SecurityMemberId
    LEFT OUTER JOIN IWA_User ON IWA_SecurityMember.SecurityMemberId = IWA_User.SecurityMemberId;


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=68;
