# ---------------------------------------------------------------------------------
# 
# Converts the ivy system database from version 68 to version 69
# 
# ---------------------------------------------------------------------------------
# 
# This script was automatically generated. Do not edit it. Instead edit the source file
# 
# ---------------------------------------------------------------------------------
# Database: MySQL
# ---------------------------------------------------------------------------------
# Copyright:
# Axon Ivy AG, Baarerstrasse 12, 6300 Zug
# ---------------------------------------------------------------------------------

# Drop views which has a new definition or depend on changed tables
DROP VIEW IWA_SignalEventQuery;

DROP VIEW IWA_TaskQuery;

DROP VIEW IWA_CaseQuery;

DROP VIEW IWA_ProcessStart;


# Drop removed indexes of table IWA_Case
DROP INDEX IWA_Case_CreatorUserIdIndex
ON IWA_Case;
DROP INDEX IWA_Case_OwnerRoleIdIndex
ON IWA_Case;
DROP INDEX IWA_Case_OwnerUserIdIndex
ON IWA_Case;

# Drop removed indexes of table IWA_Task
DROP INDEX IWA_Task_WorkerUserIdIndex
ON IWA_Task;
DROP INDEX IWA_Task_ActivatorUserIdIndex
ON IWA_Task;
DROP INDEX IWA_Task_ActivatorRoleIdIndex
ON IWA_Task;
DROP INDEX IWA_Task_ExpiryActivatorUserIdIndex
ON IWA_Task;
DROP INDEX IWA_Task_ExpiryActivatorRoleIdIndex
ON IWA_Task;

# Drop removed indexes of table IWA_WorkflowEvent
DROP INDEX IWA_WorkflowEvent_UserNameIndex
ON IWA_WorkflowEvent;

# Drop removed indexes of table IWA_SignalEvent
DROP INDEX IWA_SignalEvent_SentByUserId
ON IWA_SignalEvent;

# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_RoleDeleteTrigger;

# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_UserDeleteTrigger;

# Dropped columns of table IWA_StartElement
ALTER TABLE IWA_StartElement DROP COLUMN ActivatorRoleId;

ALTER TABLE IWA_StartElement DROP COLUMN ActivatorUserId;


# Dropped columns of table IWA_StartEventElement
ALTER TABLE IWA_StartEventElement DROP COLUMN ActivatorRoleId;


# Dropped columns of table IWA_WebServiceProcStartElement
ALTER TABLE IWA_WebServiceProcStartElement DROP COLUMN ActivatorRoleId;


# Dropped columns of table IWA_Case
ALTER TABLE IWA_Case DROP COLUMN CreatorUserId;

ALTER TABLE IWA_Case DROP COLUMN CreatorUserName;

ALTER TABLE IWA_Case DROP COLUMN OwnerRoleId;

ALTER TABLE IWA_Case DROP COLUMN OwnerUserId;

ALTER TABLE IWA_Case DROP COLUMN OwnerName;


# Dropped columns of table IWA_Task
ALTER TABLE IWA_Task DROP COLUMN WorkerUserId;

ALTER TABLE IWA_Task DROP COLUMN WorkerUserName;

ALTER TABLE IWA_Task DROP COLUMN ActivatorRoleId;

ALTER TABLE IWA_Task DROP COLUMN ActivatorUserId;

ALTER TABLE IWA_Task DROP COLUMN ActivatorName;

ALTER TABLE IWA_Task DROP COLUMN ExpiryActivatorRoleId;

ALTER TABLE IWA_Task DROP COLUMN ExpiryActivatorUserId;

ALTER TABLE IWA_Task DROP COLUMN ExpiryActivatorName;


# Dropped columns of table IWA_WorkflowEvent
ALTER TABLE IWA_WorkflowEvent DROP COLUMN UserName;

ALTER TABLE IWA_WorkflowEvent DROP COLUMN WorkerUserId;


# Dropped columns of table IWA_SignalEvent
ALTER TABLE IWA_SignalEvent DROP COLUMN SentByUserName;

ALTER TABLE IWA_SignalEvent DROP COLUMN SentByUserId;


# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_RoleDeleteTrigger
AFTER DELETE ON IWA_Role
FOR EACH ROW
BEGIN
  DELETE FROM IWA_UserRole
  WHERE IWA_UserRole.RoleId = OLD.RoleId;

  DELETE FROM IWA_RoleProperty
  WHERE IWA_RoleProperty.RoleId = OLD.RoleId;

  DELETE FROM IWA_RoleRoleMember
  WHERE IWA_RoleRoleMember.RoleId = OLD.RoleId;

  DELETE FROM IWA_RoleRoleMember
  WHERE IWA_RoleRoleMember.RoleMemberId = OLD.RoleId;

  DELETE FROM IWA_UserSubstitute
  WHERE IWA_UserSubstitute.SubstituteForRoleId = OLD.RoleId;

  DELETE FROM IWA_AccessControl
  WHERE IWA_AccessControl.RoleId = OLD.RoleId;

END
;


# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_UserDeleteTrigger
AFTER DELETE ON IWA_User
FOR EACH ROW
BEGIN
  UPDATE IWA_Note
  SET UserId=NULL
  WHERE IWA_Note.UserId=OLD.UserId;

  UPDATE IWA_PageArchive
  SET UserId=NULL
  WHERE IWA_PageArchive.UserId=OLD.UserId;

  UPDATE IWA_SecurityDescriptor
  SET OwnerUserId=NULL
  WHERE IWA_SecurityDescriptor.OwnerUserId=OLD.UserId;

  DELETE FROM IWA_UserRole
  WHERE IWA_UserRole.UserId = OLD.UserId;

  DELETE FROM IWA_UserAbsence
  WHERE IWA_UserAbsence.UserId = OLD.UserId;

  DELETE FROM IWA_UserSubstitute
  WHERE IWA_UserSubstitute.UserId = OLD.UserId;

  DELETE FROM IWA_UserSubstitute
  WHERE IWA_UserSubstitute.SubstituteUserId = OLD.UserId;

  DELETE FROM IWA_UserProperty
  WHERE IWA_UserProperty.UserId = OLD.UserId;

  DELETE FROM IWA_AccessControl
  WHERE IWA_AccessControl.UserId = OLD.UserId;

  DELETE FROM IWA_UserLocation
  WHERE IWA_UserLocation.UserId = OLD.UserId;

END
;


# Recreate views which has a new definition or depend on changed tables
CREATE VIEW IWA_SignalEventQuery
(
  SignalEventId,
  ApplicationId,
  SignalCode,
  SentTimestamp,
  SentById,
  SentByUserName,
  SentByUserId,
  SentByTaskId,
  SentByProcessElementPid
)
AS
  SELECT
    IWA_SignalEvent.SignalEventId,
    IWA_SignalEvent.ApplicationId,
    IWA_SignalEvent.SignalCode,
    IWA_SignalEvent.SentTimestamp,
    IWA_SignalEvent.SentById,
    IWA_SecurityMember.Name,
    IWA_User.UserId,
    IWA_SignalEvent.SentByTaskId,
    IWA_SignalEvent.SentByProcessElementPid
  FROM IWA_SignalEvent
    LEFT OUTER JOIN IWA_SecurityMember ON IWA_SignalEvent.SentById = IWA_SecurityMember.SecurityMemberId
    LEFT OUTER JOIN IWA_User ON IWA_SecurityMember.SecurityMemberId = IWA_User.SecurityMemberId;

CREATE VIEW IWA_TaskQuery
(
  TaskId,
  CaseId,
  BusinessCaseId,
  ProcessModelId,
  ApplicationId,
  StartTaskSwitchEventId,
  EndTaskSwitchEventId,
  TaskStartId,
  TaskEndId,
  WorkerId,
  WorkerUserName,
  WorkerUserDisplayName,
  WorkerSessionId,
  ActivatorId,
  OriginalActivatorId,
  OriginalActivatorName,
  OriginalActivatorDisplayName,
  ActivatorAvailable,
  ExpiryActivatorId,
  ExpiryActivatorName,
  ExpiryActivatorDisplayName,
  ExpiryPriority,
  ExpiryTimestamp,
  ExpiryTaskStartElementPid,
  IsExpired,
  ExpiredCreatorTaskId,
  TimeoutedCreatorIntrmdtEventId,
  DelayTimestamp,
  `State`,
  RequestPath,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  Priority,
  OriginalPriority,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendar,
  WorkingTime,
  BusinessRuntime,
  FailedTimeoutTimestamp,
  NumberOfFailures,
  NumberOfResumes,
  Category,
  IsUpdatedOnStart,
  IsOffline,
  ActivatorName,
  ActivatorDisplayName
)
AS
  SELECT
    IWA_Task.TaskId,
    IWA_Task.CaseId,
    IWA_Task.BusinessCaseId,
    IWA_Task.ProcessModelId,
    IWA_Task.ApplicationId,
    IWA_Task.StartTaskSwitchEventId,
    IWA_Task.EndTaskSwitchEventId,
    IWA_Task.TaskStartId,
    IWA_Task.TaskEndId,
    IWA_Task.WorkerId,
    Worker.Name,
    Worker.DisplayName,
    IWA_Task.WorkerSessionId,
    IWA_Task.ActivatorId,
    IWA_Task.OriginalActivatorId,
    OriginalActivator.MemberName,
    OriginalActivator.DisplayName,
    Activator.Enabled,
    IWA_Task.ExpiryActivatorId,
    ExpiryActivator.MemberName,
    ExpiryActivator.DisplayName,
    IWA_Task.ExpiryPriority,
    IWA_Task.ExpiryTimestamp,
    IWA_Task.ExpiryTaskStartElementPid,
    IWA_Task.IsExpired,
    IWA_Task.ExpiredCreatorTaskId,
    IWA_Task.TimeoutedCreatorIntrmdtEventId,
    IWA_Task.DelayTimestamp,
    IWA_Task.`State`,
    IWA_Task.RequestPath,
    IWA_Task.DisplayNameTemplate,
    IWA_Task.Name,
    IWA_Task.DisplayDescriptionTemplate,
    IWA_Task.Description,
    IWA_Task.Priority,
    IWA_Task.OriginalPriority,
    IWA_Task.StartTimestamp,
    IWA_Task.EndTimestamp,
    IWA_Task.BusinessCalendar,
    IWA_Task.WorkingTime,
    IWA_Task.BusinessRuntime,
    IWA_Task.FailedTimeoutTimestamp,
    IWA_Task.NumberOfFailures,
    IWA_Task.NumberOfResumes,
    IWA_Task.Category,
    IWA_Task.IsUpdatedOnStart,
    IWA_Task.IsOffline,
    Activator.MemberName,
    Activator.DisplayName
  FROM IWA_Task
    LEFT OUTER JOIN IWA_SecurityMember AS Activator ON IWA_Task.ActivatorId = Activator.SecurityMemberId
    LEFT OUTER JOIN IWA_SecurityMember AS OriginalActivator ON IWA_Task.OriginalActivatorId = OriginalActivator.SecurityMemberId
    LEFT OUTER JOIN IWA_SecurityMember AS ExpiryActivator ON IWA_Task.ExpiryActivatorId = ExpiryActivator.SecurityMemberId
    LEFT OUTER JOIN IWA_SecurityMember AS Worker ON IWA_Task.WorkerId = Worker.SecurityMemberId;

CREATE VIEW IWA_CaseQuery
(
  CaseId,
  BusinessCaseId,
  Kind,
  ApplicationId,
  ProcessModelId,
  TaskStartId,
  CreatorId,
  CreatorUserName,
  CreatorUserDisplayName,
  CreatorTaskId,
  EnvironmentId,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendar,
  WorkingTime,
  BusinessRuntime,
  `State`,
  Priority,
  Stage,
  OwnerId,
  OwnerName,
  OwnerDisplayName,
  Category
)
AS
  SELECT
    IWA_Case.CaseId,
    IWA_Case.BusinessCaseId,
    IWA_Case.Kind,
    IWA_Case.ApplicationId,
    IWA_Case.ProcessModelId,
    IWA_Case.TaskStartId,
    IWA_Case.CreatorId,
    Creator.Name,
    Creator.DisplayName,
    IWA_Case.CreatorTaskId,
    IWA_Case.EnvironmentId,
    IWA_Case.DisplayNameTemplate,
    IWA_Case.Name,
    IWA_Case.DisplayDescriptionTemplate,
    IWA_Case.Description,
    IWA_Case.StartTimestamp,
    IWA_Case.EndTimestamp,
    IWA_Case.BusinessCalendar,
    IWA_Case.WorkingTime,
    IWA_Case.BusinessRuntime,
    IWA_Case.`State`,
    IWA_Case.Priority,
    IWA_Case.Stage,
    IWA_Case.OwnerId,
    Owner.MemberName,
    Owner.DisplayName,
    IWA_Case.Category
  FROM IWA_Case
    LEFT OUTER JOIN IWA_SecurityMember AS Creator ON IWA_Case.CreatorId = Creator.SecurityMemberId
    LEFT OUTER JOIN IWA_SecurityMember AS Owner ON IWA_Case.OwnerId = Owner.SecurityMemberId;

CREATE VIEW IWA_ProcessStart
(
  TaskElementId,
  ProcessModelVersionId,
  Name,
  Description,
  ProcessElementId,
  TaskStartId,
  StartRequestPath,
  UserFriendlyStartRequestPath,
  ActivatorId
)
AS
  SELECT
    IWA_TaskElement.TaskElementId,
    IWA_TaskElement.ProcessModelVersionId,
    IWA_TaskElement.Name,
    IWA_TaskElement.Description,
    IWA_TaskElement.ProcessElementId,
    IWA_TaskStart.TaskStartId,
    IWA_TaskStart.StartRequestPath,
    IWA_TaskStart.UserFriendlyStartRequestPath,
    IWA_StartElement.ActivatorId
  FROM IWA_TaskElement,
    IWA_TaskStart,
    IWA_StartElement
  WHERE IWA_TaskElement.TaskElementId = IWA_TaskStart.TaskElementId AND IWA_TaskStart.TaskStartId = IWA_StartElement.TaskStartId
UNION ALL
  SELECT
    IWA_TaskElement.TaskElementId,
    IWA_TaskElement.ProcessModelVersionId,
    IWA_TaskElement.Name,
    IWA_TaskElement.Description,
    IWA_TaskElement.ProcessElementId,
    IWA_TaskStart.TaskStartId,
    IWA_TaskStart.StartRequestPath,
    IWA_TaskStart.UserFriendlyStartRequestPath,
    IWA_StartEventElement.ActivatorId
  FROM IWA_TaskElement,
    IWA_TaskStart,
    IWA_StartEventElement
  WHERE IWA_TaskElement.TaskElementId = IWA_TaskStart.TaskElementId AND IWA_TaskStart.TaskStartId = IWA_StartEventElement.TaskStartId
UNION ALL
  SELECT
    IWA_TaskElement.TaskElementId,
    IWA_TaskElement.ProcessModelVersionId,
    IWA_TaskElement.Name,
    IWA_TaskElement.Description,
    IWA_TaskElement.ProcessElementId,
    IWA_TaskStart.TaskStartId,
    IWA_TaskStart.StartRequestPath,
    IWA_TaskStart.UserFriendlyStartRequestPath,
    IWA_WebServiceProcStartElement.ActivatorId
  FROM IWA_TaskElement,
    IWA_TaskStart,
    IWA_WebServiceProcStartElement
  WHERE IWA_TaskElement.TaskElementId = IWA_TaskStart.TaskElementId AND IWA_TaskStart.TaskStartId = IWA_WebServiceProcStartElement.TaskStartId;



# 
# Update Version
# 
UPDATE IWA_Version SET Version=69;
