-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 69 to version 70
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Microsoft SQL Server
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ApplicationDeleteTrigger
GO

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ProcessModelVersionDeleteTrigger
GO

-- Drop trigger that has been deleted
DROP TRIGGER IWA_ContentManagementSystemDeleteTrigger
GO
-- Store Procedure to drop a unique constraint
CREATE PROCEDURE IWA_Drop_ForeignKey
@tableName varchar(100),
@columnName varchar(100)
AS
DECLARE @fkName Varchar(255)
SET @fkName= (
  SELECT fk.name
  FROM sys.foreign_keys fk
  INNER JOIN sys.foreign_key_columns fkc ON fkc.constraint_object_id = fk.object_id
  INNER JOIN sys.columns c1 ON fkc.parent_column_id = c1.column_id AND fkc.parent_object_id = c1.object_id
  INNER JOIN sys.columns c2 ON fkc.referenced_column_id = c2.column_id AND fkc.referenced_object_id = c2.object_id
  WHERE OBJECT_NAME(fk.parent_object_id)=@tableName AND c2.name=@columnName
)
DECLARE @dropSql varchar(4000)
SET @dropSql=
  'ALTER TABLE [dbo].['+@tableName+']
    DROP CONSTRAINT ['+@fkName+']'
EXEC(@dropSql)

GO

EXECUTE IWA_Drop_ForeignKey @tableName='IWA_EventLogData', @columnName='EventLogId'
GO
EXECUTE IWA_Drop_ForeignKey @tableName='IWA_EventLogTaskHistory', @columnName='EventLogId'
GO
EXECUTE IWA_Drop_ForeignKey @tableName='IWA_EventLogStatus', @columnName='EventLogId'
GO

-- Drop trigger of no longer exisiting table
DROP TRIGGER IWA_ContentObjectValueDeleteTrigger
GO

-- Drop trigger of no longer exisiting table
DROP TRIGGER IWA_ContentObjectDeleteTrigger
GO

-- Drop no longer exisiting table
DROP TABLE IWA_EventLogData
GO

-- Drop no longer exisiting table
DROP TABLE IWA_EventLogTaskHistory
GO

-- Drop no longer exisiting table
DROP TABLE IWA_EventLogCaseHistory
GO

-- Drop no longer exisiting table
DROP TABLE IWA_EventLogStatus
GO

-- Drop no longer exisiting table
DROP TABLE IWA_EventLog
GO

-- Drop no longer exisiting table
DROP TABLE IWA_SupportedLanguage
GO

-- Drop no longer exisiting table
DROP TABLE IWA_ContentDataString
GO

-- Drop no longer exisiting table
DROP TABLE IWA_ContentDataText
GO

-- Drop no longer exisiting table
DROP TABLE IWA_ContentDataImage
GO

-- Drop no longer exisiting table
DROP TABLE IWA_ContentObjectValue
GO

-- Drop no longer exisiting table
ALTER TABLE IWA_ContentManagementSystem DROP COLUMN DefaultPageLayoutId;
GO
ALTER TABLE IWA_ContentManagementSystem DROP COLUMN DefaultPageStyleSheetId;
GO
DROP TABLE IWA_ContentObject
GO

-- Drop no longer exisiting table
DROP TABLE IWA_ContentObjectType
GO

-- Drop no longer exisiting table
DROP TABLE IWA_ContentManagementSystem
GO

-- Drop temporary created stored procedures needed for conversion
DROP PROCEDURE IWA_Drop_ForeignKey
GO

-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ApplicationDeleteTrigger
  ON IWA_Application FOR DELETE AS

  DELETE IWA_Environment FROM IWA_Environment, deleted
  WHERE IWA_Environment.ApplicationId = deleted.ApplicationId

  DELETE IWA_WebService FROM IWA_WebService, deleted
  WHERE IWA_WebService.ApplicationId = deleted.ApplicationId

  DELETE IWA_ExternalDatabase FROM IWA_ExternalDatabase, deleted
  WHERE IWA_ExternalDatabase.ApplicationId = deleted.ApplicationId

  DELETE IWA_SignalEvent FROM IWA_SignalEvent, deleted
  WHERE IWA_SignalEvent.ApplicationId = deleted.ApplicationId

  DELETE IWA_Role FROM IWA_Role, deleted
  WHERE IWA_Role.ApplicationId = deleted.ApplicationId

  DELETE IWA_ApplicationProperty FROM IWA_ApplicationProperty, deleted
  WHERE IWA_ApplicationProperty.ApplicationId = deleted.ApplicationId

  DELETE IWA_GlobalVariable FROM IWA_GlobalVariable, deleted
  WHERE IWA_GlobalVariable.ApplicationId = deleted.ApplicationId

  DELETE IWA_ExternalNamingAndDirectory FROM IWA_ExternalNamingAndDirectory, deleted
  WHERE IWA_ExternalNamingAndDirectory.ApplicationId = deleted.ApplicationId

  DELETE IWA_RestServiceClient FROM IWA_RestServiceClient, deleted
  WHERE IWA_RestServiceClient.ApplicationId = deleted.ApplicationId

  DELETE IWA_User FROM IWA_User, deleted
  WHERE IWA_User.ApplicationId = deleted.ApplicationId

  DELETE IWA_ProcessModel FROM IWA_ProcessModel, deleted
  WHERE IWA_ProcessModel.ApplicationId = deleted.ApplicationId

  DELETE IWA_SecurityMember FROM IWA_SecurityMember, deleted
  WHERE IWA_SecurityMember.ApplicationId = deleted.ApplicationId

  DELETE IWA_SecurityDescriptor FROM IWA_SecurityDescriptor, deleted
  WHERE IWA_SecurityDescriptor.SecurityDescriptorId = deleted.SecurityDescriptorId


GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ProcessModelVersionDeleteTrigger
  ON IWA_ProcessModelVersion FOR DELETE AS

  DELETE IWA_TaskElement FROM IWA_TaskElement, deleted
  WHERE IWA_TaskElement.ProcessModelVersionId = deleted.ProcessModelVersionId

  DELETE IWA_WebServiceProcess FROM IWA_WebServiceProcess, deleted
  WHERE IWA_WebServiceProcess.ProcessModelVersionId = deleted.ProcessModelVersionId

  DELETE IWA_PageElement FROM IWA_PageElement, deleted
  WHERE IWA_PageElement.ProcessModelVersionId = deleted.ProcessModelVersionId


GO

-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=70
GO
