-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 69 to version 70
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Oracle
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ApplicationDeleteTrg;

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_EVENTLOGDATA' AND UCC.COLUMN_NAME='EVENTLOGID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_EventLogData DROP CONSTRAINT ' || FK_NAME;
END;
;

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_EVENTLOGTASKHISTORY' AND UCC.COLUMN_NAME='EVENTLOGID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_EventLogTaskHistory DROP CONSTRAINT ' || FK_NAME;
END;
;

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_EVENTLOGSTATUS' AND UCC.COLUMN_NAME='EVENTLOGID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_EventLogStatus DROP CONSTRAINT ' || FK_NAME;
END;
;

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_CONTENTDATASTRING' AND UCC.COLUMN_NAME='CONTENTOBJECTVALUEID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_ContentDataString DROP CONSTRAINT ' || FK_NAME;
END;
;

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_CONTENTDATATEXT' AND UCC.COLUMN_NAME='CONTENTOBJECTVALUEID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_ContentDataText DROP CONSTRAINT ' || FK_NAME;
END;
;

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_CONTENTDATAIMAGE' AND UCC.COLUMN_NAME='CONTENTOBJECTVALUEID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_ContentDataImage DROP CONSTRAINT ' || FK_NAME;
END;
;

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_CONTENTMANAGEMENTSYSTEM' AND UCC.COLUMN_NAME='DEFAULTPAGELAYOUTID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_ContentManagementSystem DROP CONSTRAINT ' || FK_NAME;
END;
;

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_CONTENTMANAGEMENTSYSTEM' AND UCC.COLUMN_NAME='DEFAULTPAGESTYLESHEETID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_ContentManagementSystem DROP CONSTRAINT ' || FK_NAME;
END;
;

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_CONTENTOBJECT' AND UCC.COLUMN_NAME='PARENTCONTENTOBJECTID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_ContentObject DROP CONSTRAINT ' || FK_NAME;
END;
;

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_CONTENTOBJECTVALUE' AND UCC.COLUMN_NAME='CONTENTOBJECTID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_ContentObjectValue DROP CONSTRAINT ' || FK_NAME;
END;
;


-- Drop no longer exisiting table
DROP TABLE IWA_EventLogData;

-- Drop no longer exisiting table
DROP TABLE IWA_EventLogTaskHistory;

-- Drop no longer exisiting table
DROP TABLE IWA_EventLogCaseHistory;

-- Drop no longer exisiting table
DROP TABLE IWA_EventLogStatus;

-- Drop no longer exisiting table
DROP TABLE IWA_EventLog;

-- Drop no longer exisiting table
DROP TABLE IWA_SupportedLanguage;

-- Drop no longer exisiting table
DROP TABLE IWA_ContentDataString;

-- Drop no longer exisiting table
DROP TABLE IWA_ContentDataText;

-- Drop no longer exisiting table
DROP TABLE IWA_ContentDataImage;

-- Drop no longer exisiting table
DROP TABLE IWA_ContentObjectValue;

-- Drop no longer exisiting table
ALTER TABLE IWA_ContentManagementSystem DROP COLUMN DefaultPageLayoutId;
ALTER TABLE IWA_ContentManagementSystem DROP COLUMN DefaultPageStyleSheetId;
DROP TABLE IWA_ContentObject;

-- Drop no longer exisiting table
DROP TABLE IWA_ContentObjectType;

-- Drop no longer exisiting table
DROP TABLE IWA_ContentManagementSystem;

-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ApplicationDeleteTrg
AFTER DELETE ON IWA_Application
FOR EACH ROW
BEGIN
  DELETE IWA_SignalEvent
  WHERE IWA_SignalEvent.ApplicationId = :old.ApplicationId;

  DELETE IWA_Role
  WHERE IWA_Role.ApplicationId = :old.ApplicationId;

  DELETE IWA_Library
  WHERE IWA_Library.ApplicationId = :old.ApplicationId;

  DELETE IWA_User
  WHERE IWA_User.ApplicationId = :old.ApplicationId;

  DELETE IWA_ProcessModel
  WHERE IWA_ProcessModel.ApplicationId = :old.ApplicationId;

  DELETE IWA_SecurityMember
  WHERE IWA_SecurityMember.ApplicationId = :old.ApplicationId;

  DELETE IWA_SecurityDescriptor
  WHERE IWA_SecurityDescriptor.SecurityDescriptorId = :old.SecurityDescriptorId;

END;
;

-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=70;
