-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 72 to version 73
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Microsoft SQL Server
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------

-- Added columns of table IWA_Case
ALTER TABLE IWA_Case ADD
  ActivatorId VARCHAR(210) NULL REFERENCES IWA_SecurityMember(SecurityMemberId)
GO


-- Migrate ActivatorId from IWA_ProcessStart View to IWA_Case
UPDATE IWA_Case
SET ActivatorId = s.ActivatorId
FROM IWA_ProcessStart s
WHERE IWA_Case.TaskStartId = s.TaskStartId
GO


-- Drop views which has a new definition or depend on changed tables
DROP VIEW IWA_CaseQuery
GO

DROP VIEW IWA_ProcessStart
GO


-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ProcessModelVersionDeleteTrigger
GO

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_TaskStartDeleteTrigger
GO
-- Store Procedure to drop a unique constraint
CREATE PROCEDURE IWA_Drop_ForeignKey
@tableName varchar(100),
@columnName varchar(100)
AS
DECLARE @fkName Varchar(255)
SET @fkName= (
  SELECT fk.name
  FROM sys.foreign_keys fk
  INNER JOIN sys.foreign_key_columns fkc ON fkc.constraint_object_id = fk.object_id
  INNER JOIN sys.columns c1 ON fkc.parent_column_id = c1.column_id AND fkc.parent_object_id = c1.object_id
  INNER JOIN sys.columns c2 ON fkc.referenced_column_id = c2.column_id AND fkc.referenced_object_id = c2.object_id
  WHERE OBJECT_NAME(fk.parent_object_id)=@tableName AND c2.name=@columnName
)
DECLARE @dropSql varchar(4000)
SET @dropSql=
  'ALTER TABLE [dbo].['+@tableName+']
    DROP CONSTRAINT ['+@fkName+']'
EXEC(@dropSql)

GO

EXECUTE IWA_Drop_ForeignKey @tableName='IWA_WebServiceProcStartElement', @columnName='WebServiceProcessId'
GO

-- Drop no longer exisiting table
DROP TABLE IWA_StartElement
GO

-- Drop no longer exisiting table
DROP TABLE IWA_StartEventElement
GO

-- Drop no longer exisiting table
DROP TABLE IWA_WebServiceProcStartElement
GO

-- Drop no longer exisiting table
DROP TABLE IWA_WebServiceProcess
GO

-- Drop no longer exisiting table
DROP TABLE IWA_StartSignalEventElement
GO



-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ProcessModelVersionDeleteTrigger
  ON IWA_ProcessModelVersion FOR DELETE AS

  DELETE IWA_TaskElement FROM IWA_TaskElement, deleted
  WHERE IWA_TaskElement.ProcessModelVersionId = deleted.ProcessModelVersionId

  DELETE IWA_PageElement FROM IWA_PageElement, deleted
  WHERE IWA_PageElement.ProcessModelVersionId = deleted.ProcessModelVersionId


GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_TaskStartDeleteTrigger
  ON IWA_TaskStart FOR DELETE AS

  DELETE IWA_IntermediateEventElement FROM IWA_IntermediateEventElement, deleted
  WHERE IWA_IntermediateEventElement.TaskStartId = deleted.TaskStartId


GO


-- Recreate views which has a new definition or depend on changed tables
CREATE VIEW IWA_CaseQuery
(
  CaseId,
  BusinessCaseId,
  Kind,
  ApplicationId,
  ProcessModelId,
  TaskStartId,
  ActivatorId,
  CreatorId,
  CreatorUserName,
  CreatorUserDisplayName,
  CreatorTaskId,
  EnvironmentId,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendar,
  WorkingTime,
  BusinessRuntime,
  "State",
  Priority,
  Stage,
  OwnerId,
  OwnerName,
  OwnerDisplayName,
  Category
)
AS
  SELECT
    IWA_Case.CaseId,
    IWA_Case.BusinessCaseId,
    IWA_Case.Kind,
    IWA_Case.ApplicationId,
    IWA_Case.ProcessModelId,
    IWA_Case.TaskStartId,
    IWA_Case.ActivatorId,
    IWA_Case.CreatorId,
    Creator.Name,
    Creator.DisplayName,
    IWA_Case.CreatorTaskId,
    IWA_Case.EnvironmentId,
    IWA_Case.DisplayNameTemplate,
    IWA_Case.Name,
    IWA_Case.DisplayDescriptionTemplate,
    IWA_Case.Description,
    IWA_Case.StartTimestamp,
    IWA_Case.EndTimestamp,
    IWA_Case.BusinessCalendar,
    IWA_Case.WorkingTime,
    IWA_Case.BusinessRuntime,
    IWA_Case."State",
    IWA_Case.Priority,
    IWA_Case.Stage,
    IWA_Case.OwnerId,
    Owner.MemberName,
    Owner.DisplayName,
    IWA_Case.Category
  FROM IWA_Case
    LEFT OUTER JOIN IWA_SecurityMember AS Creator ON IWA_Case.CreatorId = Creator.SecurityMemberId
    LEFT OUTER JOIN IWA_SecurityMember AS Owner ON IWA_Case.OwnerId = Owner.SecurityMemberId
GO


-- Drop temporary created stored procedures needed for conversion
DROP PROCEDURE IWA_Drop_ForeignKey
GO

-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=73
GO
