# ---------------------------------------------------------------------------------
# 
# Converts the ivy system database from version 72 to version 73
# 
# ---------------------------------------------------------------------------------
# 
# This script was automatically generated. Do not edit it. Instead edit the source file
# 
# ---------------------------------------------------------------------------------
# Database: MySQL
# ---------------------------------------------------------------------------------
# Copyright:
# Axon Ivy AG, Baarerstrasse 12, 6300 Zug
# ---------------------------------------------------------------------------------

# Added columns of table IWA_Case
ALTER TABLE IWA_Case ADD COLUMN
  ActivatorId VARCHAR(210);

# Create added foreign keys of table IWA_Case
ALTER TABLE IWA_Case ADD
(
 FOREIGN KEY (ActivatorId) REFERENCES IWA_SecurityMember(SecurityMemberId)
);


# Migrate ActivatorId from IWA_ProcessStart View to IWA_Case
UPDATE IWA_Case
    INNER JOIN 
  IWA_ProcessStart ON IWA_Case.TaskStartId = IWA_ProcessStart.TaskStartId
SET 
  IWA_Case.ActivatorId=IWA_ProcessStart.ActivatorId;


# Drop views which has a new definition or depend on changed tables
DROP VIEW IWA_CaseQuery;

DROP VIEW IWA_ProcessStart;


# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ProcessModelVersionDeleteTrigger;

# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_TaskStartDeleteTrigger;
# Store Procedure to drop a foreign key constraint
CREATE PROCEDURE IWA_Drop_ForeignKey_Constraint(fk_schema VARCHAR(64), fk_table VARCHAR(64), fk_column VARCHAR(64))
BEGIN
  WHILE EXISTS(
    SELECT * FROM INFORMATION_SCHEMA.KEY_COLUMN_USAGE
    WHERE REFERENCED_COLUMN_NAME IS NOT NULL
      AND CAST(TABLE_SCHEMA AS CHAR CHARACTER SET ascii) COLLATE ascii_general_ci = CAST(fk_schema AS CHAR CHARACTER SET ascii)
      AND CAST(TABLE_NAME AS CHAR CHARACTER SET ascii) COLLATE ascii_general_ci = CAST(fk_table AS CHAR CHARACTER SET ascii)
      AND CAST(COLUMN_NAME AS CHAR CHARACTER SET ascii) COLLATE ascii_general_ci = CAST(fk_column AS CHAR CHARACTER SET ascii)
  ) 
  DO
    BEGIN
      SET @sqlstmt = (
        SELECT CONCAT('ALTER TABLE `',TABLE_SCHEMA,'`.',TABLE_NAME,' DROP FOREIGN KEY ',CONSTRAINT_NAME)
        FROM INFORMATION_SCHEMA.KEY_COLUMN_USAGE
        WHERE REFERENCED_COLUMN_NAME IS NOT NULL
          AND CAST(TABLE_SCHEMA AS CHAR CHARACTER SET ascii) COLLATE ascii_general_ci = CAST(fk_schema AS CHAR CHARACTER SET ascii)
          AND CAST(TABLE_NAME AS CHAR CHARACTER SET ascii) COLLATE ascii_general_ci = CAST(fk_table AS CHAR CHARACTER SET ascii)
          AND CAST(COLUMN_NAME AS CHAR CHARACTER SET ascii) COLLATE ascii_general_ci = CAST(fk_column AS CHAR CHARACTER SET ascii)
        LIMIT 1
      );
      PREPARE stmt1 FROM @sqlstmt;
      EXECUTE stmt1;
    END;
  END WHILE;
END;
;

CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_WebServiceProcStartElement', 'WebServiceProcessId');

# Drop no longer exisiting table
DROP TABLE IWA_StartElement;

# Drop no longer exisiting table
DROP TABLE IWA_StartEventElement;

# Drop no longer exisiting table
DROP TABLE IWA_WebServiceProcStartElement;

# Drop no longer exisiting table
DROP TABLE IWA_WebServiceProcess;

# Drop no longer exisiting table
DROP TABLE IWA_StartSignalEventElement;



# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ProcessModelVersionDeleteTrigger
AFTER DELETE ON IWA_ProcessModelVersion
FOR EACH ROW
BEGIN
  DELETE FROM IWA_TaskElement
  WHERE IWA_TaskElement.ProcessModelVersionId = OLD.ProcessModelVersionId;

  DELETE FROM IWA_PageElement
  WHERE IWA_PageElement.ProcessModelVersionId = OLD.ProcessModelVersionId;

END
;


# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_TaskStartDeleteTrigger
AFTER DELETE ON IWA_TaskStart
FOR EACH ROW
BEGIN
  DELETE FROM IWA_IntermediateEventElement
  WHERE IWA_IntermediateEventElement.TaskStartId = OLD.TaskStartId;

END
;


# Recreate views which has a new definition or depend on changed tables
CREATE VIEW IWA_CaseQuery
(
  CaseId,
  BusinessCaseId,
  Kind,
  ApplicationId,
  ProcessModelId,
  TaskStartId,
  ActivatorId,
  CreatorId,
  CreatorUserName,
  CreatorUserDisplayName,
  CreatorTaskId,
  EnvironmentId,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendar,
  WorkingTime,
  BusinessRuntime,
  `State`,
  Priority,
  Stage,
  OwnerId,
  OwnerName,
  OwnerDisplayName,
  Category
)
AS
  SELECT
    IWA_Case.CaseId,
    IWA_Case.BusinessCaseId,
    IWA_Case.Kind,
    IWA_Case.ApplicationId,
    IWA_Case.ProcessModelId,
    IWA_Case.TaskStartId,
    IWA_Case.ActivatorId,
    IWA_Case.CreatorId,
    Creator.Name,
    Creator.DisplayName,
    IWA_Case.CreatorTaskId,
    IWA_Case.EnvironmentId,
    IWA_Case.DisplayNameTemplate,
    IWA_Case.Name,
    IWA_Case.DisplayDescriptionTemplate,
    IWA_Case.Description,
    IWA_Case.StartTimestamp,
    IWA_Case.EndTimestamp,
    IWA_Case.BusinessCalendar,
    IWA_Case.WorkingTime,
    IWA_Case.BusinessRuntime,
    IWA_Case.`State`,
    IWA_Case.Priority,
    IWA_Case.Stage,
    IWA_Case.OwnerId,
    Owner.MemberName,
    Owner.DisplayName,
    IWA_Case.Category
  FROM IWA_Case
    LEFT OUTER JOIN IWA_SecurityMember AS Creator ON IWA_Case.CreatorId = Creator.SecurityMemberId
    LEFT OUTER JOIN IWA_SecurityMember AS Owner ON IWA_Case.OwnerId = Owner.SecurityMemberId;


# Drop temporary created stored procedures needed for conversion
DROP PROCEDURE IWA_Drop_ForeignKey_Constraint;

# 
# Update Version
# 
UPDATE IWA_Version SET Version=73;
