-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 72 to version 73
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Oracle
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------

-- Added columns of table IWA_Case
ALTER TABLE IWA_Case ADD
  ActivatorId VARCHAR2(210) REFERENCES IWA_SecurityMember(SecurityMemberId);


-- Migrate ActivatorId from IWA_ProcessStart View to IWA_Case
MERGE INTO IWA_Case c
USING (SELECT distinct TaskStartId, ActivatorId FROM IWA_ProcessStart) ps
ON (c.TaskStartId = ps.TaskStartId)
WHEN MATCHED THEN
  UPDATE SET c.ActivatorId = ps.ActivatorId;


-- Drop views which has a new definition or depend on changed tables
DROP VIEW IWA_CaseQuery;

DROP VIEW IWA_ProcessStart;

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_WEBSERVICEPROCSTARTELEMENT' AND UCC.COLUMN_NAME='WEBSERVICEPROCESSID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_WebServiceProcStartElement DROP CONSTRAINT ' || FK_NAME;
END;
;


-- Drop no longer exisiting table
DROP TABLE IWA_StartElement;

-- Drop no longer exisiting table
DROP TABLE IWA_StartEventElement;

-- Drop no longer exisiting table
DROP TABLE IWA_WebServiceProcStartElement;

-- Drop no longer exisiting table
DROP TABLE IWA_WebServiceProcess;

-- Drop no longer exisiting table
DROP TABLE IWA_StartSignalEventElement;



-- Recreate views which has a new definition or depend on changed tables
CREATE VIEW IWA_CaseQuery
(
  CaseId,
  BusinessCaseId,
  Kind,
  ApplicationId,
  ProcessModelId,
  TaskStartId,
  ActivatorId,
  CreatorId,
  CreatorUserName,
  CreatorUserDisplayName,
  CreatorTaskId,
  EnvironmentId,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendar,
  WorkingTime,
  BusinessRuntime,
  State,
  Priority,
  Stage,
  OwnerId,
  OwnerName,
  OwnerDisplayName,
  Category
)
AS
  SELECT
    IWA_Case.CaseId,
    IWA_Case.BusinessCaseId,
    IWA_Case.Kind,
    IWA_Case.ApplicationId,
    IWA_Case.ProcessModelId,
    IWA_Case.TaskStartId,
    IWA_Case.ActivatorId,
    IWA_Case.CreatorId,
    Creator.Name,
    Creator.DisplayName,
    IWA_Case.CreatorTaskId,
    IWA_Case.EnvironmentId,
    IWA_Case.DisplayNameTemplate,
    IWA_Case.Name,
    IWA_Case.DisplayDescriptionTemplate,
    IWA_Case.Description,
    IWA_Case.StartTimestamp,
    IWA_Case.EndTimestamp,
    IWA_Case.BusinessCalendar,
    IWA_Case.WorkingTime,
    IWA_Case.BusinessRuntime,
    IWA_Case.State,
    IWA_Case.Priority,
    IWA_Case.Stage,
    IWA_Case.OwnerId,
    Owner.MemberName,
    Owner.DisplayName,
    IWA_Case.Category
  FROM IWA_Case
    LEFT OUTER JOIN IWA_SecurityMember Creator ON IWA_Case.CreatorId = Creator.SecurityMemberId
    LEFT OUTER JOIN IWA_SecurityMember Owner ON IWA_Case.OwnerId = Owner.SecurityMemberId;



-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=73;
