# SQL script to convert the database for MySQL from version 74 to version 75


# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ApplicationDeleteTrigger;

# Drop no longer existing table
DROP TABLE IWA_ExternalNamingAndDirectory;

# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ApplicationDeleteTrigger
AFTER DELETE ON IWA_Application
FOR EACH ROW
BEGIN
  DELETE FROM IWA_Environment
  WHERE IWA_Environment.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ExternalDatabase
  WHERE IWA_ExternalDatabase.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_SignalEvent
  WHERE IWA_SignalEvent.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_Role
  WHERE IWA_Role.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ApplicationProperty
  WHERE IWA_ApplicationProperty.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_GlobalVariable
  WHERE IWA_GlobalVariable.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_RestServiceClient
  WHERE IWA_RestServiceClient.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_User
  WHERE IWA_User.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ProcessModel
  WHERE IWA_ProcessModel.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_SecurityMember
  WHERE IWA_SecurityMember.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_SecurityDescriptor
  WHERE IWA_SecurityDescriptor.SecurityDescriptorId = OLD.SecurityDescriptorId;

END
;


# Update Version
UPDATE IWA_Version SET Version=75;
