-- SQL script to convert the database for Microsoft SQL Server from version 75 to version 76


-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_TaskStartDeleteTrigger
GO

-- Drop trigger of no longer existing table
DROP TRIGGER IWA_IntermediateEventElementDeleteTrigger
GO

-- Drop no longer existing table
DROP TABLE IWA_IntermediateEventElement
GO

-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_TaskStartDeleteTrigger
  ON IWA_TaskStart FOR DELETE AS

  DELETE IWA_IntermediateEvent FROM IWA_IntermediateEvent, deleted
  WHERE IWA_IntermediateEvent.TaskStartId = deleted.TaskStartId


GO


-- Update Version
UPDATE IWA_Version SET Version=76
GO
