# SQL script to convert the database for MySQL from version 75 to version 76


# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_TaskStartDeleteTrigger;

# Drop trigger of no longer existing table
DROP TRIGGER IWA_IntermediateEventElementDeleteTrigger;

# Drop no longer existing table
DROP TABLE IWA_IntermediateEventElement;

# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_TaskStartDeleteTrigger
AFTER DELETE ON IWA_TaskStart
FOR EACH ROW
BEGIN
  DELETE FROM IWA_IntermediateEvent
  WHERE IWA_IntermediateEvent.TaskStartId = OLD.TaskStartId;

END
;


# Update Version
UPDATE IWA_Version SET Version=76;
