-- SQL script to convert the database for Oracle from version 75 to version 76

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_INTERMEDIATEEVENT' AND UCC.COLUMN_NAME='TASKSTARTID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_IntermediateEvent DROP CONSTRAINT ' || FK_NAME;
END;
;


-- Drop no longer existing table
DROP TABLE IWA_IntermediateEventElement;

-- Drop unique constraint which depend on changed columns or was deleted
ALTER TABLE IWA_IntermediateEvent DROP UNIQUE (TaskStartId, EventId) DROP INDEX;

-- Changed columns of table IWA_IntermediateEvent
ALTER TABLE IWA_IntermediateEvent MODIFY TaskStartId  NUMBER(20);

-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_IntermediateEvent ADD UNIQUE (TaskStartId, EventId);

ALTER TABLE IWA_IntermediateEvent ADD FOREIGN KEY (TaskStartId) REFERENCES IWA_TaskStart(TaskStartId) ON DELETE CASCADE;


-- Update Version
UPDATE IWA_Version SET Version=76;
