-- SQL script to convert the database for Oracle from version 77 to version 78

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_GLOBALVARIABLE' AND UCC.COLUMN_NAME='PARENTGLOBALVARIABLEID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_GlobalVariable DROP CONSTRAINT ' || FK_NAME;
END;
;


-- Drop no longer existing table
DROP TABLE IWA_GlobalVariable;

-- Update Version
UPDATE IWA_Version SET Version=78;
