-- SQL script to convert the database for Microsoft SQL Server from version 78 to version 79


-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ApplicationDeleteTrigger
GO

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_EnvironmentDeleteTrigger
GO

-- Drop trigger of no longer existing table
DROP TRIGGER IWA_ExternalDatabaseDeleteTrigger
GO

-- Drop no longer existing table
DROP TABLE IWA_ExternalDatabaseProperty
GO

-- Drop no longer existing table
DROP TABLE IWA_ExternalDatabase
GO

-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ApplicationDeleteTrigger
  ON IWA_Application FOR DELETE AS

  DELETE IWA_Environment FROM IWA_Environment, deleted
  WHERE IWA_Environment.ApplicationId = deleted.ApplicationId

  DELETE IWA_WebService FROM IWA_WebService, deleted
  WHERE IWA_WebService.ApplicationId = deleted.ApplicationId

  DELETE IWA_SignalEvent FROM IWA_SignalEvent, deleted
  WHERE IWA_SignalEvent.ApplicationId = deleted.ApplicationId

  DELETE IWA_Role FROM IWA_Role, deleted
  WHERE IWA_Role.ApplicationId = deleted.ApplicationId

  DELETE IWA_ApplicationProperty FROM IWA_ApplicationProperty, deleted
  WHERE IWA_ApplicationProperty.ApplicationId = deleted.ApplicationId

  DELETE IWA_RestServiceClient FROM IWA_RestServiceClient, deleted
  WHERE IWA_RestServiceClient.ApplicationId = deleted.ApplicationId

  DELETE IWA_User FROM IWA_User, deleted
  WHERE IWA_User.ApplicationId = deleted.ApplicationId

  DELETE IWA_ProcessModel FROM IWA_ProcessModel, deleted
  WHERE IWA_ProcessModel.ApplicationId = deleted.ApplicationId

  DELETE IWA_SecurityMember FROM IWA_SecurityMember, deleted
  WHERE IWA_SecurityMember.ApplicationId = deleted.ApplicationId

  DELETE IWA_SecurityDescriptor FROM IWA_SecurityDescriptor, deleted
  WHERE IWA_SecurityDescriptor.SecurityDescriptorId = deleted.SecurityDescriptorId


GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_EnvironmentDeleteTrigger
  ON IWA_Environment FOR DELETE AS

  UPDATE IWA_Case  SET IWA_Case.EnvironmentId=NULL
  FROM IWA_Case, deleted
  WHERE IWA_Case.EnvironmentId = deleted.EnvironmentId

  DELETE IWA_RestServiceClient FROM IWA_RestServiceClient, deleted
  WHERE IWA_RestServiceClient.EnvironmentId = deleted.EnvironmentId

  DELETE IWA_WebServiceEnvironment FROM IWA_WebServiceEnvironment, deleted
  WHERE IWA_WebServiceEnvironment.EnvironmentId = deleted.EnvironmentId


GO


-- Update Version
UPDATE IWA_Version SET Version=79
GO
