-- SQL script to convert the database for Oracle from version 78 to version 79

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_EXTERNALDATABASE' AND UCC.COLUMN_NAME='PARENTEXTERNALDATABASEID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_ExternalDatabase DROP CONSTRAINT ' || FK_NAME;
END;
;

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_EXTERNALDATABASEPROPERTY' AND UCC.COLUMN_NAME='EXTERNALDATABASEID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_ExternalDatabaseProperty DROP CONSTRAINT ' || FK_NAME;
END;
;


-- Drop no longer existing table
DROP TABLE IWA_ExternalDatabaseProperty;

-- Drop no longer existing table
DROP TABLE IWA_ExternalDatabase;

-- Update Version
UPDATE IWA_Version SET Version=79;
