-- SQL script to convert the database for Oracle from version 79 to version 80

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_RESTSERVICECLIENT' AND UCC.COLUMN_NAME='PARENTRESTCLIENTID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_RestServiceClient DROP CONSTRAINT ' || FK_NAME;
END;
;

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_RESTSERVICECLIENTPROPERTY' AND UCC.COLUMN_NAME='RESTCLIENTID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_RestServiceClientProperty DROP CONSTRAINT ' || FK_NAME;
END;
;

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_RESTSERVICECLIENTFEATURE' AND UCC.COLUMN_NAME='RESTCLIENTID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_RestServiceClientFeature DROP CONSTRAINT ' || FK_NAME;
END;
;


-- Drop no longer existing table
DROP TABLE IWA_RestServiceClientProperty;

-- Drop no longer existing table
DROP TABLE IWA_RestServiceClientFeature;

-- Drop no longer existing table
DROP TABLE IWA_RestServiceClient;

-- Update Version
UPDATE IWA_Version SET Version=80;
