-- SQL script to convert the database for Oracle from version 81 to version 82

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_WEBSERVICEFEATURE' AND UCC.COLUMN_NAME='WEBSERVICEENVIRONMENTID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_WebServiceFeature DROP CONSTRAINT ' || FK_NAME;
END;
;

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_WEBSERVICEPROPERTY' AND UCC.COLUMN_NAME='WEBSERVICEENVIRONMENTID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_WebServiceProperty DROP CONSTRAINT ' || FK_NAME;
END;
;

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_WEBSERVICEENDPOINT' AND UCC.COLUMN_NAME='WEBSERVICEENVIRONMENTID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_WebServiceEndpoint DROP CONSTRAINT ' || FK_NAME;
END;
;

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_WEBSERVICEENDPOINT' AND UCC.COLUMN_NAME='WEBSERVICEPORTTYPEID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_WebServiceEndpoint DROP CONSTRAINT ' || FK_NAME;
END;
;

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_WEBSERVICEENVIRONMENT' AND UCC.COLUMN_NAME='WEBSERVICEID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_WebServiceEnvironment DROP CONSTRAINT ' || FK_NAME;
END;
;

DECLARE
FK_NAME VARCHAR(30);
BEGIN
  SELECT UC.CONSTRAINT_NAME INTO FK_NAME
  FROM USER_CONSTRAINTS UC INNER JOIN USER_CONS_COLUMNS UCC ON UC.CONSTRAINT_NAME = UCC.CONSTRAINT_NAME
  WHERE UC.CONSTRAINT_TYPE='R' AND UC.TABLE_NAME='IWA_WEBSERVICEPORTTYPE' AND UCC.COLUMN_NAME='WEBSERVICEID';

  EXECUTE IMMEDIATE 'ALTER TABLE IWA_WebServicePortType DROP CONSTRAINT ' || FK_NAME;
END;
;


-- Drop no longer existing table
DROP TABLE IWA_WebServiceFeature;

-- Drop no longer existing table
DROP TABLE IWA_WebServiceProperty;

-- Drop no longer existing table
DROP TABLE IWA_WebServiceEndpoint;

-- Drop no longer existing table
DROP TABLE IWA_WebServiceEnvironment;

-- Drop no longer existing table
DROP TABLE IWA_WebServicePortType;

-- Drop no longer existing table
DROP TABLE IWA_WebService;

-- Update Version
UPDATE IWA_Version SET Version=82;
