# SQL script to convert the database for MySQL from version 86 to version 87


# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ApplicationDeleteTrigger;

# Drop no longer existing table
DROP TABLE IWA_ApplicationProperty;

# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ApplicationDeleteTrigger
AFTER DELETE ON IWA_Application
FOR EACH ROW
BEGIN
  DELETE FROM IWA_SignalEvent
  WHERE IWA_SignalEvent.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_Role
  WHERE IWA_Role.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_User
  WHERE IWA_User.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ProcessModel
  WHERE IWA_ProcessModel.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_SecurityMember
  WHERE IWA_SecurityMember.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_SecurityDescriptor
  WHERE IWA_SecurityDescriptor.SecurityDescriptorId = OLD.SecurityDescriptorId;

END
;


# Update Version
UPDATE IWA_Version SET Version=87;
