-- SQL script to convert the database for Postgre SQL from version 87 to version 88

-- Drop views which has a new definition or depend on changed tables
DROP VIEW IWA_SignalEventQuery;

-- Drop no longer existing table
DROP TABLE IWA_Language;

-- Dropped columns of table IWA_User
ALTER TABLE IWA_User DROP COLUMN EMailLanguageId;


-- Recreate views which has a new definition or depend on changed tables
CREATE VIEW IWA_SignalEventQuery
(
  SignalEventId,
  ApplicationId,
  SignalCode,
  SentTimestamp,
  SentById,
  SentByUserName,
  SentByUserId,
  SentByTaskId,
  SentByProcessElementPid
)
AS
  SELECT
    IWA_SignalEvent.SignalEventId,
    IWA_SignalEvent.ApplicationId,
    IWA_SignalEvent.SignalCode,
    IWA_SignalEvent.SentTimestamp,
    IWA_SignalEvent.SentById,
    IWA_SecurityMember.Name,
    IWA_User.UserId,
    IWA_SignalEvent.SentByTaskId,
    IWA_SignalEvent.SentByProcessElementPid
  FROM IWA_SignalEvent
    LEFT OUTER JOIN IWA_SecurityMember ON IWA_SignalEvent.SentById = IWA_SecurityMember.SecurityMemberId
    LEFT OUTER JOIN IWA_User ON IWA_SecurityMember.SecurityMemberId = IWA_User.SecurityMemberId;


-- Update Version
UPDATE IWA_Version SET Version=89;
