-- SQL script to convert the database for Microsoft SQL Server from version 90 to version 91

UPDATE IWA_UserProperty SET SecurityMemberId = (SELECT SecurityMemberId FROM IWA_User WHERE IWA_User.UserId = IWA_UserProperty.UserId)
GO

UPDATE IWA_RoleProperty SET SecurityMemberId = (SELECT SecurityMemberId FROM IWA_Role WHERE IWA_Role.RoleId = IWA_RoleProperty.RoleId)
GO

UPDATE IWA_UserAbsence SET SecurityMemberId = (SELECT SecurityMemberId FROM IWA_User WHERE IWA_User.UserId = IWA_UserAbsence.UserId)
GO

UPDATE IWA_UserSubstitute SET SecurityMemberId = (SELECT SecurityMemberId FROM IWA_User WHERE IWA_User.UserId = IWA_UserSubstitute.UserId)
GO

UPDATE IWA_UserSubstitute SET SubstituteUserSecurityMemberId = (SELECT SecurityMemberId FROM IWA_User WHERE IWA_User.UserId = IWA_UserSubstitute.SubstituteUserId) 
GO

UPDATE IWA_UserSubstitute SET SubstituteRoleSecurityMemberId = (SELECT SecurityMemberId FROM IWA_Role WHERE IWA_Role.RoleId = IWA_UserSubstitute.SubstituteForRoleId)
GO

UPDATE IWA_Note SET SecurityMemberId = (SELECT SecurityMemberId FROM IWA_User WHERE IWA_User.UserId = IWA_Note.UserId)
GO

UPDATE IWA_UserLocation SET SecurityMemberId = (SELECT SecurityMemberId FROM IWA_User WHERE IWA_User.UserId = IWA_UserLocation.UserId)
GO

UPDATE IWA_AccessControl SET SecurityMemberId = CASE
    WHEN UserId IS NOT NULL THEN (SELECT SecurityMemberId FROM IWA_User WHERE IWA_User.UserId = IWA_AccessControl.UserId)
    ELSE (SELECT SecurityMemberId FROM IWA_Role WHERE IWA_Role.RoleId = IWA_AccessControl.RoleId)
END
GO

-- Update Version
UPDATE IWA_Version SET Version=91;
GO
