-- SQL script to convert the database for Oracle from version 91 to version 92


-- Drop removed indexes of table IWA_UserAbsence
DROP INDEX IWA_UserAbsence_UserIdIndex;

-- Drop removed indexes of table IWA_UserSubstitute
DROP INDEX IWA_UserSubstitute_UserIdIndex;
DROP INDEX IWA_UserSbsttt_SbstttUsrIdIdx;

-- Drop removed indexes of table IWA_Note
DROP INDEX IWA_Note_UserIdIndex;

-- Drop removed indexes of table IWA_UserLocation
DROP INDEX IWA_UserLocation_UserId;

-- Drop unique constraint which depend on changed columns or was deleted
-- ALTER TABLE IWA_RoleProperty DROP UNIQUE (SecurityMemberId, PropertyName) DROP INDEX;
ALTER TABLE IWA_RoleProperty DROP UNIQUE (RoleId, PropertyName) DROP INDEX;

-- Dropped columns of table IWA_RoleProperty
ALTER TABLE IWA_RoleProperty DROP COLUMN RoleId;


-- Changed columns of table IWA_RoleProperty
ALTER TABLE IWA_RoleProperty MODIFY SecurityMemberId  VARCHAR2(210);
ALTER TABLE IWA_RoleProperty MODIFY SecurityMemberId NOT NULL;

-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_RoleProperty ADD UNIQUE (SecurityMemberId, PropertyName);


-- Drop unique constraint which depend on changed columns or was deleted
-- ALTER TABLE IWA_UserProperty DROP UNIQUE (SecurityMemberId, PropertyName) DROP INDEX;
ALTER TABLE IWA_UserProperty DROP UNIQUE (UserId, PropertyName) DROP INDEX;

-- Dropped columns of table IWA_UserProperty
ALTER TABLE IWA_UserProperty DROP COLUMN UserId;


-- Changed columns of table IWA_UserProperty
ALTER TABLE IWA_UserProperty MODIFY SecurityMemberId  VARCHAR2(210);
ALTER TABLE IWA_UserProperty MODIFY SecurityMemberId NOT NULL;

-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_UserProperty ADD UNIQUE (SecurityMemberId, PropertyName);


-- Dropped columns of table IWA_UserAbsence
ALTER TABLE IWA_UserAbsence DROP COLUMN UserId;


-- Changed columns of table IWA_UserAbsence
ALTER TABLE IWA_UserAbsence MODIFY SecurityMemberId  VARCHAR2(210);
ALTER TABLE IWA_UserAbsence MODIFY SecurityMemberId NOT NULL;


-- Drop unique constraint which depend on changed columns or was deleted
-- ALTER TABLE IWA_UserSubstitute DROP UNIQUE (SecurityMemberId, SubstituteUserSecurityMemberId, SubstituteRoleSecurityMemberId) DROP INDEX;
ALTER TABLE IWA_UserSubstitute DROP UNIQUE (UserId, SubstituteUserId, SubstituteForRoleId) DROP INDEX;

-- Dropped columns of table IWA_UserSubstitute
ALTER TABLE IWA_UserSubstitute DROP COLUMN UserId;

ALTER TABLE IWA_UserSubstitute DROP COLUMN SubstituteUserId;

ALTER TABLE IWA_UserSubstitute DROP COLUMN SubstituteForRoleId;


-- Changed columns of table IWA_UserSubstitute
ALTER TABLE IWA_UserSubstitute MODIFY SecurityMemberId  VARCHAR2(210);
ALTER TABLE IWA_UserSubstitute MODIFY SecurityMemberId NOT NULL;
ALTER TABLE IWA_UserSubstitute MODIFY SubstituteUserSecurityMemberId  VARCHAR2(210);
ALTER TABLE IWA_UserSubstitute MODIFY SubstituteUserSecurityMemberId NOT NULL;

-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_UserSubstitute ADD UNIQUE (SecurityMemberId, SubstituteUserSecurityMemberId, SubstituteRoleSecurityMemberId);


-- Dropped columns of table IWA_Note
ALTER TABLE IWA_Note DROP COLUMN UserId;


-- Dropped columns of table IWA_UserLocation
ALTER TABLE IWA_UserLocation DROP COLUMN UserId;


-- Changed columns of table IWA_UserLocation
ALTER TABLE IWA_UserLocation MODIFY SecurityMemberId  VARCHAR2(210);
ALTER TABLE IWA_UserLocation MODIFY SecurityMemberId NOT NULL;


-- Drop unique constraint which depend on changed columns or was deleted
-- ALTER TABLE IWA_AccessControl DROP UNIQUE (SecurityDescriptorId, PermissionId, SecurityMemberId) DROP INDEX;

ALTER TABLE IWA_AccessControl DROP UNIQUE (SecurityDescriptorId, PermissionId, RoleId, UserId) DROP INDEX;

-- Dropped columns of table IWA_AccessControl
ALTER TABLE IWA_AccessControl DROP COLUMN RoleId;

ALTER TABLE IWA_AccessControl DROP COLUMN UserId;


-- Changed columns of table IWA_AccessControl
ALTER TABLE IWA_AccessControl MODIFY SecurityMemberId  VARCHAR2(210);
ALTER TABLE IWA_AccessControl MODIFY SecurityMemberId NOT NULL;

-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_AccessControl ADD UNIQUE (SecurityDescriptorId, PermissionId, SecurityMemberId);


-- Create new indexes of table IWA_RoleProperty
DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_RoleProperty_SecurityMemberIdIndex ON IWA_RoleProperty (SecurityMemberId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

-- Update Version
UPDATE IWA_Version SET Version=92;
