-- SQL script to convert the database for Postgre SQL from version 91 to version 92


-- Drop removed indexes of table IWA_UserAbsence
DROP INDEX IWA_UserAbsence_UserIdIndex;

-- Drop removed indexes of table IWA_UserSubstitute
DROP INDEX IWA_UserSubstitute_UserIdIndex;
DROP INDEX IWA_UserSbsttt_SbstttUsrIdIdx;

-- Drop removed indexes of table IWA_Note
DROP INDEX IWA_Note_UserIdIndex;

-- Drop removed indexes of table IWA_UserLocation
DROP INDEX IWA_UserLocation_UserId;

-- Drop unique constraint which depend on changed columns or was deleted
ALTER TABLE IWA_RoleProperty DROP CONSTRAINT IWA_RoleProperty_RoleId_PropertyName_Key CASCADE;

-- Dropped columns of table IWA_RoleProperty
ALTER TABLE IWA_RoleProperty DROP COLUMN RoleId;


-- Changed columns of table IWA_RoleProperty
ALTER TABLE IWA_RoleProperty ALTER COLUMN SecurityMemberId TYPE VARCHAR(210);
ALTER TABLE IWA_RoleProperty ALTER COLUMN SecurityMemberId SET NOT NULL;


-- Drop unique constraint which depend on changed columns or was deleted
ALTER TABLE IWA_UserProperty DROP CONSTRAINT IWA_UserProperty_UserId_PropertyName_Key CASCADE;

-- Dropped columns of table IWA_UserProperty
ALTER TABLE IWA_UserProperty DROP COLUMN UserId;


-- Changed columns of table IWA_UserProperty
ALTER TABLE IWA_UserProperty ALTER COLUMN SecurityMemberId TYPE VARCHAR(210);
ALTER TABLE IWA_UserProperty ALTER COLUMN SecurityMemberId SET NOT NULL;


-- Dropped columns of table IWA_UserAbsence
ALTER TABLE IWA_UserAbsence DROP COLUMN UserId;


-- Changed columns of table IWA_UserAbsence
ALTER TABLE IWA_UserAbsence ALTER COLUMN SecurityMemberId TYPE VARCHAR(210);
ALTER TABLE IWA_UserAbsence ALTER COLUMN SecurityMemberId SET NOT NULL;


-- Drop unique constraint which depend on changed columns or was deleted
--ALTER TABLE IWA_UserSubstitute DROP CONSTRAINT IWA_UserSubstitute_UserId_SubstituteUserId_SubstituteForRoleId_Key CASCADE;

-- Dropped columns of table IWA_UserSubstitute
ALTER TABLE IWA_UserSubstitute DROP COLUMN UserId;

ALTER TABLE IWA_UserSubstitute DROP COLUMN SubstituteUserId;

ALTER TABLE IWA_UserSubstitute DROP COLUMN SubstituteForRoleId;


-- Changed columns of table IWA_UserSubstitute
ALTER TABLE IWA_UserSubstitute ALTER COLUMN SecurityMemberId TYPE VARCHAR(210);
ALTER TABLE IWA_UserSubstitute ALTER COLUMN SecurityMemberId SET NOT NULL;
ALTER TABLE IWA_UserSubstitute ALTER COLUMN SubstituteUserSecurityMemberId TYPE VARCHAR(210);
ALTER TABLE IWA_UserSubstitute ALTER COLUMN SubstituteUserSecurityMemberId SET NOT NULL;


-- Dropped columns of table IWA_Note
ALTER TABLE IWA_Note DROP COLUMN UserId;


-- Dropped columns of table IWA_UserLocation
ALTER TABLE IWA_UserLocation DROP COLUMN UserId;


-- Changed columns of table IWA_UserLocation
ALTER TABLE IWA_UserLocation ALTER COLUMN SecurityMemberId TYPE VARCHAR(210);
ALTER TABLE IWA_UserLocation ALTER COLUMN SecurityMemberId SET NOT NULL;


-- Dropped columns of table IWA_AccessControl
ALTER TABLE IWA_AccessControl DROP COLUMN RoleId;

ALTER TABLE IWA_AccessControl DROP COLUMN UserId;


-- Changed columns of table IWA_AccessControl
ALTER TABLE IWA_AccessControl ALTER COLUMN SecurityMemberId TYPE VARCHAR(210);
ALTER TABLE IWA_AccessControl ALTER COLUMN SecurityMemberId SET NOT NULL;
ALTER TABLE IWA_AccessControl ADD UNIQUE (SecurityDescriptorId, PermissionId, SecurityMemberId);


-- Create new indexes of table IWA_RoleProperty
CREATE INDEX IF NOT EXISTS IWA_RoleProperty_SecurityMemberIdIndex
ON IWA_RoleProperty (SecurityMemberId varchar_pattern_ops);


-- Create new unique constraint of table IWA_RoleProperty
ALTER TABLE IWA_RoleProperty ADD UNIQUE (SecurityMemberId, PropertyName);


-- Create new unique constraint of table IWA_UserProperty
ALTER TABLE IWA_UserProperty ADD UNIQUE (SecurityMemberId, PropertyName);


-- Create new unique constraint of table IWA_UserSubstitute
ALTER TABLE IWA_UserSubstitute ADD UNIQUE (SecurityMemberId, SubstituteUserSecurityMemberId, SubstituteRoleSecurityMemberId);


-- Update Version
UPDATE IWA_Version SET Version=92;
