-- SQL script to convert the database for Microsoft SQL Server from version 92 to version 93


-- Add column ParentSecurityMemberId to table IWA_Role
ALTER TABLE IWA_Role ADD
  ParentSecurityMemberId VARCHAR(210)
GO

-- Create index IWA_Role_ParentSecurityMemberIdIndex
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Role') AND name='IWA_Role_ParentSecurityMemberIdIndex')
  CREATE INDEX IWA_Role_ParentSecurityMemberIdIndex ON IWA_Role (ParentSecurityMemberId)
GO

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_RoleDeleteTrigger
GO

-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_RoleDeleteTrigger
  ON IWA_Role FOR DELETE AS
  IF (@@ROWCOUNT > 0)
  BEGIN

    DELETE IWA_UserRole FROM IWA_UserRole, deleted
    WHERE IWA_UserRole.RoleId = deleted.RoleId

    DELETE IWA_Role FROM IWA_Role, deleted
    WHERE IWA_Role.ParentRoleId = deleted.RoleId

    DELETE IWA_Role FROM IWA_Role, deleted
    WHERE IWA_Role.ParentSecurityMemberId = deleted.SecurityMemberId

    DELETE IWA_RoleRoleMember FROM IWA_RoleRoleMember, deleted
    WHERE IWA_RoleRoleMember.RoleId = deleted.RoleId

    DELETE IWA_RoleRoleMember FROM IWA_RoleRoleMember, deleted
    WHERE IWA_RoleRoleMember.RoleMemberId = deleted.RoleId

    END
GO

-- Update Version
UPDATE IWA_Version SET Version=93
GO
