-- SQL script to convert the database for Oracle from version 92 to version 93

ALTER TABLE IWA_Role ADD
  ParentSecurityMemberId VARCHAR(210) REFERENCES IWA_Role(SecurityMemberId) ON DELETE CASCADE;

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_Role_ParentSecurityMemberIdIndex ON IWA_Role (ParentSecurityMemberId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

-- Update Version
UPDATE IWA_Version SET Version=93;
