-- SQL script to convert the database for Microsoft SQL Server from version 94 to version 95


-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_RoleDeleteTrigger
GO

-- Dropped columns of table IWA_Role
ALTER TABLE IWA_Role DROP COLUMN ParentRoleId
GO

-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_RoleDeleteTrigger
  ON IWA_Role FOR DELETE AS
  IF (@@ROWCOUNT > 0)
  BEGIN

    DELETE IWA_UserRole FROM IWA_UserRole, deleted
    WHERE IWA_UserRole.RoleId = deleted.RoleId

    DELETE IWA_Role FROM IWA_Role, deleted
    WHERE IWA_Role.ParentSecurityMemberId = deleted.SecurityMemberId

    DELETE IWA_RoleRoleMember FROM IWA_RoleRoleMember, deleted
    WHERE IWA_RoleRoleMember.RoleId = deleted.RoleId

    DELETE IWA_RoleRoleMember FROM IWA_RoleRoleMember, deleted
    WHERE IWA_RoleRoleMember.RoleMemberId = deleted.RoleId

    END
GO

-- Update Version
UPDATE IWA_Version SET Version=95
GO
