# SQL script to convert the database for MySQL from version 95 to version 96

# Added columns of table IWA_UserRole
ALTER TABLE IWA_UserRole ADD COLUMN
  RoleSecurityMemberId VARCHAR(210);
ALTER TABLE IWA_UserRole ADD COLUMN
  UserSecurityMemberId VARCHAR(210);


# Find SecurityMemberId of UserId and set it
UPDATE IWA_UserRole SET
  RoleSecurityMemberId = (SELECT SecurityMemberId FROM IWA_Role t WHERE t.RoleId = IWA_UserRole.RoleId),
  UserSecurityMemberId = (SELECT SecurityMemberId FROM IWA_User t WHERE t.UserId = IWA_UserRole.UserId);


DROP TRIGGER IWA_UserDeleteTrigger;


ALTER TABLE IWA_UserRole DROP PRIMARY KEY;
ALTER TABLE IWA_UserRole ADD PRIMARY KEY (RoleSecurityMemberId, UserSecurityMemberId);


# Dropped columns of table IWA_UserRole
ALTER TABLE IWA_UserRole DROP COLUMN UserId;
ALTER TABLE IWA_UserRole DROP COLUMN RoleId;

ALTER TABLE IWA_UserRole MODIFY RoleSecurityMemberId VARCHAR(210) NOT NULL;
ALTER TABLE IWA_UserRole MODIFY UserSecurityMemberId VARCHAR(210) NOT NULL;

ALTER TABLE IWA_UserRole ADD FOREIGN KEY (RoleSecurityMemberId) REFERENCES IWA_Role(SecurityMemberId) ON DELETE CASCADE;
ALTER TABLE IWA_UserRole ADD FOREIGN KEY (UserSecurityMemberId) REFERENCES IWA_User(SecurityMemberId) ON DELETE CASCADE;

# Update Version
UPDATE IWA_Version SET Version=96;
