-- SQL script to convert the database for Postgre SQL from version 95 to version 96

-- Added columns of table IWA_UserRole
ALTER TABLE IWA_UserRole ADD COLUMN
  RoleSecurityMemberId VARCHAR(210) REFERENCES IWA_Role(SecurityMemberId) ON DELETE CASCADE;
ALTER TABLE IWA_UserRole ADD COLUMN
  UserSecurityMemberId VARCHAR(210) REFERENCES IWA_User(SecurityMemberId) ON DELETE CASCADE;


-- Find SecurityMemberId of UserId and set it
UPDATE IWA_UserRole SET
  RoleSecurityMemberId = (SELECT SecurityMemberId FROM IWA_Role t WHERE t.RoleId = IWA_UserRole.RoleId),
  UserSecurityMemberId = (SELECT SecurityMemberId FROM IWA_User t WHERE t.UserId = IWA_UserRole.UserId);


-- Dropped columns of table IWA_UserRole
ALTER TABLE IWA_UserRole DROP COLUMN RoleId;
ALTER TABLE IWA_UserRole DROP COLUMN UserId;

ALTER TABLE IWA_UserRole ADD PRIMARY KEY (RoleSecurityMemberId, UserSecurityMemberId);

-- set to not null
ALTER TABLE IWA_UserRole ALTER COLUMN RoleSecurityMemberId SET NOT NULL;
ALTER TABLE IWA_UserRole ALTER COLUMN UserSecurityMemberId SET NOT NULL;


-- Update Version
UPDATE IWA_Version SET Version=96;
