-- SQL script to convert the database for Microsoft SQL Server from version 96 to version 97


-- Store Procedure to drop a primary key constraint
CREATE PROCEDURE IWA_Drop_PrimaryKey
@tableName varchar(100)
AS
DECLARE @pkName Varchar(255)
SET @pkName= (
  SELECT [name] FROM sysobjects
    WHERE [xtype] = 'PK'
          AND [parent_obj] = OBJECT_ID(N'[dbo].['+@tableName+N']')
)
DECLARE @dropSql varchar(4000)
SET @dropSql=
  'ALTER TABLE [dbo].['+@tableName+']
    DROP CONSTRAINT ['+@PkName+']'
EXEC(@dropSql)

GO

EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_RoleRoleMember'
GO

DROP PROCEDURE IWA_Drop_PrimaryKey
GO

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_RoleDeleteTrigger
GO

-- Added columns of table IWA_RoleRoleMember
ALTER TABLE IWA_RoleRoleMember ADD
  RoleSecurityMemberId VARCHAR(210)
GO
ALTER TABLE IWA_RoleRoleMember ADD
  RoleMemberSecurityMemberId VARCHAR(210)
GO

-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_RoleDeleteTrigger
  ON IWA_Role FOR DELETE AS
  IF (@@ROWCOUNT > 0)
  BEGIN

    DELETE IWA_Role FROM IWA_Role, deleted
    WHERE IWA_Role.ParentSecurityMemberId = deleted.SecurityMemberId

    END
GO


-- Find SecurityMemberId of RoleId and set it
UPDATE IWA_RoleRoleMember SET
  RoleSecurityMemberId = (SELECT SecurityMemberId FROM IWA_Role t WHERE t.RoleId = IWA_RoleRoleMember.RoleId),
  RoleMemberSecurityMemberId = (SELECT SecurityMemberId FROM IWA_Role t WHERE t.RoleId = IWA_RoleRoleMember.RoleMemberId)
GO

-- Dropped columns of table IWA_RoleRoleMember
ALTER TABLE IWA_RoleRoleMember DROP COLUMN RoleId
GO

ALTER TABLE IWA_RoleRoleMember DROP COLUMN RoleMemberId
GO

ALTER TABLE IWA_RoleRoleMember ALTER COLUMN RoleSecurityMemberId VARCHAR(210) NOT NULL
GO
ALTER TABLE IWA_RoleRoleMember ALTER COLUMN RoleMemberSecurityMemberId VARCHAR(210) NOT NULL
GO

ALTER TABLE IWA_RoleRoleMember ADD PRIMARY KEY (RoleSecurityMemberId, RoleMemberSecurityMemberId)
GO

-- Update Version
UPDATE IWA_Version SET Version=97
GO
