# SQL script to convert the database for MySQL from version 96 to version 97

# Added columns of table IWA_RoleRoleMember
ALTER TABLE IWA_RoleRoleMember ADD COLUMN
  RoleSecurityMemberId VARCHAR(210);
ALTER TABLE IWA_RoleRoleMember ADD COLUMN
  RoleMemberSecurityMemberId VARCHAR(210);


# Find SecurityMemberId of RoleId and set it
UPDATE IWA_RoleRoleMember SET
  RoleSecurityMemberId = (SELECT SecurityMemberId FROM IWA_Role t WHERE t.RoleId = IWA_RoleRoleMember.RoleId),
  RoleMemberSecurityMemberId = (SELECT SecurityMemberId FROM IWA_Role t WHERE t.RoleId = IWA_RoleRoleMember.RoleMemberId);

DROP TRIGGER IWA_RoleDeleteTrigger;

ALTER TABLE IWA_RoleRoleMember DROP PRIMARY KEY;
ALTER TABLE IWA_RoleRoleMember ADD PRIMARY KEY (RoleSecurityMemberId, RoleMemberSecurityMemberId); 


# Dropped columns of table IWA_RoleRoleMember
ALTER TABLE IWA_RoleRoleMember DROP COLUMN RoleId;
ALTER TABLE IWA_RoleRoleMember DROP COLUMN RoleMemberId;

ALTER TABLE IWA_RoleRoleMember MODIFY RoleSecurityMemberId VARCHAR(210) NOT NULL;
ALTER TABLE IWA_RoleRoleMember MODIFY RoleMemberSecurityMemberId VARCHAR(210) NOT NULL;

ALTER TABLE IWA_RoleRoleMember ADD FOREIGN KEY (RoleSecurityMemberId) REFERENCES IWA_Role(SecurityMemberId) ON DELETE CASCADE;
ALTER TABLE IWA_RoleRoleMember ADD FOREIGN KEY (RoleMemberSecurityMemberId) REFERENCES IWA_Role(SecurityMemberId) ON DELETE CASCADE;

# Update Version
UPDATE IWA_Version SET Version=97;
