-- SQL script to convert the database for Oracle from version 96 to version 97

-- Added columns of table IWA_RoleRoleMember
ALTER TABLE IWA_RoleRoleMember ADD
  RoleSecurityMemberId VARCHAR2(210) REFERENCES IWA_Role(SecurityMemberId) ON DELETE CASCADE;
ALTER TABLE IWA_RoleRoleMember ADD
  RoleMemberSecurityMemberId VARCHAR2(210) REFERENCES IWA_Role(SecurityMemberId) ON DELETE CASCADE;


-- Find SecurityMemberId of RoleId and set it
UPDATE IWA_RoleRoleMember SET
  RoleSecurityMemberId = (SELECT SecurityMemberId FROM IWA_Role t WHERE t.RoleId = IWA_RoleRoleMember.RoleId),
  RoleMemberSecurityMemberId = (SELECT SecurityMemberId FROM IWA_Role t WHERE t.RoleId = IWA_RoleRoleMember.RoleMemberId);


ALTER TABLE IWA_RoleRoleMember DROP PRIMARY KEY;
ALTER TABLE IWA_RoleRoleMember ADD PRIMARY KEY (RoleSecurityMemberId, RoleMemberSecurityMemberId); 

-- Dropped columns of table IWA_RoleRoleMember
ALTER TABLE IWA_RoleRoleMember DROP COLUMN RoleId;
ALTER TABLE IWA_RoleRoleMember DROP COLUMN RoleMemberId;

-- set to not null
ALTER TABLE IWA_RoleRoleMember MODIFY RoleSecurityMemberId NOT NULL;
ALTER TABLE IWA_RoleRoleMember MODIFY RoleMemberSecurityMemberId NOT NULL;

-- Update Version
UPDATE IWA_Version SET Version=97;
