-- SQL script to convert the database for Postgre SQL from version 96 to version 97

-- Added columns of table IWA_RoleRoleMember
ALTER TABLE IWA_RoleRoleMember ADD COLUMN
  RoleSecurityMemberId VARCHAR(210) REFERENCES IWA_Role(SecurityMemberId) ON DELETE CASCADE;
ALTER TABLE IWA_RoleRoleMember ADD COLUMN
  RoleMemberSecurityMemberId VARCHAR(210) REFERENCES IWA_Role(SecurityMemberId) ON DELETE CASCADE;
  
  
-- Find SecurityMemberId of RoleId and set it
UPDATE IWA_RoleRoleMember SET
  RoleSecurityMemberId = (SELECT SecurityMemberId FROM IWA_Role t WHERE t.RoleId = IWA_RoleRoleMember.RoleId),
  RoleMemberSecurityMemberId = (SELECT SecurityMemberId FROM IWA_Role t WHERE t.RoleId = IWA_RoleRoleMember.RoleMemberId);


-- Dropped columns of table IWA_RoleRoleMember
ALTER TABLE IWA_RoleRoleMember DROP COLUMN RoleId;
ALTER TABLE IWA_RoleRoleMember DROP COLUMN RoleMemberId;

ALTER TABLE IWA_RoleRoleMember ADD PRIMARY KEY (RoleSecurityMemberId, RoleMemberSecurityMemberId);


-- set to not null
ALTER TABLE IWA_RoleRoleMember ALTER COLUMN RoleSecurityMemberId SET NOT NULL;
ALTER TABLE IWA_RoleRoleMember ALTER COLUMN RoleMemberSecurityMemberId SET NOT NULL;


-- Update Version
UPDATE IWA_Version SET Version=97;
