# SQL script to convert the database for MySQL from version 97 to version 98

# Drop views which has a new definition or depend on changed tables
DROP VIEW IWA_SignalEventQuery;

# Drop unique constraint which depend on changed columns or was deleted
ALTER TABLE IWA_User DROP PRIMARY KEY;
ALTER TABLE IWA_Role DROP PRIMARY KEY;

ALTER TABLE IWA_User ADD PRIMARY KEY (SecurityMemberId); 
ALTER TABLE IWA_Role ADD PRIMARY KEY (SecurityMemberId); 

ALTER TABLE IWA_User DROP INDEX SecurityMemberId;
ALTER TABLE IWA_Role DROP INDEX SecurityMemberId;

# Recreate views which has a new definition or depend on changed tables
CREATE VIEW IWA_SignalEventQuery
(
  SignalEventId,
  ApplicationId,
  SignalCode,
  SentTimestamp,
  SentById,
  SentByUserName,
  SentByUserId,
  SentByTaskId,
  SentByProcessElementPid
)
AS
  SELECT
    IWA_SignalEvent.SignalEventId,
    IWA_SignalEvent.ApplicationId,
    IWA_SignalEvent.SignalCode,
    IWA_SignalEvent.SentTimestamp,
    IWA_SignalEvent.SentById,
    IWA_SecurityMember.Name,
    IWA_User.UserId,
    IWA_SignalEvent.SentByTaskId,
    IWA_SignalEvent.SentByProcessElementPid
  FROM IWA_SignalEvent
    LEFT OUTER JOIN IWA_SecurityMember ON IWA_SignalEvent.SentById = IWA_SecurityMember.SecurityMemberId
    LEFT OUTER JOIN IWA_User ON IWA_SecurityMember.SecurityMemberId = IWA_User.SecurityMemberId;


# making ex primary keys unique
ALTER TABLE IWA_Role ADD UNIQUE (RoleId);
ALTER TABLE IWA_User ADD UNIQUE (UserId);


# Update Version
UPDATE IWA_Version SET Version=98;

