-- migrate mssql from version 99 to version 100

-- drop views
DROP VIEW IWA_SignalEventQuery
GO
DROP VIEW IWA_TaskQuery
GO
DROP VIEW IWA_CaseQuery
GO

-- drop trigger
DROP TRIGGER IWA_ApplicationDeleteTrigger
GO

-- add columns
ALTER TABLE IWA_SecurityMember ADD SecuritySystemId BIGINT NULL REFERENCES IWA_SecuritySystem(SecuritySystemId)
GO
ALTER TABLE IWA_Role ADD SecuritySystemId BIGINT NULL REFERENCES IWA_SecuritySystem(SecuritySystemId)
GO
ALTER TABLE IWA_User ADD SecuritySystemId BIGINT NULL REFERENCES IWA_SecuritySystem(SecuritySystemId)
GO
ALTER TABLE IWA_Case ADD SecuritySystemId BIGINT NULL REFERENCES IWA_SecuritySystem(SecuritySystemId)
GO
ALTER TABLE IWA_Task ADD SecuritySystemId BIGINT NULL REFERENCES IWA_SecuritySystem(SecuritySystemId)
GO
ALTER TABLE IWA_WorkflowEvent ADD SecuritySystemId BIGINT NULL REFERENCES IWA_SecuritySystem(SecuritySystemId)
GO
ALTER TABLE IWA_SignalEvent ADD SecuritySystemId BIGINT NULL REFERENCES IWA_SecuritySystem(SecuritySystemId)
GO
ALTER TABLE IWA_IntermediateEvent ADD SecuritySystemId BIGINT NULL REFERENCES IWA_SecuritySystem(SecuritySystemId)
GO
ALTER TABLE IWA_SecuritySystem ADD SecurityDescriptorId BIGINT NULL REFERENCES IWA_SecurityDescriptor(SecurityDescriptorId)
GO

-- nullable
ALTER TABLE IWA_Role ALTER COLUMN ApplicationId BIGINT NULL
GO
ALTER TABLE IWA_SignalEvent ALTER COLUMN ApplicationId BIGINT NULL
GO
ALTER TABLE IWA_SignalEvent ADD FOREIGN KEY (ApplicationId) REFERENCES IWA_Application(ApplicationId) ON DELETE CASCADE; 
GO

-- trigger
CREATE TRIGGER IWA_ApplicationDeleteTrigger
  ON IWA_Application FOR DELETE AS

  DELETE IWA_Role FROM IWA_Role, deleted
  WHERE IWA_Role.ApplicationId = deleted.ApplicationId

  DELETE IWA_ProcessModel FROM IWA_ProcessModel, deleted
  WHERE IWA_ProcessModel.ApplicationId = deleted.ApplicationId


GO


-- update version
UPDATE IWA_Version SET Version=100
GO
