-- migrate oracle from version 101 to version 102

DROP TRIGGER IWA_ApplicationDeleteTrg;
ALTER TABLE IWA_Role DROP UNIQUE (SecuritySystemId, ApplicationId, Name) DROP INDEX;
ALTER TABLE IWA_Role DROP COLUMN ApplicationId;
ALTER TABLE IWA_Role ADD UNIQUE (SecuritySystemId, Name);

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_Role_ExternalSecNameIdx ON IWA_Role (SecuritySystemId, ExternalSecurityName) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

CREATE TRIGGER IWA_ApplicationDeleteTrg
AFTER DELETE ON IWA_Application
FOR EACH ROW
BEGIN
  DELETE IWA_Library
  WHERE IWA_Library.ApplicationId = :old.ApplicationId;

  DELETE IWA_ProcessModel
  WHERE IWA_ProcessModel.ApplicationId = :old.ApplicationId;

END;
;

UPDATE IWA_Version SET Version=102;
