-- migrate mssql from version 102 to version 103

ALTER TABLE IWA_BusinessData ADD
  SecuritySystemId BIGINT NULL
GO

UPDATE IWA_BusinessData SET SecuritySystemId = CreatedByAppId * 10
GO

-- put all business data in default security system if app was not existing
UPDATE IWA_BusinessData SET SecuritySystemId = 1 WHERE SecuritySystemId NOT IN (SELECT SecuritySystemId FROM IWA_SecuritySystem)
GO

ALTER TABLE IWA_BusinessData ALTER COLUMN SecuritySystemId BIGINT NOT NULL
GO

ALTER TABLE IWA_BusinessData ADD FOREIGN KEY (SecuritySystemId) REFERENCES IWA_SecuritySystem (SecuritySystemId)
GO

IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_BusinessData') AND name='IWA_BusinessData_SecSysIdx')
  CREATE INDEX IWA_BusinessData_SecSysIdx ON IWA_BusinessData (SecuritySystemId)
GO

UPDATE IWA_Version SET Version=103
GO
