-- migrate mysql from version 102 to version 103

ALTER TABLE IWA_BusinessData ADD COLUMN
  SecuritySystemId BIGINT NULL;

UPDATE IWA_BusinessData SET SecuritySystemId = CreatedByAppId * 10;
-- put all business data in default security system if app was not existing
UPDATE IWA_BusinessData SET SecuritySystemId = 1 WHERE SecuritySystemId NOT IN (SELECT SecuritySystemId FROM IWA_SecuritySystem);

ALTER TABLE IWA_BusinessData ADD
(
 FOREIGN KEY (SecuritySystemId) REFERENCES IWA_SecuritySystem(SecuritySystemId)
);

CREATE PROCEDURE create_index_if_not_exists(sqlstatement VARCHAR(256))
BEGIN
  DECLARE already_exists CONDITION FOR SQLSTATE '23000';
  DECLARE columns_indexed CONDITION FOR SQLSTATE '42000';

  DECLARE EXIT HANDLER FOR already_exists, columns_indexed
  BEGIN
    -- Ignore exceptions for index already exists or columns already indexed
  END;

  SET @sqlstmt = sqlstatement;
  PREPARE stmt FROM @sqlstmt;
  EXECUTE stmt;
  DEALLOCATE PREPARE stmt;
END;
;

CALL create_index_if_not_exists('CREATE INDEX IWA_BusinessData_SecSysIdx ON IWA_BusinessData (SecuritySystemId);');

DROP PROCEDURE create_index_if_not_exists;


ALTER TABLE IWA_BusinessData MODIFY SecuritySystemId BIGINT NOT NULL;

UPDATE IWA_Version SET Version=103;
