-- migrate oracle from version 102 to version 103

ALTER TABLE IWA_BusinessData ADD
  SecuritySystemId NUMBER(20) NULL;

UPDATE IWA_BusinessData SET SecuritySystemId = CreatedByAppId * 10;
-- put all business data in default security system if app was not existing
UPDATE IWA_BusinessData SET SecuritySystemId = 1 WHERE SecuritySystemId NOT IN (SELECT SecuritySystemId FROM IWA_SecuritySystem);

ALTER TABLE IWA_BusinessData ADD FOREIGN KEY (SecuritySystemId) REFERENCES IWA_SecuritySystem (SecuritySystemId);

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_BusinessData_SecSysIdx ON IWA_BusinessData (SecuritySystemId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN 
  NULL;
END;
;

ALTER TABLE IWA_BusinessData MODIFY SecuritySystemId NOT NULL;

UPDATE IWA_Version SET Version=103;
