-- migrate postgresql from version 102 to version 103

ALTER TABLE IWA_BusinessData ADD COLUMN SecuritySystemId BIGINT NULL;

UPDATE IWA_BusinessData SET SecuritySystemId = CreatedByAppId * 10;
-- put all business data in default security system if app was not existing
UPDATE IWA_BusinessData SET SecuritySystemId = 1 WHERE SecuritySystemId NOT IN (SELECT SecuritySystemId FROM IWA_SecuritySystem);

ALTER TABLE IWA_BusinessData ADD FOREIGN KEY (SecuritySystemId) REFERENCES IWA_SecuritySystem (SecuritySystemId);

CREATE INDEX IF NOT EXISTS IWA_BusinessData_SecSysIdx
ON IWA_BusinessData (SecuritySystemId);

ALTER TABLE IWA_BusinessData ALTER COLUMN SecuritySystemId SET NOT NULL;

UPDATE IWA_Version SET Version=103;
