# SQL script to convert the database for MySQL from version 105 to version 106


# Create new added tables
CREATE TABLE IWA_CaseLocalized
(
  CaseLocalizedId BIGINT NOT NULL,
  CaseId BIGINT NOT NULL,
  LanguageId BIGINT NOT NULL,
  Name VARCHAR(200) NOT NULL,
  Description TEXT NOT NULL,
  PRIMARY KEY (CaseLocalizedId),
  FOREIGN KEY (CaseId) REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  UNIQUE (CaseId, LanguageId),
  INDEX IWA_CaseLocalized_NameIndex (Name)
) ENGINE=InnoDB;

CREATE TABLE IWA_TaskLocalized
(
  TaskLocalizedId BIGINT NOT NULL,
  TaskId BIGINT NOT NULL,
  LanguageId BIGINT NOT NULL,
  Name VARCHAR(200) NOT NULL,
  Description TEXT NOT NULL,
  PRIMARY KEY (TaskLocalizedId),
  FOREIGN KEY (TaskId) REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  UNIQUE (TaskId, LanguageId),
  INDEX IWA_TaskLocalized_NameIndex (Name)
) ENGINE=InnoDB;

CREATE TABLE IWA_Language
(
  LanguageId BIGINT NOT NULL,
  SecuritySystemId BIGINT NOT NULL,
  IsDefault BIT NOT NULL,
  Locale VARCHAR(25) NOT NULL,
  PRIMARY KEY (LanguageId),
  FOREIGN KEY (SecuritySystemId) REFERENCES IWA_SecuritySystem(SecuritySystemId),
  UNIQUE (SecuritySystemId, Locale),
  INDEX IWA_Language_SecuritySystemId (SecuritySystemId)
) ENGINE=InnoDB;

ALTER TABLE IWA_CaseLocalized ADD
(
 FOREIGN KEY (LanguageId) REFERENCES IWA_Language(LanguageId)
);

ALTER TABLE IWA_TaskLocalized ADD
(
 FOREIGN KEY (LanguageId) REFERENCES IWA_Language(LanguageId)
);


# Update Version
UPDATE IWA_Version SET Version=106;
