-- SQL script to convert the database for Oracle from version 108 to version 109


-- Drop removed indexes of table IWA_Role
DROP INDEX IWA_Role_ExternalSecNameIdx;

-- Dropped columns of table IWA_Role
ALTER TABLE IWA_Role DROP COLUMN ExternalSecurityName;

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ApplicationDeleteTrg;

-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ApplicationDeleteTrg
AFTER DELETE ON IWA_Application
FOR EACH ROW
BEGIN
  DELETE IWA_SignalEvent
  WHERE IWA_SignalEvent.ApplicationId = :old.ApplicationId;

  DELETE IWA_Library
  WHERE IWA_Library.ApplicationId = :old.ApplicationId;

  DELETE IWA_ProcessModel
  WHERE IWA_ProcessModel.ApplicationId = :old.ApplicationId;

END;
;

-- Update Version
UPDATE IWA_Version SET Version=109;
