# SQL script to convert the database for MySQL from version 109 to version 110

CREATE PROCEDURE create_index_if_not_exists(sqlstatement VARCHAR(256))
BEGIN
  DECLARE already_exists CONDITION FOR SQLSTATE '23000';
  DECLARE columns_indexed CONDITION FOR SQLSTATE '42000';

  DECLARE EXIT HANDLER FOR already_exists, columns_indexed
  BEGIN
    -- Ignore exceptions for index already exists or columns already indexed
  END;

  SET @sqlstmt = sqlstatement;
  PREPARE stmt FROM @sqlstmt;
  EXECUTE stmt;
  DEALLOCATE PREPARE stmt;
END;
;

# Create new indexes of table IWA_Case
CALL create_index_if_not_exists('CREATE INDEX IWA_Case_StartTimestamp ON IWA_Case (StartTimestamp);');

# Create new indexes of table IWA_Task
CALL create_index_if_not_exists('CREATE INDEX IWA_Task_StartTimestamp ON IWA_Task (StartTimestamp);');

DROP PROCEDURE create_index_if_not_exists;

# Update Version
UPDATE IWA_Version SET Version=110;
