-- migrate mssql from version 113 to version 114

-- add index for foreign keys
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_AsyncProcessCaseData') AND name='IWA_AsyncProcessCaseData_CaseIdIndex')
  CREATE INDEX IWA_AsyncProcessCaseData_CaseIdIndex ON IWA_AsyncProcessCaseData (CaseId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Application') AND name='IWA_Application_SecuritySystemIdIndex')
  CREATE INDEX IWA_Application_SecuritySystemIdIndex ON IWA_Application (SecuritySystemId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_ProcessModel') AND name='IWA_ProcessModel_ApplicationIdIndex')
  CREATE INDEX IWA_ProcessModel_ApplicationIdIndex ON IWA_ProcessModel (ApplicationId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_ProcessModelVersion') AND name='IWA_ProcessModelVersion_ProcessModelIdIndex')
  CREATE INDEX IWA_ProcessModelVersion_ProcessModelIdIndex ON IWA_ProcessModelVersion (ProcessModelId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Library') AND name='IWA_Library_ApplicationIdIndex')
  CREATE INDEX IWA_Library_ApplicationIdIndex ON IWA_Library (ApplicationId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_LibrarySpecification') AND name='IWA_LibrarySpecification_LibraryIdIndex')
  CREATE INDEX IWA_LibrarySpecification_LibraryIdIndex ON IWA_LibrarySpecification (LibraryId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_LibraryVersionSpec') AND name='IWA_LibraryVersionSpec_LibrarySpecificationIdIndex')
  CREATE INDEX IWA_LibraryVersionSpec_LibrarySpecificationIdIndex ON IWA_LibraryVersionSpec (LibrarySpecificationId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_CaseMap') AND name='IWA_CaseMap_ProcessModelVersionIdIndex')
  CREATE INDEX IWA_CaseMap_ProcessModelVersionIdIndex ON IWA_CaseMap (ProcessModelVersionId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_CaseMap') AND name='IWA_CaseMap_ApplicationIdIndex')
  CREATE INDEX IWA_CaseMap_ApplicationIdIndex ON IWA_CaseMap (ApplicationId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_SecurityMember') AND name='IWA_SecurityMember_SecuritySystemIdIndex')
  CREATE INDEX IWA_SecurityMember_SecuritySystemIdIndex ON IWA_SecurityMember (SecuritySystemId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Role') AND name='IWA_Role_SecuritySystemIdIndex')
  CREATE INDEX IWA_Role_SecuritySystemIdIndex ON IWA_Role (SecuritySystemId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_RoleRoleMember') AND name='IWA_RoleRoleMember_RoleSecurityMemberIdIndex')
  CREATE INDEX IWA_RoleRoleMember_RoleSecurityMemberIdIndex ON IWA_RoleRoleMember (RoleSecurityMemberId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_RoleRoleMember') AND name='IWA_RoleRoleMember_RoleMemberSecurityMemberIdIndex')
  CREATE INDEX IWA_RoleRoleMember_RoleMemberSecurityMemberIdIndex ON IWA_RoleRoleMember (RoleMemberSecurityMemberId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_User') AND name='IWA_User_SecuritySystemIdIndex')
  CREATE INDEX IWA_User_SecuritySystemIdIndex ON IWA_User (SecuritySystemId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_UserRole') AND name='IWA_UserRole_RoleSecurityMemberIdIndex')
  CREATE INDEX IWA_UserRole_RoleSecurityMemberIdIndex ON IWA_UserRole (RoleSecurityMemberId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_UserRole') AND name='IWA_UserRole_UserSecurityMemberIdIndex')
  CREATE INDEX IWA_UserRole_UserSecurityMemberIdIndex ON IWA_UserRole (UserSecurityMemberId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskElement') AND name='IWA_TaskElement_ProcessModelVersionIdIndex')
  CREATE INDEX IWA_TaskElement_ProcessModelVersionIdIndex ON IWA_TaskElement (ProcessModelVersionId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskStart') AND name='IWA_TaskStart_TaskElementIdIndex')
  CREATE INDEX IWA_TaskStart_TaskElementIdIndex ON IWA_TaskStart (TaskElementId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskEnd') AND name='IWA_TaskEnd_TaskElementIdIndex')
  CREATE INDEX IWA_TaskEnd_TaskElementIdIndex ON IWA_TaskEnd (TaskElementId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskSwitchEvent') AND name='IWA_TaskSwitchEvent_TaskElementIdIndex')
  CREATE INDEX IWA_TaskSwitchEvent_TaskElementIdIndex ON IWA_TaskSwitchEvent (TaskElementId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskSwitchEvent') AND name='IWA_TaskSwitchEvent_CaseIdIndex')
  CREATE INDEX IWA_TaskSwitchEvent_CaseIdIndex ON IWA_TaskSwitchEvent (CaseId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Case') AND name='IWA_Case_ActivatorIdIndex')
  CREATE INDEX IWA_Case_ActivatorIdIndex ON IWA_Case (ActivatorId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_CaseLocalized') AND name='IWA_CaseLocalized_CaseIdIndex')
  CREATE INDEX IWA_CaseLocalized_CaseIdIndex ON IWA_CaseLocalized (CaseId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_CaseLocalized') AND name='IWA_CaseLocalized_LanguageIdIndex')
  CREATE INDEX IWA_CaseLocalized_LanguageIdIndex ON IWA_CaseLocalized (LanguageId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Task') AND name='IWA_Task_StartTaskSwitchEventIdIndex')
  CREATE INDEX IWA_Task_StartTaskSwitchEventIdIndex ON IWA_Task (StartTaskSwitchEventId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Task') AND name='IWA_Task_EndTaskSwitchEventIdIndex')
  CREATE INDEX IWA_Task_EndTaskSwitchEventIdIndex ON IWA_Task (EndTaskSwitchEventId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Task') AND name='IWA_Task_TaskStartIdIndex')
  CREATE INDEX IWA_Task_TaskStartIdIndex ON IWA_Task (TaskStartId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Task') AND name='IWA_Task_TaskEndIdIndex')
  CREATE INDEX IWA_Task_TaskEndIdIndex ON IWA_Task (TaskEndId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Task') AND name='IWA_Task_ExpiredCreatorTaskIdIndex')
  CREATE INDEX IWA_Task_ExpiredCreatorTaskIdIndex ON IWA_Task (ExpiredCreatorTaskId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Task') AND name='IWA_Task_TimeoutedCreatorIntrmdtEventIdIndex')
  CREATE INDEX IWA_Task_TimeoutedCreatorIntrmdtEventIdIndex ON IWA_Task (TimeoutedCreatorIntrmdtEventId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskLocalized') AND name='IWA_TaskLocalized_TaskIdIndex')
  CREATE INDEX IWA_TaskLocalized_TaskIdIndex ON IWA_TaskLocalized (TaskId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskLocalized') AND name='IWA_TaskLocalized_LanguageIdIndex')
  CREATE INDEX IWA_TaskLocalized_LanguageIdIndex ON IWA_TaskLocalized (LanguageId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_CaseMapEvent') AND name='IWA_CaseMapEvent_ProcessCaseIdIndex')
  CREATE INDEX IWA_CaseMapEvent_ProcessCaseIdIndex ON IWA_CaseMapEvent (ProcessCaseId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskNote') AND name='IWA_TaskNote_TaskIdIndex')
  CREATE INDEX IWA_TaskNote_TaskIdIndex ON IWA_TaskNote (TaskId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskNote') AND name='IWA_TaskNote_NoteIdIndex')
  CREATE INDEX IWA_TaskNote_NoteIdIndex ON IWA_TaskNote (NoteId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_CaseNote') AND name='IWA_CaseNote_CaseIdIndex')
  CREATE INDEX IWA_CaseNote_CaseIdIndex ON IWA_CaseNote (CaseId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_CaseNote') AND name='IWA_CaseNote_NoteIdIndex')
  CREATE INDEX IWA_CaseNote_NoteIdIndex ON IWA_CaseNote (NoteId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskCustomStringField') AND name='IWA_TaskCustomStringField_TaskIdIndex')
  CREATE INDEX IWA_TaskCustomStringField_TaskIdIndex ON IWA_TaskCustomStringField (TaskId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskCustomTextField') AND name='IWA_TaskCustomTextField_TaskIdIndex')
  CREATE INDEX IWA_TaskCustomTextField_TaskIdIndex ON IWA_TaskCustomTextField (TaskId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskCustomNumberField') AND name='IWA_TaskCustomNumberField_TaskIdIndex')
  CREATE INDEX IWA_TaskCustomNumberField_TaskIdIndex ON IWA_TaskCustomNumberField (TaskId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskCustomTimestampField') AND name='IWA_TaskCustomTimestampField_TaskIdIndex')
  CREATE INDEX IWA_TaskCustomTimestampField_TaskIdIndex ON IWA_TaskCustomTimestampField (TaskId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_CaseCustomStringField') AND name='IWA_CaseCstmStringFld_CaseIdIndex')
  CREATE INDEX IWA_CaseCstmStringFld_CaseIdIndex ON IWA_CaseCustomStringField (CaseId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_CaseCustomTextField') AND name='IWA_CaseCstmTextFld_CaseIdIndex')
  CREATE INDEX IWA_CaseCstmTextFld_CaseIdIndex ON IWA_CaseCustomTextField (CaseId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_CaseCustomNumberField') AND name='IWA_CaseCstmNumberFld_CaseIdIndex')
  CREATE INDEX IWA_CaseCstmNumberFld_CaseIdIndex ON IWA_CaseCustomNumberField (CaseId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_CaseCustomTimestampField') AND name='IWA_CaseCstmTmstmpFld_CaseIdIndex')
  CREATE INDEX IWA_CaseCstmTmstmpFld_CaseIdIndex ON IWA_CaseCustomTimestampField (CaseId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskSignalEventReceiver') AND name='IWA_TskSigEvntRcvr_SgTskTskId')
  CREATE INDEX IWA_TskSigEvntRcvr_SgTskTskId ON IWA_TaskSignalEventReceiver (SignaledTaskTaskStartId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_SignalEvent') AND name='IWA_SignalEvent_SecuritySystemId')
  CREATE INDEX IWA_SignalEvent_SecuritySystemId ON IWA_SignalEvent (SecuritySystemId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_SignalEvent') AND name='IWA_SignalEvent_ApplicationId')
  CREATE INDEX IWA_SignalEvent_ApplicationId ON IWA_SignalEvent (ApplicationId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_SecurityDescriptor') AND name='IWA_SecurityDescriptor_SecurityDescriptorTypeId')
  CREATE INDEX IWA_SecurityDescriptor_SecurityDescriptorTypeId ON IWA_SecurityDescriptor (SecurityDescriptorTypeId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_SecuritySystem') AND name='IWA_SecuritySystem_SecurityDescriptorId')
  CREATE INDEX IWA_SecuritySystem_SecurityDescriptorId ON IWA_SecuritySystem (SecurityDescriptorId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_PermissionGroup') AND name='IWA_PermissionGroup_ParentPermissionGroupId')
  CREATE INDEX IWA_PermissionGroup_ParentPermissionGroupId ON IWA_PermissionGroup (ParentPermissionGroupId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_SecurityDescriptorType') AND name='IWA_SecurityDescriptorType_RootPermissionGroupId')
  CREATE INDEX IWA_SecurityDescriptorType_RootPermissionGroupId ON IWA_SecurityDescriptorType (RootPermissionGroupId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_AccessControl') AND name='IWA_AccessControl_PermissionIdIdx')
  CREATE INDEX IWA_AccessControl_PermissionIdIdx ON IWA_AccessControl (PermissionId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_PermissionGroupPermission') AND name='IWA_PermissionGroupPermission_PermissionGroupId')
  CREATE INDEX IWA_PermissionGroupPermission_PermissionGroupId ON IWA_PermissionGroupPermission (PermissionGroupId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_PermissionGroupPermission') AND name='IWA_PermissionGroupPermission_PermissionId')
  CREATE INDEX IWA_PermissionGroupPermission_PermissionId ON IWA_PermissionGroupPermission (PermissionId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_BusinessCaseData') AND name='IWA_BusinessCaseData_BusinessCaseId')
  CREATE INDEX IWA_BusinessCaseData_BusinessCaseId ON IWA_BusinessCaseData (BusinessCaseId)
GO


-- add missing foreign key
DELETE FROM IWA_AccessControl WHERE PermissionId NOT IN (SELECT PermissionId FROM IWA_Permission)
GO
ALTER TABLE IWA_AccessControl ADD FOREIGN KEY (PermissionId) REFERENCES IWA_Permission (PermissionId) ON DELETE CASCADE
GO

-- update version
UPDATE IWA_Version SET Version=114
GO
