-- migrates mssql from version 117 to version 118

ALTER TABLE IWA_Case ADD BusinessState INTEGER
GO
UPDATE IWA_Case SET BusinessState = 0 WHERE "State" IN (0, 1)
GO
UPDATE IWA_Case SET BusinessState = 1 WHERE "State" IN (2)
GO
UPDATE IWA_Case SET BusinessState = 2 WHERE "State" IN (3)
GO
ALTER TABLE IWA_Case ALTER COLUMN BusinessState INTEGER NOT NULL
GO

ALTER TABLE IWA_Task ADD BusinessState INTEGER
GO
UPDATE IWA_Task SET BusinessState = 0 WHERE "State" IN (4, 8, 12)
GO
UPDATE IWA_Task SET BusinessState = 1 WHERE "State" IN (0, 5)
GO
UPDATE IWA_Task SET BusinessState = 2 WHERE "State" IN (1, 2, 6)
GO
UPDATE IWA_Task SET BusinessState = 3 WHERE "State" IN (7)
GO
UPDATE IWA_Task SET BusinessState = 4 WHERE "State" IN (3)
GO
UPDATE IWA_Task SET BusinessState = 5 WHERE "State" IN (10, 11)
GO
ALTER TABLE IWA_Task ALTER COLUMN BusinessState INTEGER NOT NULL
GO

IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Case') AND name='IWA_Case_StateIndex')
  CREATE INDEX IWA_Case_StateIndex ON IWA_Case ("State")
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Case') AND name='IWA_Case_BusinessStateIndex')
  CREATE INDEX IWA_Case_BusinessStateIndex ON IWA_Case (BusinessState)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Task') AND name='IWA_Task_BusinessStateIndex')
  CREATE INDEX IWA_Task_BusinessStateIndex ON IWA_Task (BusinessState)
GO


UPDATE IWA_Version SET Version=118
GO
