-- migrate mysql from version 117 to version 118

ALTER TABLE IWA_Case ADD COLUMN BusinessState INTEGER;
UPDATE IWA_Case SET BusinessState = 0 WHERE `State` IN (0, 1);
UPDATE IWA_Case SET BusinessState = 1 WHERE `State` IN (2);
UPDATE IWA_Case SET BusinessState = 2 WHERE `State` IN (3);
ALTER TABLE IWA_Case MODIFY BusinessState INTEGER NOT NULL;

ALTER TABLE IWA_Task ADD COLUMN BusinessState INTEGER;
UPDATE IWA_Task SET BusinessState = 0 WHERE `State` IN (4, 8, 12);
UPDATE IWA_Task SET BusinessState = 1 WHERE `State` IN (0, 5);
UPDATE IWA_Task SET BusinessState = 2 WHERE `State` IN (1, 2, 6);
UPDATE IWA_Task SET BusinessState = 3 WHERE `State` IN (7);
UPDATE IWA_Task SET BusinessState = 4 WHERE `State` IN (3);
UPDATE IWA_Task SET BusinessState = 5 WHERE `State` IN (10, 11);
ALTER TABLE IWA_Task MODIFY BusinessState INTEGER NOT NULL;

CREATE PROCEDURE create_index_if_not_exists(sqlstatement VARCHAR(256))
BEGIN
  DECLARE already_exists CONDITION FOR SQLSTATE '23000';
  DECLARE columns_indexed CONDITION FOR SQLSTATE '42000';

  DECLARE EXIT HANDLER FOR already_exists, columns_indexed
  BEGIN
    -- Ignore exceptions for index already exists or columns already indexed
  END;

  SET @sqlstmt = sqlstatement;
  PREPARE stmt FROM @sqlstmt;
  EXECUTE stmt;
  DEALLOCATE PREPARE stmt;
END;
;

CALL create_index_if_not_exists('CREATE INDEX IWA_Case_StateIndex ON IWA_Case (`State`);');
CALL create_index_if_not_exists('CREATE INDEX IWA_Case_BusinessStateIndex ON IWA_Case (BusinessState);');
CALL create_index_if_not_exists('CREATE INDEX IWA_Task_BusinessStateIndex ON IWA_Task (BusinessState);');
DROP PROCEDURE create_index_if_not_exists;

UPDATE IWA_Version SET Version=118;
