-- migrate oracle from version 117 to version 118

ALTER TABLE IWA_Case ADD BusinessState NUMBER(10);
UPDATE IWA_Case SET BusinessState = 0 WHERE State IN (0, 1);
UPDATE IWA_Case SET BusinessState = 1 WHERE State IN (2);
UPDATE IWA_Case SET BusinessState = 2 WHERE State IN (3);
ALTER TABLE IWA_Case MODIFY BusinessState NOT NULL;

ALTER TABLE IWA_Task ADD BusinessState NUMBER(10);
UPDATE IWA_Task SET BusinessState = 0 WHERE State IN (4, 8, 12);
UPDATE IWA_Task SET BusinessState = 1 WHERE State IN (0, 5);
UPDATE IWA_Task SET BusinessState = 2 WHERE State IN (1, 2, 6);
UPDATE IWA_Task SET BusinessState = 3 WHERE State IN (7);
UPDATE IWA_Task SET BusinessState = 4 WHERE State IN (3);
UPDATE IWA_Task SET BusinessState = 5 WHERE State IN (10, 11);
ALTER TABLE IWA_Task MODIFY BusinessState NOT NULL;

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_Case_StateIndex ON IWA_Case (State) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN
  NULL;
END;
;

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_Case_BusinessStateIndex ON IWA_Case (BusinessState) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN
  NULL;
END;
;

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_Task_BusinessStateIndex ON IWA_Task (BusinessState) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN
  NULL;
END;
;

UPDATE IWA_Version SET Version=118;
