# SQL script to convert the database for MySQL from version 127 to version 128


# Changed columns of table IWA_UploadedFile
ALTER TABLE IWA_UploadedFile MODIFY
  CreatorId VARCHAR(210) NULL;
ALTER TABLE IWA_UploadedFile MODIFY
  ModifierId VARCHAR(210) NULL;


# Create new indexes of table IWA_UploadedFile
CREATE PROCEDURE create_index_if_not_exists(sqlstatement VARCHAR(256))
BEGIN
  DECLARE already_exists CONDITION FOR SQLSTATE '23000';
  DECLARE columns_indexed CONDITION FOR SQLSTATE '42000';

  DECLARE EXIT HANDLER FOR already_exists, columns_indexed
  BEGIN
    -- Ignore exceptions for index already exists or columns already indexed
  END;

  SET @sqlstmt = sqlstatement;
  PREPARE stmt FROM @sqlstmt;
  EXECUTE stmt;
  DEALLOCATE PREPARE stmt;
END;
;

CALL create_index_if_not_exists('CREATE INDEX IWA_Uploaded_CreatorId ON IWA_UploadedFile (CreatorId);');

CALL create_index_if_not_exists('CREATE INDEX IWA_Uploaded_ModifierId ON IWA_UploadedFile (ModifierId);');
DROP PROCEDURE create_index_if_not_exists;

# Update Version
UPDATE IWA_Version SET Version=128;
