-- SQL script to convert the database for Microsoft SQL Server from version 130 to version 131


-- Create new added tables
CREATE TABLE IWA_Notification
(
  NotificationId VARCHAR(36) NOT NULL,
  Kind VARCHAR(400) NOT NULL,
  Payload VARCHAR(MAX) NOT NULL,
  ReceiverId VARCHAR(210) NOT NULL REFERENCES IWA_SecurityMember(SecurityMemberId) ON DELETE CASCADE,
  CreatedAt DATETIME2(3) NOT NULL,
  PRIMARY KEY (NotificationId)
)
GO

IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Notification') AND name='IWA_Notification_KindIndex')
  CREATE INDEX IWA_Notification_KindIndex ON IWA_Notification (Kind)
GO

IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Notification') AND name='IWA_Notification_ReceiverIdIndex')
  CREATE INDEX IWA_Notification_ReceiverIdIndex ON IWA_Notification (ReceiverId)
GO

IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Notification') AND name='IWA_Notification_CreatedAtIndex')
  CREATE INDEX IWA_Notification_CreatedAtIndex ON IWA_Notification (CreatedAt)
GO

CREATE TABLE IWA_NotificationDelivery
(
  NotificationDeliveryId VARCHAR(36) NOT NULL,
  NotificationId VARCHAR(36) NULL,
  Channel VARCHAR(400) NOT NULL,
  ReceiverId VARCHAR(210) NOT NULL REFERENCES IWA_SecurityMember(SecurityMemberId) ON DELETE CASCADE,
  DeliveredAt DATETIME2(3) NULL,
  PRIMARY KEY (NotificationDeliveryId)
)
GO

IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_NotificationDelivery') AND name='IWA_NotificationDelivery_NotificationIdIndex')
  CREATE INDEX IWA_NotificationDelivery_NotificationIdIndex ON IWA_NotificationDelivery (NotificationId)
GO

IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_NotificationDelivery') AND name='IWA_NotificationDelivery_ChannelIndex')
  CREATE INDEX IWA_NotificationDelivery_ChannelIndex ON IWA_NotificationDelivery (Channel)
GO

IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_NotificationDelivery') AND name='IWA_NotificationDelivery_ReceiverIdIndex')
  CREATE INDEX IWA_NotificationDelivery_ReceiverIdIndex ON IWA_NotificationDelivery (ReceiverId)
GO

IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_NotificationDelivery') AND name='IWA_NotificationDelivery_DeliveredAtIndex')
  CREATE INDEX IWA_NotificationDelivery_DeliveredAtIndex ON IWA_NotificationDelivery (DeliveredAt)
GO


-- Update Version
UPDATE IWA_Version SET Version=131
GO
