# SQL script to convert the database for MySQL from version 130 to version 131


# Create new added tables
CREATE TABLE IWA_Notification
(
  NotificationId VARCHAR(36) NOT NULL,
  Kind VARCHAR(100) NOT NULL,
  Payload TEXT NOT NULL,
  ReceiverId VARCHAR(210) NOT NULL,
  CreatedAt DATETIME(3) NOT NULL,
  PRIMARY KEY (NotificationId),
  FOREIGN KEY (ReceiverId) REFERENCES IWA_SecurityMember(SecurityMemberId) ON DELETE CASCADE,
  INDEX IWA_Notification_KindIndex (Kind),
  INDEX IWA_Notification_ReceiverIdIndex (ReceiverId),
  INDEX IWA_Notification_CreatedAtIndex (CreatedAt)
) ENGINE=InnoDB;

CREATE TABLE IWA_NotificationDelivery
(
  NotificationDeliveryId VARCHAR(36) NOT NULL,
  NotificationId VARCHAR(36),
  Channel VARCHAR(100) NOT NULL,
  ReceiverId VARCHAR(210) NOT NULL,
  DeliveredAt DATETIME(3),
  PRIMARY KEY (NotificationDeliveryId),
  FOREIGN KEY (NotificationId) REFERENCES IWA_Notification(NotificationId) ON DELETE CASCADE,
  FOREIGN KEY (ReceiverId) REFERENCES IWA_SecurityMember(SecurityMemberId) ON DELETE CASCADE,
  INDEX IWA_NotificationDelivery_NotificationIdIndex (NotificationId),
  INDEX IWA_NotificationDelivery_ChannelIndex (Channel),
  INDEX IWA_NotificationDelivery_ReceiverIdIndex (ReceiverId),
  INDEX IWA_NotificationDelivery_DeliveredAtIndex (DeliveredAt)
) ENGINE=InnoDB;


# Update Version
UPDATE IWA_Version SET Version=131;
