-- SQL script to convert the database for Postgre SQL from version 130 to version 131


-- Create new added tables
CREATE TABLE IWA_Notification
(
  NotificationId VARCHAR(36) NOT NULL,
  Kind VARCHAR(100) NOT NULL,
  Payload TEXT NOT NULL,
  ReceiverId VARCHAR(210) NOT NULL REFERENCES IWA_SecurityMember(SecurityMemberId) ON DELETE CASCADE,
  CreatedAt TIMESTAMP NOT NULL,
  PRIMARY KEY (NotificationId)
);

CREATE INDEX IF NOT EXISTS IWA_Notification_KindIndex
ON IWA_Notification (Kind varchar_pattern_ops);

CREATE INDEX IF NOT EXISTS IWA_Notification_ReceiverIdIndex
ON IWA_Notification (ReceiverId varchar_pattern_ops);

CREATE INDEX IF NOT EXISTS IWA_Notification_CreatedAtIndex
ON IWA_Notification (CreatedAt);

CREATE TABLE IWA_NotificationDelivery
(
  NotificationDeliveryId VARCHAR(36) NOT NULL,
  NotificationId VARCHAR(36) REFERENCES IWA_Notification(NotificationId) ON DELETE CASCADE,
  Channel VARCHAR(100) NOT NULL,
  ReceiverId VARCHAR(210) NOT NULL REFERENCES IWA_SecurityMember(SecurityMemberId) ON DELETE CASCADE,
  DeliveredAt TIMESTAMP,
  PRIMARY KEY (NotificationDeliveryId)
);

CREATE INDEX IF NOT EXISTS IWA_NotificationDelivery_NotificationIdIndex
ON IWA_NotificationDelivery (NotificationId varchar_pattern_ops);

CREATE INDEX IF NOT EXISTS IWA_NotificationDelivery_ChannelIndex
ON IWA_NotificationDelivery (Channel varchar_pattern_ops);

CREATE INDEX IF NOT EXISTS IWA_NotificationDelivery_ReceiverIdIndex
ON IWA_NotificationDelivery (ReceiverId varchar_pattern_ops);

CREATE INDEX IF NOT EXISTS IWA_NotificationDelivery_DeliveredAtIndex
ON IWA_NotificationDelivery (DeliveredAt);


-- Update Version
UPDATE IWA_Version SET Version=131;
