# SQL script to convert the database for MySQL from version 131 to version 132


# Added columns of table IWA_Notification
ALTER TABLE IWA_Notification ADD COLUMN
  SecuritySystemId BIGINT NOT NULL;

# Create added foreign keys of table IWA_Notification
ALTER TABLE IWA_Notification ADD
(
 FOREIGN KEY (SecuritySystemId) REFERENCES IWA_SecuritySystem(SecuritySystemId) ON DELETE CASCADE
);


# Create new indexes of table IWA_Notification
CREATE PROCEDURE create_index_if_not_exists(sqlstatement VARCHAR(256))
BEGIN
  DECLARE already_exists CONDITION FOR SQLSTATE '23000';
  DECLARE columns_indexed CONDITION FOR SQLSTATE '42000';

  DECLARE EXIT HANDLER FOR already_exists, columns_indexed
  BEGIN
    -- Ignore exceptions for index already exists or columns already indexed
  END;

  SET @sqlstmt = sqlstatement;
  PREPARE stmt FROM @sqlstmt;
  EXECUTE stmt;
  DEALLOCATE PREPARE stmt;
END;
;

CALL create_index_if_not_exists('CREATE INDEX IWA_Notification_SecuritySystemIdIndex ON IWA_Notification (SecuritySystemId);');
DROP PROCEDURE create_index_if_not_exists;


# Update Version
UPDATE IWA_Version SET Version=132;
