-- SQL script to convert the database for Oracle from version 131 to version 132


-- Added columns of table IWA_Notification
ALTER TABLE IWA_Notification ADD
  SecuritySystemId NUMBER(20) NOT NULL REFERENCES IWA_SecuritySystem(SecuritySystemId) ON DELETE CASCADE;

-- Create new indexes of table IWA_Notification
DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_Notification_SecuritySystemIdIndex ON IWA_Notification (SecuritySystemId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN
  NULL;
END;
;

-- Update Version
UPDATE IWA_Version SET Version=132;
