# SQL script to convert the database for MySQL from version 132 to version 133


# Added columns of table IWA_NotificationDelivery
ALTER TABLE IWA_NotificationDelivery ADD COLUMN
  ReadAt DATETIME(3);
ALTER TABLE IWA_NotificationDelivery ADD COLUMN
  Hide BIT NOT NULL;

# Create new indexes of table IWA_NotificationDelivery
CREATE PROCEDURE create_index_if_not_exists(sqlstatement VARCHAR(256))
BEGIN
  DECLARE already_exists CONDITION FOR SQLSTATE '23000';
  DECLARE columns_indexed CONDITION FOR SQLSTATE '42000';

  DECLARE EXIT HANDLER FOR already_exists, columns_indexed
  BEGIN
    -- Ignore exceptions for index already exists or columns already indexed
  END;

  SET @sqlstmt = sqlstatement;
  PREPARE stmt FROM @sqlstmt;
  EXECUTE stmt;
  DEALLOCATE PREPARE stmt;
END;
;

CALL create_index_if_not_exists('CREATE INDEX IWA_NotificationDelivery_ReadAtIndex ON IWA_NotificationDelivery (ReadAt);');

CALL create_index_if_not_exists('CREATE INDEX IWA_NotificationDelivery_HideIndex ON IWA_NotificationDelivery (Hide);');

DROP PROCEDURE create_index_if_not_exists;


# Update Version
UPDATE IWA_Version SET Version=133;
