-- SQL script to convert the database for Oracle from version 132 to version 133


-- Added columns of table IWA_NotificationDelivery
ALTER TABLE IWA_NotificationDelivery ADD
  ReadAt TIMESTAMP;
ALTER TABLE IWA_NotificationDelivery ADD
  Hide NUMBER(1) NOT NULL;

-- Create new indexes of table IWA_NotificationDelivery
DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_NotificationDelivery_ReadAtIndex ON IWA_NotificationDelivery (ReadAt) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN
  NULL;
END;
;

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_NotificationDelivery_HideIndex ON IWA_NotificationDelivery (Hide) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN
  NULL;
END;
;

-- Update Version
UPDATE IWA_Version SET Version=133;
