-- SQL script to convert the database for Oracle from version 134 to version 135


-- Added columns of table IWA_NotificationDelivery
ALTER TABLE IWA_NotificationDelivery ADD
  DeliveryState NUMBER(10) NOT NULL;
ALTER TABLE IWA_NotificationDelivery ADD
  Error VARCHAR2(255);

-- Create new indexes of table IWA_NotificationDelivery
DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_NotificationDelivery_DeliveryStateIndex ON IWA_NotificationDelivery (DeliveryState) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN
  NULL;
END;
;

-- Update Version
UPDATE IWA_Version SET Version=135;
