-- SQL script to convert the database for Microsoft SQL Server from version 136 to version 137

CREATE TABLE IWA_Blob
(
  BlobId BIGINT NOT NULL,
  UUID VARCHAR(36) NULL,
  ApplicationId BIGINT NULL,
  SecuritySystemId BIGINT NOT NULL REFERENCES IWA_SecuritySystem(SecuritySystemId),
  FileName VARCHAR(1020) NOT NULL,
  FilePath VARCHAR(3000) NOT NULL,
  CreatorId VARCHAR(210) NULL REFERENCES IWA_SecurityMember(SecurityMemberId),
  CreatedAt DATETIME2(3) NOT NULL,
  "Size" BIGINT NOT NULL,
  ModifierId VARCHAR(210) NULL REFERENCES IWA_SecurityMember(SecurityMemberId),
  ModifiedAt DATETIME2(3) NOT NULL,
  Description VARCHAR(4096) NULL,
  PRIMARY KEY (BlobId)
)
GO

IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Blob') AND name='IWA_Blob_FilePath')
  CREATE INDEX IWA_Blob_FilePath ON IWA_Blob (FilePath)
GO

IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Blob') AND name='IWA_Blob_CreatorId')
  CREATE INDEX IWA_Blob_CreatorId ON IWA_Blob (CreatorId)
GO

IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Blob') AND name='IWA_Blob_ModifierId')
  CREATE INDEX IWA_Blob_ModifierId ON IWA_Blob (ModifierId)
GO

IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Blob') AND name='IWA_Blob_CreatedAt')
  CREATE INDEX IWA_Blob_CreatedAt ON IWA_Blob (CreatedAt)
GO

IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Blob') AND name='IWA_Blob_FileName')
  CREATE INDEX IWA_Blob_FileName ON IWA_Blob (FileName)
GO

IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Blob') AND name='IWA_Blob_ModifiedAt')
  CREATE INDEX IWA_Blob_ModifiedAt ON IWA_Blob (ModifiedAt)
GO

IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Blob') AND name='IWA_Blob_SecuritySystemId')
  CREATE INDEX IWA_Blob_SecuritySystemId ON IWA_Blob (SecuritySystemId)
GO

IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Blob') AND name='IWA_Blob_ApplicationId')
  CREATE INDEX IWA_Blob_ApplicationId ON IWA_Blob (ApplicationId)
GO

-- Update Version
UPDATE IWA_Version SET Version=137
GO
