-- SQL script to convert the database for Postgre SQL from version 137 to version 138

-- Added columns of table IWA_Blob
ALTER TABLE IWA_Blob RENAME COLUMN FileId TO BlobId;
  
ALTER TABLE IWA_Blob ADD COLUMN
  UUID VARCHAR(36);


-- Create new indexes of table IWA_Blob
CREATE INDEX IF NOT EXISTS IWA_Blob_FilePath
ON IWA_Blob (FilePath varchar_pattern_ops);

CREATE INDEX IF NOT EXISTS IWA_Blob_CreatedAt
ON IWA_Blob (CreatedAt);

CREATE INDEX IF NOT EXISTS IWA_Blob_FileName
ON IWA_Blob (FileName varchar_pattern_ops);

CREATE INDEX IF NOT EXISTS IWA_Blob_ModifiedAt
ON IWA_Blob (ModifiedAt);

CREATE INDEX IF NOT EXISTS IWA_Blob_SecuritySystemId
ON IWA_Blob (SecuritySystemId);

CREATE INDEX IF NOT EXISTS IWA_Blob_ApplicationId
ON IWA_Blob (ApplicationId);


-- Create new unique constraint of table IWA_Blob
ALTER TABLE IWA_Blob ADD UNIQUE (UUID);


-- Update Version
UPDATE IWA_Version SET Version=138;
