# SQL script to convert the database for MySQL from version 142 to version 143


# Added columns of table IWA_Blob
ALTER TABLE IWA_Blob ADD COLUMN
  `Path` VARCHAR(750);

# Create new indexes of table IWA_Blob
CREATE PROCEDURE create_index_if_not_exists(sqlstatement VARCHAR(256))
BEGIN
  DECLARE already_exists CONDITION FOR SQLSTATE '23000';
  DECLARE columns_indexed CONDITION FOR SQLSTATE '42000';

  DECLARE EXIT HANDLER FOR already_exists, columns_indexed
  BEGIN
    -- Ignore exceptions for index already exists or columns already indexed
  END;

  SET @sqlstmt = sqlstatement;
  PREPARE stmt FROM @sqlstmt;
  EXECUTE stmt;
  DEALLOCATE PREPARE stmt;
END;
;

CALL create_index_if_not_exists('CREATE INDEX IWA_Blob_Path ON IWA_Blob (`Path`(255));');

DROP PROCEDURE create_index_if_not_exists;



# Update Version
UPDATE IWA_Version SET Version=143;
