-- SQL script to convert the database for Oracle from version 142 to version 143


-- Added columns of table IWA_Blob
ALTER TABLE IWA_Blob ADD
  "PATH" VARCHAR2(750);

-- Create new indexes of table IWA_Blob
DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_Blob_Path ON IWA_Blob ("PATH") TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN
  NULL;
END;
;

-- Update Version
UPDATE IWA_Version SET Version=143;
