-- Migrate Microsoft SQL Server from version 145 to version 146


CREATE TABLE IWA_NotificationSubscription
(
  NotificationSubscriptionId BIGINT NOT NULL,
  Channel VARCHAR(400) NOT NULL,
  Kind VARCHAR(400) NOT NULL,
  SubscriberId VARCHAR(210) NOT NULL REFERENCES IWA_SecurityMember(SecurityMemberId) ON DELETE CASCADE,
  Subscribed BIT NOT NULL,
  PRIMARY KEY (NotificationSubscriptionId),
  UNIQUE (SubscriberId, Kind, Channel)
)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_NotificationSubscription') AND name='IWA_NotificationSubscription_ChannelIndex')
  CREATE INDEX IWA_NotificationSubscription_ChannelIndex ON IWA_NotificationSubscription (Channel)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_NotificationSubscription') AND name='IWA_NotificationSubscription_KindIndex')
  CREATE INDEX IWA_NotificationSubscription_KindIndex ON IWA_NotificationSubscription (Kind)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_NotificationSubscription') AND name='IWA_NotificationSubscription_SubscriberIdIndex')
  CREATE INDEX IWA_NotificationSubscription_SubscriberIdIndex ON IWA_NotificationSubscription (SubscriberId)
GO

UPDATE IWA_Version SET Version = 146
GO
