# Migrate MySQL from version 145 to version 146


CREATE TABLE IWA_NotificationSubscription
(
  NotificationSubscriptionId BIGINT NOT NULL,
  Channel VARCHAR(100) NOT NULL,
  Kind VARCHAR(100) NOT NULL,
  SubscriberId VARCHAR(210) NOT NULL,
  Subscribed BIT NOT NULL,
  PRIMARY KEY (NotificationSubscriptionId),
  FOREIGN KEY (SubscriberId) REFERENCES IWA_SecurityMember(SecurityMemberId) ON DELETE CASCADE,
  UNIQUE (SubscriberId, Kind, Channel),
  INDEX IWA_NotificationSubscription_ChannelIndex (Channel),
  INDEX IWA_NotificationSubscription_KindIndex (Kind),
  INDEX IWA_NotificationSubscription_SubscriberIdIndex (SubscriberId)
) ENGINE=InnoDB;


UPDATE IWA_Version SET Version = 146;
