-- Migrate Oracle from version 145 to version 146


CREATE TABLE IWA_NotificationSubscription
(
  NotificationSubscriptionId NUMBER(20) NOT NULL,
  Channel VARCHAR2(100) NOT NULL,
  Kind VARCHAR2(100) NOT NULL,
  SubscriberId VARCHAR2(210) NOT NULL REFERENCES IWA_SecurityMember(SecurityMemberId) ON DELETE CASCADE,
  Subscribed NUMBER(1) NOT NULL,
  PRIMARY KEY (NotificationSubscriptionId),
  UNIQUE (SubscriberId, Kind, Channel)
)
TABLESPACE ${tablespaceName};

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_NotificationSubscription_ChannelIndex ON IWA_NotificationSubscription (Channel) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN
  NULL;
END;
;

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_NotificationSubscription_KindIndex ON IWA_NotificationSubscription (Kind) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN
  NULL;
END;
;

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_NotificationSubscription_SubscriberIdIndex ON IWA_NotificationSubscription (SubscriberId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN
  NULL;
END;
;

UPDATE IWA_Version SET Version = 146;
