-- Migrate Postgre SQL from version 145 to version 146


CREATE TABLE IWA_NotificationSubscription
(
  NotificationSubscriptionId BIGINT NOT NULL,
  Channel VARCHAR(100) NOT NULL,
  Kind VARCHAR(100) NOT NULL,
  SubscriberId VARCHAR(210) NOT NULL REFERENCES IWA_SecurityMember(SecurityMemberId) ON DELETE CASCADE,
  Subscribed DECIMAL(1) NOT NULL,
  PRIMARY KEY (NotificationSubscriptionId),
  UNIQUE (SubscriberId, Kind, Channel)
);
CREATE INDEX IF NOT EXISTS IWA_NotificationSubscription_ChannelIndex ON IWA_NotificationSubscription (Channel varchar_pattern_ops);
CREATE INDEX IF NOT EXISTS IWA_NotificationSubscription_KindIndex ON IWA_NotificationSubscription (Kind varchar_pattern_ops);
CREATE INDEX IF NOT EXISTS IWA_NotificationSubscription_SubscriberIdIndex ON IWA_NotificationSubscription (SubscriberId varchar_pattern_ops);


UPDATE IWA_Version SET Version = 146;
