-- Migrate Oracle from version 151 to version 152

ALTER TABLE IWA_Notification ADD ProcessModelVersionId NUMBER(20) REFERENCES IWA_ProcessModelVersion(ProcessModelVersionId) ON DELETE SET NULL;
DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_Notification_ProcessModelVersionIdIndex ON IWA_Notification (ProcessModelVersionId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN
  NULL;
END;
;

UPDATE IWA_Version SET Version = 152;
