-- Migrate Oracle from version 153 to version 154

CREATE TABLE IWA_NotificationReceiver
(
  NotificationId VARCHAR2(36) NOT NULL REFERENCES IWA_Notification(NotificationId) ON DELETE CASCADE,
  ReceiverId VARCHAR2(210) NOT NULL REFERENCES IWA_SecurityMember(SecurityMemberId) ON DELETE CASCADE,
  PRIMARY KEY (NotificationId, ReceiverId)
)
TABLESPACE ${tablespaceName};
DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_NotificationReceiver_NotificationIdIndex ON IWA_NotificationReceiver (NotificationId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN
  NULL;
END;
;

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_NotificationReceiver_ReceiverIdIndex ON IWA_NotificationReceiver (ReceiverId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN
  NULL;
END;
;

INSERT INTO IWA_NotificationReceiver (NotificationId, ReceiverId)
SELECT NotificationId, ReceiverId
FROM IWA_Notification;

DROP INDEX IWA_Notification_ReceiverIdIndex;

ALTER TABLE IWA_Notification DROP COLUMN ReceiverId;

UPDATE IWA_Version SET Version = 154;
