-- Migrate Postgre SQL from version 153 to version 154

CREATE TABLE IWA_NotificationReceiver
(
  NotificationId VARCHAR(36) NOT NULL REFERENCES IWA_Notification(NotificationId) ON DELETE CASCADE,
  ReceiverId VARCHAR(210) NOT NULL REFERENCES IWA_SecurityMember(SecurityMemberId) ON DELETE CASCADE,
  PRIMARY KEY (NotificationId, ReceiverId)
);
CREATE INDEX IF NOT EXISTS IWA_NotificationReceiver_NotificationIdIndex ON IWA_NotificationReceiver (NotificationId varchar_pattern_ops);
CREATE INDEX IF NOT EXISTS IWA_NotificationReceiver_ReceiverIdIndex ON IWA_NotificationReceiver (ReceiverId varchar_pattern_ops);

INSERT INTO IWA_NotificationReceiver (NotificationId, ReceiverId) 
SELECT NotificationId, ReceiverId 
FROM IWA_Notification;

DROP INDEX IWA_Notification_ReceiverIdIndex;

ALTER TABLE IWA_Notification DROP COLUMN ReceiverId;

UPDATE IWA_Version SET Version = 154;
