# Migrate MySQL from version 156 to version 157

CREATE PROCEDURE create_index_if_not_exists(sqlstatement VARCHAR(256))
BEGIN
  DECLARE already_exists CONDITION FOR SQLSTATE '23000';
  DECLARE columns_indexed CONDITION FOR SQLSTATE '42000';
  DECLARE EXIT HANDLER FOR already_exists, columns_indexed
  BEGIN
    -- ignore exceptions for index already exists or columns already indexed
  END;
  SET @sqlstmt = sqlstatement;
  PREPARE stmt FROM @sqlstmt;
  EXECUTE stmt;
  DEALLOCATE PREPARE stmt;
END;
;

CALL create_index_if_not_exists('CREATE INDEX IWA_User_SecSysSecMemberIndex ON IWA_User (SecuritySystemId, SecurityMemberId)');
CALL create_index_if_not_exists('CREATE INDEX IWA_User_SecSysNameSecMemberIdx ON IWA_User (SecuritySystemId, Name(50), SecurityMemberId(200))');
DROP PROCEDURE create_index_if_not_exists;


UPDATE IWA_Version SET Version = 157;
