-- Migrate Microsoft SQL Server from version 157 to version 158

IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_CaseLocalized') AND name='IWA_CaseLocalized_CaseIdLanguageIdNameIndex')
  CREATE INDEX IWA_CaseLocalized_CaseIdLanguageIdNameIndex ON IWA_CaseLocalized (CaseId, LanguageId, Name)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_CaseLocalized') AND name='IWA_CaseLocalized_LanguageIdNameCaseIdIndex')
  CREATE INDEX IWA_CaseLocalized_LanguageIdNameCaseIdIndex ON IWA_CaseLocalized (LanguageId, Name, CaseId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Task') AND name='IWA_Task_TaskIdCaseIdIndex')
  CREATE INDEX IWA_Task_TaskIdCaseIdIndex ON IWA_Task (TaskId, CaseId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Task') AND name='IWA_Task_CaseIdTaskIdIndex')
  CREATE INDEX IWA_Task_CaseIdTaskIdIndex ON IWA_Task (CaseId, TaskId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Task') AND name='IWA_Task_TaskIdBusinessCaseIdIndex')
  CREATE INDEX IWA_Task_TaskIdBusinessCaseIdIndex ON IWA_Task (TaskId, BusinessCaseId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_Task') AND name='IWA_Task_BusinessCaseIdTaskIdIndex')
  CREATE INDEX IWA_Task_BusinessCaseIdTaskIdIndex ON IWA_Task (BusinessCaseId, TaskId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskLocalized') AND name='IWA_TaskLocalized_TaskIdLanguageIdNameIndex')
  CREATE INDEX IWA_TaskLocalized_TaskIdLanguageIdNameIndex ON IWA_TaskLocalized (TaskId, LanguageId, Name)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskLocalized') AND name='IWA_TaskLocalized_LanguageIdNameTaskIdIndex')
  CREATE INDEX IWA_TaskLocalized_LanguageIdNameTaskIdIndex ON IWA_TaskLocalized (LanguageId, Name, TaskId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskCustomStringField') AND name='IWA_TaskCstmStringFld_TaskIdNameValueIndex')
  CREATE INDEX IWA_TaskCstmStringFld_TaskIdNameValueIndex ON IWA_TaskCustomStringField (TaskId, Name, "Value")
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskCustomStringField') AND name='IWA_TaskCstmStringFld_NameValueTaskIdIndex')
  CREATE INDEX IWA_TaskCstmStringFld_NameValueTaskIdIndex ON IWA_TaskCustomStringField (Name, "Value", TaskId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskCustomNumberField') AND name='IWA_TaskCstmNumberFld_TaskIdNameValueIndex')
  CREATE INDEX IWA_TaskCstmNumberFld_TaskIdNameValueIndex ON IWA_TaskCustomNumberField (TaskId, Name, "Value")
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskCustomNumberField') AND name='IWA_TaskCstmNumberFld_NameValueTaskIdIndex')
  CREATE INDEX IWA_TaskCstmNumberFld_NameValueTaskIdIndex ON IWA_TaskCustomNumberField (Name, "Value", TaskId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskCustomTimestampField') AND name='IWA_TaskCstmTimestampFld_TaskIdNameValueIndex')
  CREATE INDEX IWA_TaskCstmTimestampFld_TaskIdNameValueIndex ON IWA_TaskCustomTimestampField (TaskId, Name, "Value")
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_TaskCustomTimestampField') AND name='IWA_TaskCstmTimestampFld_NameValueTaskIdIndex')
  CREATE INDEX IWA_TaskCstmTimestampFld_NameValueTaskIdIndex ON IWA_TaskCustomTimestampField (Name, "Value", TaskId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_CaseCustomStringField') AND name='IWA_CaseCstmStringFld_CaseIdNameValueIndex')
  CREATE INDEX IWA_CaseCstmStringFld_CaseIdNameValueIndex ON IWA_CaseCustomStringField (CaseId, Name, "Value")
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_CaseCustomStringField') AND name='IWA_CaseCstmStringFld_NameValueCaseIdIndex')
  CREATE INDEX IWA_CaseCstmStringFld_NameValueCaseIdIndex ON IWA_CaseCustomStringField (Name, "Value", CaseId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_CaseCustomNumberField') AND name='IWA_CaseCstmNumberFld_CaseIdNameValueIndex')
  CREATE INDEX IWA_CaseCstmNumberFld_CaseIdNameValueIndex ON IWA_CaseCustomNumberField (CaseId, Name, "Value")
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_CaseCustomNumberField') AND name='IWA_CaseCstmNumberFld_NameValueCaseIdIndex')
  CREATE INDEX IWA_CaseCstmNumberFld_NameValueCaseIdIndex ON IWA_CaseCustomNumberField (Name, "Value", CaseId)
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_CaseCustomTimestampField') AND name='IWA_CaseCstmTmstmpFld_CaseIdNameValueIndex')
  CREATE INDEX IWA_CaseCstmTmstmpFld_CaseIdNameValueIndex ON IWA_CaseCustomTimestampField (CaseId, Name, "Value")
GO
IF NOT EXISTS (SELECT * FROM sysindexes WHERE id=object_id('IWA_CaseCustomTimestampField') AND name='IWA_CaseCstmTmstmpFld_NameValueCaseIdIndex')
  CREATE INDEX IWA_CaseCstmTmstmpFld_NameValueCaseIdIndex ON IWA_CaseCustomTimestampField (Name, "Value", CaseId)
GO

UPDATE IWA_Version SET Version = 158
GO
