-- Migrate Postgre SQL from version 157 to version 158

CREATE INDEX IF NOT EXISTS IWA_CaseLocalized_CaseIdLanguageIdNameIndex ON IWA_CaseLocalized (CaseId, LanguageId, Name varchar_pattern_ops);
CREATE INDEX IF NOT EXISTS IWA_CaseLocalized_LanguageIdNameCaseIdIndex ON IWA_CaseLocalized (LanguageId, Name varchar_pattern_ops, CaseId);
CREATE INDEX IF NOT EXISTS IWA_Task_TaskIdCaseIdIndex ON IWA_Task (TaskId, CaseId);
CREATE INDEX IF NOT EXISTS IWA_Task_CaseIdTaskIdIndex ON IWA_Task (CaseId, TaskId);
CREATE INDEX IF NOT EXISTS IWA_Task_TaskIdBusinessCaseIdIndex ON IWA_Task (TaskId, BusinessCaseId);
CREATE INDEX IF NOT EXISTS IWA_Task_BusinessCaseIdTaskIdIndex ON IWA_Task (BusinessCaseId, TaskId);
CREATE INDEX IF NOT EXISTS IWA_TaskLocalized_TaskIdLanguageIdNameIndex ON IWA_TaskLocalized (TaskId, LanguageId, Name varchar_pattern_ops);
CREATE INDEX IF NOT EXISTS IWA_TaskLocalized_LanguageIdNameTaskIdIndex ON IWA_TaskLocalized (LanguageId, Name varchar_pattern_ops, TaskId);
CREATE INDEX IF NOT EXISTS IWA_TaskCstmStringFld_TaskIdNameValueIndex ON IWA_TaskCustomStringField (TaskId, Name varchar_pattern_ops, "Value" varchar_pattern_ops);
CREATE INDEX IF NOT EXISTS IWA_TaskCstmStringFld_NameValueTaskIdIndex ON IWA_TaskCustomStringField (Name varchar_pattern_ops, "Value" varchar_pattern_ops, TaskId);
CREATE INDEX IF NOT EXISTS IWA_TaskCstmNumberFld_TaskIdNameValueIndex ON IWA_TaskCustomNumberField (TaskId, Name varchar_pattern_ops, "Value");
CREATE INDEX IF NOT EXISTS IWA_TaskCstmNumberFld_NameValueTaskIdIndex ON IWA_TaskCustomNumberField (Name varchar_pattern_ops, "Value", TaskId);
CREATE INDEX IF NOT EXISTS IWA_TaskCstmTimestampFld_TaskIdNameValueIndex ON IWA_TaskCustomTimestampField (TaskId, Name varchar_pattern_ops, "Value");
CREATE INDEX IF NOT EXISTS IWA_TaskCstmTimestampFld_NameValueTaskIdIndex ON IWA_TaskCustomTimestampField (Name varchar_pattern_ops, "Value", TaskId);
CREATE INDEX IF NOT EXISTS IWA_CaseCstmStringFld_CaseIdNameValueIndex ON IWA_CaseCustomStringField (CaseId, Name varchar_pattern_ops, "Value" varchar_pattern_ops);
CREATE INDEX IF NOT EXISTS IWA_CaseCstmStringFld_NameValueCaseIdIndex ON IWA_CaseCustomStringField (Name varchar_pattern_ops, "Value" varchar_pattern_ops, CaseId);
CREATE INDEX IF NOT EXISTS IWA_CaseCstmNumberFld_CaseIdNameValueIndex ON IWA_CaseCustomNumberField (CaseId, Name varchar_pattern_ops, "Value");
CREATE INDEX IF NOT EXISTS IWA_CaseCstmNumberFld_NameValueCaseIdIndex ON IWA_CaseCustomNumberField (Name varchar_pattern_ops, "Value", CaseId);
CREATE INDEX IF NOT EXISTS IWA_CaseCstmTmstmpFld_CaseIdNameValueIndex ON IWA_CaseCustomTimestampField (CaseId, Name varchar_pattern_ops, "Value");
CREATE INDEX IF NOT EXISTS IWA_CaseCstmTmstmpFld_NameValueCaseIdIndex ON IWA_CaseCustomTimestampField (Name varchar_pattern_ops, "Value", CaseId);

UPDATE IWA_Version SET Version = 158;
