-- Migrate Oracle from version 159 to version 160

DROP INDEX IWA_Case_OwnerIdIndex;

CREATE TABLE IWA_CaseOwner
(
  CaseId NUMBER(20) NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  OwnerId VARCHAR2(210) NOT NULL REFERENCES IWA_SecurityMember(SecurityMemberId) ON DELETE CASCADE,
  PRIMARY KEY (CaseId, OwnerId)
)
TABLESPACE ${tablespaceName};

INSERT INTO IWA_CaseOwner (CaseId, OwnerId)
SELECT CaseId, OwnerId FROM IWA_Case
WHERE OwnerId IS NOT NULL;

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_CaseOwner_CaseIdIndex ON IWA_CaseOwner (CaseId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN
  NULL;
END;
;

DECLARE
  ALREADY_EXISTS EXCEPTION;
  COLUMNS_INDEXED EXCEPTION;
  PRAGMA EXCEPTION_INIT(ALREADY_EXISTS, -955);
  PRAGMA EXCEPTION_INIT(COLUMNS_INDEXED, -1408);
BEGIN
  EXECUTE IMMEDIATE 'CREATE INDEX IWA_CaseOwner_OwnerIdIndex ON IWA_CaseOwner (OwnerId) TABLESPACE ${tablespaceName}';
EXCEPTION
  WHEN ALREADY_EXISTS OR COLUMNS_INDEXED THEN
  NULL;
END;
;


ALTER TABLE IWA_Case DROP COLUMN OwnerId;

UPDATE IWA_Version SET Version = 160;
