-- Migrate Postgre SQL from version 159 to version 160

DROP INDEX IWA_Case_OwnerIdIndex;

CREATE TABLE IWA_CaseOwner
(
  CaseId BIGINT NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  OwnerId VARCHAR(210) NOT NULL REFERENCES IWA_SecurityMember(SecurityMemberId) ON DELETE CASCADE,
  PRIMARY KEY (CaseId, OwnerId)
);

INSERT INTO IWA_CaseOwner (CaseId, OwnerId)
SELECT CaseId, OwnerId FROM IWA_Case
WHERE OwnerId IS NOT NULL; 

CREATE INDEX IF NOT EXISTS IWA_CaseOwner_CaseIdIndex ON IWA_CaseOwner (CaseId);
CREATE INDEX IF NOT EXISTS IWA_CaseOwner_OwnerIdIndex ON IWA_CaseOwner (OwnerId varchar_pattern_ops);

ALTER TABLE IWA_Case DROP COLUMN OwnerId;

UPDATE IWA_Version SET Version = 160;
