    /**
     * <p>Adds a condition, which negates a set of where conditions given by the <code>otherQuery</code> with a NOT expression.<br/>
     * Only the where clause of the given <code>otherQuery</code> is considered. All other parts are ignored.</p>
     * <p>SQL part: <code>NOT([otherSqlExpression])</code></p>
     * <p>
     *   <b>Example:</b>
     *   <code><pre>${table.queryClassName} subQuery = ${table.queryClassName}.create().where()
     *      .name().isEqual("john");
     *${table.queryClassName} query = ${table.queryClassName}.create().where()
     *      .not(subQuery);</pre></code>
     *   Corresponds to SQL:
     *   <code><pre>SELECT * FROM IWA_${table.name}
     *  WHERE NOT(name = 'john')</pre></code>
     * </p>
     * @param otherQuery Query from which the negated where part will be added to the current query.
     * @return query for further composition
     */
