 * <p>
 * Provides a query builder to query {@link ch.ivyteam.ivy.security.IUser user} data of
 * the {@link ch.ivyteam.ivy.security.ISecurityContext#current() current security context}.
 * </p><p>
 * To execute the query use {@link ch.ivyteam.ivy.security.query.IUserQueryExecutor}.
 * See {@link ch.ivyteam.ivy.security.user.IUserRepository#queryExecutor() ivy.wf.getSecurityContext().users().queryExecutor()}
 * </p><p>
 * <b>Example how to filter and order data:</b>
 * <code><pre>import ch.ivyteam.ivy.security.query.UserQuery;
 *import ch.ivyteam.ivy.security.IUser;
 *import ch.ivyteam.ivy.security.IRole;
 *
 *IRole manager = ivy.wf.getSecurityContext().findRole("manager");
 *UserQuery userQuery = UserQuery.create();
 *List&lt;IUser&gt; users = userQuery.where().hasRole(manager)
 * .orderBy().name().ascending()
 * .executor().results();
 * </pre></code>
 * <p>Note, that a UserQuery by default returns only users of the
 * {@link ch.ivyteam.ivy.security.ISecurityContext#current() current security context}.
 * It is <b>not</b> necessary to explicit filter the users with {@link IFilterableColumns#securitySystemId}
 * as this is already implicitly done by the UserQuery itself.
 * </p>
