/*

 jquery.layout 1.9.0
 $Date: 2024-01-17 $
 $Rev: 1.9.0 $

 Copyright (c) 2014 Kevin Dalman (http://jquery-dev.com)
 Based on work by Fabrizio Balliano (http://www.fabrizioballiano.net)

 Dual licensed under the GPL (http://www.gnu.org/licenses/gpl.html)
 and MIT (http://www.opensource.org/licenses/mit-license.php) licenses.

 SEE: http://layout.jquery-dev.com/LICENSE.txt

 Changelog: http://layout.jquery-dev.com/changelog.cfm

 Docs: http://layout.jquery-dev.com/documentation.html
 Tips: http://layout.jquery-dev.com/tips.html
 Help: http://groups.google.com/group/jquery-ui-layout

 History
 2016/28/10 - Added responsiveness - marc magon
 2018/01/27 - Updated the toggler class and responsive properties
 2018/04/02 - Switch unbinds to .off() as recommended

 2019/02/09 - @rsprinkle      Add AMD Support,
              @alexsielicki   Fixing issue with running under webpack with jQuery 3.3.1 and jQuery Migrate plugin

 2019/03/25 - @rsprinkle      AMD Support - Return JQuery
 jquery.layout.state 1.0
 $Date: 2011-07-16 08:00:00 (Sat, 16 July 2011) $

 Copyright (c) 2010
   Kevin Dalman (http://allpro.net)

 Dual licensed under the GPL (http://www.gnu.org/licenses/gpl.html)
 and MIT (http://www.opensource.org/licenses/mit-license.php) licenses.

 @dependancies: UI Layout 1.8.2 or higher
 @dependancies: Persist.js

 @support: http://groups.google.com/group/jquery-ui-layout
*/
(function(U){"function"===typeof define&&define.amd?define(["jquery"],U):U(jQuery)})(function(U){(function(d){var v=Math.min,p=Math.max,u=Math.floor,x=function(n){return"string"===typeof n},C=function(n,y){if(Array.isArray(y))for(var B=0,E=y.length;B<E;B++){var I=y[B];try{x(I)&&(I=eval(I)),"function"===typeof I&&I(n)}catch(A){}}};d.layout={version:"1.9.0",revision:1.9004,browser:{},effects:{slide:{all:{duration:"fast"},north:{direction:"up"},south:{direction:"down"},east:{direction:"right"},west:{direction:"left"}},
drop:{all:{duration:"slow"},north:{direction:"up"},south:{direction:"down"},east:{direction:"right"},west:{direction:"left"}},scale:{all:{duration:"fast"}},blind:{},clip:{},explode:{},fade:{},fold:{},puff:{},size:{all:{easing:"swing"}}},config:{optionRootKeys:"effects panes north south west east center".split(" "),allPanes:["north","south","west","east","center"],borderPanes:["north","south","west","east"],oppositeEdge:{north:"south",south:"north",east:"west",west:"east"},offscreenCSS:{left:"-99999px",
right:"auto"},offscreenReset:"offscreenReset",hidden:{visibility:"hidden"},visible:{visibility:"visible"},resizers:{cssReq:{position:"absolute",padding:0,margin:0,fontSize:"1px",textAlign:"left",overflow:"hidden"},cssDemo:{background:"#DDD",border:"none"}},togglers:{cssReq:{position:"absolute",display:"block",padding:0,margin:0,overflow:"hidden",textAlign:"center",fontSize:"1px",cursor:"pointer",zIndex:1},cssDemo:{background:"#AAA"}},content:{cssReq:{position:"relative"},cssDemo:{overflow:"auto",
padding:"10px"},cssDemoPane:{overflow:"hidden",padding:0}},panes:{cssReq:{position:"absolute",margin:0},cssDemo:{padding:"10px",background:"#FFF",border:"1px solid #BBB",overflow:"auto"}},north:{side:"top",sizeType:"Height",dir:"horz",cssReq:{top:0,bottom:"auto",left:0,right:0,width:"auto"}},south:{side:"bottom",sizeType:"Height",dir:"horz",cssReq:{top:"auto",bottom:0,left:0,right:0,width:"auto"}},east:{side:"right",sizeType:"Width",dir:"vert",cssReq:{left:"auto",right:0,top:"auto",bottom:"auto",
height:"auto"}},west:{side:"left",sizeType:"Width",dir:"vert",cssReq:{left:0,right:"auto",top:"auto",bottom:"auto",height:"auto"}},center:{dir:"center",cssReq:{left:"auto",right:"auto",top:"auto",bottom:"auto",height:"auto",width:"auto"}}},callbacks:{},getParentPaneElem:function(n){n=d(n);if(n=n.data("layout")||n.data("parentLayout")){n=n.container;if(n.data("layoutPane"))return n;n=n.closest("."+d.layout.defaults.panes.paneClass);if(n.data("layoutPane"))return n}return null},getParentPaneInstance:function(n){return(n=
d.layout.getParentPaneElem(n))?n.data("layoutPane"):null},getParentLayoutInstance:function(n){return(n=d.layout.getParentPaneElem(n))?n.data("parentLayout"):null},getEventObject:function(n){return"object"===typeof n&&n.stopPropagation?n:null},parsePaneName:function(n){var y=d.layout.getEventObject(n);y&&(y.stopPropagation(),n=d(this).data("layoutEdge"));n&&!/^(west|east|north|south|center)$/.test(n)&&(d.layout.msg('LAYOUT ERROR - Invalid pane-name: "'+n+'"'),n="error");return n},plugins:{draggable:!!d.fn.draggable,
effects:{core:!!d.effects,slide:d.effects&&(d.effects.slide||d.effects.effect&&d.effects.effect.slide)}},onCreate:[],onLoad:[],onReady:[],onDestroy:[],onUnload:[],afterOpen:[],afterClose:[],scrollbarWidth:function(){return window.scrollbarWidth||d.layout.getScrollbarSize("width")},scrollbarHeight:function(){return window.scrollbarHeight||d.layout.getScrollbarSize("height")},getScrollbarSize:function(n){var y=d('\x3cdiv style\x3d"position: absolute; top: -10000px; left: -10000px; width: 100px; height: 100px; border: 0; overflow: scroll;"\x3e\x3c/div\x3e').appendTo("body"),
B={width:y.outerWidth-y[0].clientWidth,height:100-y[0].clientHeight};y.remove();window.scrollbarWidth=B.width;window.scrollbarHeight=B.height;return n.match(/^(width|height)$/)?B[n]:B},disableTextSelection:function(){var n=d(document);d.fn.disableSelection&&(n.data("textSelectionInitialized")||n.on("mouseup",d.layout.enableTextSelection).data("textSelectionInitialized",!0),n.data("textSelectionDisabled")||n.disableSelection().data("textSelectionDisabled",!0))},enableTextSelection:function(){var n=
d(document);d.fn.enableSelection&&n.data("textSelectionDisabled")&&n.enableSelection().data("textSelectionDisabled",!1)},showInvisibly:function(n,y){return n&&n.length&&(y||"none"===n.css("display"))?(y=n[0].style,y={display:y.display||"",visibility:y.visibility||""},n.css({display:"block",visibility:"hidden"}),y):{}},getElementDimensions:function(n,y){var B={css:{},inset:{}},E=B.css,I={bottom:0},A=d.layout.cssNum,M=Math.round,r=n.offset(),z,L,Q;B.offsetLeft=r.left;B.offsetTop=r.top;y||(y={});d.each(["Left",
"Right","Top","Bottom"],function(P,w){z=E["border"+w]=d.layout.borderWidth(n,w);L=E["padding"+w]=d.layout.cssNum(n,"padding"+w);Q=w.toLowerCase();B.inset[Q]=0<=y[Q]?y[Q]:L;I[Q]=B.inset[Q]+z});E.width=M(n.width());E.height=M(n.height());E.top=A(n,"top",!0);E.bottom=A(n,"bottom",!0);E.left=A(n,"left",!0);E.right=A(n,"right",!0);B.outerWidth=M(n.outerWidth());B.outerHeight=M(n.outerHeight());B.innerWidth=p(0,B.outerWidth-I.left-I.right);B.innerHeight=p(0,B.outerHeight-I.top-I.bottom);B.layoutWidth=M(n.innerWidth());
B.layoutHeight=M(n.innerHeight());return B},getElementStyles:function(n,y){var B={};n=n[0].style;y=y.split(",");var E=["Top","Bottom","Left","Right"],I=["Color","Style","Width"],A,M,r;for(A=0;A<y.length;A++){var z=y[A];if(z.match(/(border|padding|margin)$/))for(M=0;4>M;M++){var L=E[M];if("border"===z)for(r=0;3>r;r++){var Q=I[r];B[z+L+Q]=n[z+L+Q]}else B[z+L]=n[z+L]}else B[z]=n[z]}return B},cssWidth:function(n,y){if(0>=y)return 0;var B=d.layout.browser;B=B.boxModel?B.boxSizing?n.css("boxSizing"):"content-box":
"border-box";var E=d.layout.borderWidth,I=d.layout.cssNum;"border-box"!==B&&(y-=E(n,"Left")+E(n,"Right"));"content-box"===B&&(y-=I(n,"paddingLeft")+I(n,"paddingRight"));return p(0,y)},cssHeight:function(n,y){if(0>=y)return 0;var B=d.layout.browser;B=B.boxModel?B.boxSizing?n.css("boxSizing"):"content-box":"border-box";var E=d.layout.borderWidth,I=d.layout.cssNum;"border-box"!==B&&(y-=E(n,"Top")+E(n,"Bottom"));"content-box"===B&&(y-=I(n,"paddingTop")+I(n,"paddingBottom"));return p(0,y)},cssNum:function(n,
y,B){n.jquery||(n=d(n));var E=d.layout.showInvisibly(n);y=d.css(n[0],y,!0);B=B&&"auto"==y?y:Math.round(parseFloat(y)||0);n.css(E);return B},borderWidth:function(n,y){n.jquery&&(n=n[0]);y="border"+y.substr(0,1).toUpperCase()+y.substr(1);return"none"===d.css(n,y+"Style",!0)?0:Math.round(parseFloat(d.css(n,y+"Width",!0))||0)},isMouseOverElem:function(n,y){var B=d(y||this),E=B.offset();y=E.top;E=E.left;var I=E+B.outerWidth();B=y+B.outerHeight();var A=n.pageX;n=n.pageY;return A>=E&&A<=I&&n>=y&&n<=B},msg:function(n,
y,B,E){d.isPlainObject(n)&&window.debugData?("string"===typeof y?(E=B,B=y):"object"===typeof B&&(E=B,B=null),B=B||"log( \x3cobject\x3e )",E=d.extend({sort:!1,returnHTML:!1,display:!1},E),!0===y||E.display?debugData(n,B,E):window.console&&console.log(debugData(n,B,E))):y?alert(n):window.console?console.log(n):(y=d("#layoutLogger"),y.length||(y=d('\x3cdiv id\x3d"layoutLogger" style\x3d"position: '+(d.support.fixedPosition?"fixed":"absolute")+'; top: 5px; z-index: 999999; max-width: 25%; overflow: hidden; border: 1px solid #000; border-radius: 5px; background: #FBFBFB; box-shadow: 0 2px 10px rgba(0,0,0,0.3);"\x3e\x3cdiv style\x3d"font-size: 13px; font-weight: bold; padding: 5px 10px; background: #F6F6F6; border-radius: 5px 5px 0 0; cursor: move;"\x3e\x3cspan style\x3d"float: right; padding-left: 7px; cursor: pointer;" title\x3d"Remove Console" onclick\x3d"$(this).closest(\'#layoutLogger\').remove()"\x3eX\x3c/span\x3eLayout console.log\x3c/div\x3e\x3cul style\x3d"font-size: 13px; font-weight: none; list-style: none; margin: 0; padding: 0 0 2px;"\x3e\x3c/ul\x3e\x3c/div\x3e').appendTo("body"),
y.css("left",d(window).width()-y.outerWidth()-5),d.ui.draggable&&y.draggable({handle:":first-child"})),y.children("ul").append('\x3cli style\x3d"padding: 4px 10px; margin: 0; border-top: 1px solid #CCC;"\x3e'+n.replace(/</g,"\x26lt;").replace(/>/g,"\x26gt;")+"\x3c/li\x3e"))}};(function(){var n=navigator.userAgent.toLowerCase();n=/(chrome)[ \/]([\w.]+)/.exec(n)||/(webkit)[ \/]([\w.]+)/.exec(n)||/(opera)(?:.*version|)[ \/]([\w.]+)/.exec(n)||0>n.indexOf("compatible")&&/(mozilla)(?:.*? rv:([\w.]+)|)/.exec(n)||
[];var y=n[1]||"",B=document.compatMode,E=d.support,I=void 0!==E.boxSizing?E.boxSizing:E.boxSizingReliable,A=!B||"CSS1Compat"===B||E.boxModel||!1,M=d.layout.browser={version:n[2]||0,safari:"webkit"===y,webkit:"chrome"===y,boxModel:A,boxSizing:!("function"===typeof I?!I():!I)};y&&(M[y]=!0);A||B||d(function(){M.boxModel=E.boxModel})})();d.layout.defaults={name:"",containerClass:"ui-layout-container",inset:null,scrollToBookmarkOnLoad:!0,resizeWithWindow:!0,resizeWithWindowDelay:200,resizeWithWindowMaxDelay:0,
maskPanesEarly:!1,onresizeall_start:null,onresizeall_end:null,onload_start:null,onload_end:null,onunload_start:null,onunload_end:null,initPanes:!0,showErrorMessages:!0,showDebugMessages:!1,zIndex:null,zIndexes:{pane_normal:0,content_mask:1,resizer_normal:2,pane_sliding:100,pane_animate:1E3,resizer_drag:1E4},errors:{pane:"pane",selector:"selector",addButtonError:"Error Adding Button\nInvalid ",containerMissing:"UI Layout Initialization Error\nThe specified layout-container does not exist.",centerPaneMissing:"UI Layout Initialization Error\nThe center-pane element does not exist.\nThe center-pane is a required element.",
noContainerHeight:"UI Layout Initialization Warning\nThe layout-container \"CONTAINER\" has no height.\nTherefore the layout is 0-height and hence 'invisible'!",callbackError:"UI Layout Callback Error\nThe EVENT callback is not a valid function."},panes:{applyDemoStyles:!1,responsive:{enabled:!1,when:"md",sizes:{xl:1140,lg:992,md:768,sm:576,xs:0}},closable:!0,resizable:!0,slidable:!0,initClosed:!1,initHidden:!1,contentSelector:".ui-layout-content",contentIgnoreSelector:".ui-layout-ignore",findNestedContent:!1,
paneClass:"ui-layout-pane",resizerClass:"ui-layout-resizer",togglerClass:"ui-layout-toggler",buttonClass:"ui-layout-button",minSize:0,maxSize:0,spacing_open:6,spacing_closed:6,togglerLength_open:50,togglerLength_closed:50,togglerAlign_open:"center",togglerAlign_closed:"center",togglerContent_open:"",togglerContent_closed:"",resizerDblClickToggle:!0,autoResize:!0,autoReopen:!0,resizerDragOpacity:1,draggableIframeFix:!1,maskContents:!1,maskObjects:!1,maskZindex:null,resizingGrid:!1,livePaneResizing:!1,
liveContentResizing:!1,liveResizingTolerance:1,sliderCursor:"pointer",slideTrigger_open:"click",slideTrigger_close:"mouseleave",slideDelay_open:300,slideDelay_close:300,hideTogglerOnSlide:!1,preventQuickSlideClose:d.layout.browser.webkit,preventPrematureSlideClose:!1,tips:{Open:"Open",Close:"Close",Resize:"Resize",Slide:"Slide Open",Pin:"Pin",Unpin:"Un-Pin",noRoomToOpen:"Not enough room to show this panel.",minSizeWarning:"Panel has reached its minimum size",maxSizeWarning:"Panel has reached its maximum size"},
showOverflowOnHover:!1,enableCursorHotkey:!0,customHotkeyModifier:"SHIFT",fxName:"slide",fxSpeed:null,fxSettings:{},fxOpacityFix:!0,animatePaneSizing:!1,children:null,containerSelector:"",initChildren:!0,destroyChildren:!0,resizeChildren:!0,triggerEventsOnLoad:!1,triggerEventsDuringLiveResize:!0,onshow_start:null,onshow_end:null,onhide_start:null,onhide_end:null,onopen_start:null,onopen_end:null,onclose_start:null,onclose_end:null,onresize_start:null,onresize_end:function(){},onsizecontent_start:null,
onsizecontent_end:null,onswap_start:null,onswap_end:null,ondrag_start:null,ondrag_end:null},north:{paneSelector:".ui-layout-north",size:"auto",resizerCursor:"n-resize",customHotkey:""},south:{paneSelector:".ui-layout-south",size:"auto",resizerCursor:"s-resize",customHotkey:""},east:{paneSelector:".ui-layout-east",size:200,resizerCursor:"e-resize",customHotkey:""},west:{paneSelector:".ui-layout-west",size:200,resizerCursor:"w-resize",customHotkey:""},center:{paneSelector:".ui-layout-center",minWidth:0,
minHeight:0}};d.layout.optionsMap={layout:"name instanceKey stateManagement effects inset zIndexes errors zIndex scrollToBookmarkOnLoad showErrorMessages maskPanesEarly outset resizeWithWindow resizeWithWindowDelay resizeWithWindowMaxDelay iframeFix onresizeall onresizeall_start onresizeall_end onload onload_start onload_end onunload onunload_start onunload_end".split(" "),center:"paneClass contentSelector contentIgnoreSelector findNestedContent applyDemoStyles triggerEventsOnLoad showOverflowOnHover maskContents maskObjects liveContentResizing iframeFix containerSelector children initChildren resizeChildren destroyChildren onresize onresize_start onresize_end onsizecontent onsizecontent_start onsizecontent_end".split(" "),
noDefault:["paneSelector","resizerCursor","customHotkey"]};d.layout.transformData=function(n,y){y=y?{panes:{},center:{}}:{};var B,E;if("object"!==typeof n)return y;for(B in n){var I=y;var A=n[B];var M=B.split("__");var r=M.length-1;for(E=0;E<=r;E++){var z=M[E];E===r?d.isPlainObject(A)?I[z]=d.layout.transformData(A):I[z]=A:(I[z]||(I[z]={}),I=I[z])}}return y};d.layout.backwardCompatibility={map:{applyDefaultStyles:"applyDemoStyles",childOptions:"children",initChildLayout:"initChildren",destroyChildLayout:"destroyChildren",
resizeChildLayout:"resizeChildren",resizeNestedLayout:"resizeChildren",resizeWhileDragging:"livePaneResizing",resizeContentWhileDragging:"liveContentResizing",triggerEventsWhileDragging:"triggerEventsDuringLiveResize",maskIframesOnResize:"maskContents",useStateCookie:"stateManagement.enabled","cookie.autoLoad":"stateManagement.autoLoad","cookie.autoSave":"stateManagement.autoSave","cookie.keys":"stateManagement.stateKeys","cookie.name":"stateManagement.cookie.name","cookie.domain":"stateManagement.cookie.domain",
"cookie.path":"stateManagement.cookie.path","cookie.expires":"stateManagement.cookie.expires","cookie.secure":"stateManagement.cookie.secure",noRoomToOpenTip:"tips.noRoomToOpen",togglerTip_open:"tips.Close",togglerTip_closed:"tips.Open",resizerTip:"tips.Resize",sliderTip:"tips.Slide"},renameOptions:function(n){function y(r,z){r=r.split(".");for(var L=r.length-1,Q={branch:n,key:r[L]},P=0,w;P<L;P++)w=r[P],Q.branch=void 0===Q.branch[w]?z?Q.branch[w]={}:{}:Q.branch[w];return Q}var B=d.layout.backwardCompatibility.map,
E;for(E in B){var I=y(E);var A=I.branch[I.key];if(void 0!==A){var M=y(B[E],!0);M.branch[M.key]=A;delete I.branch[I.key]}}},renameAllOptions:function(n){var y=d.layout.backwardCompatibility.renameOptions;y(n);n.defaults&&("object"!==typeof n.panes&&(n.panes={}),d.extend(!0,n.panes,n.defaults),delete n.defaults);n.panes&&y(n.panes);d.each(d.layout.config.allPanes,function(B,E){n[E]&&y(n[E])});return n}};d.fn.layout=function(n){function y(b){if(!b)return!0;var c=b.keyCode;if(33>c)return!0;var e={38:"north",
40:"south",37:"west",39:"east"},f=b.shiftKey,g=b.ctrlKey,h,k,q,l;g&&37<=c&&40>=c&&w[e[c]].enableCursorHotkey?l=e[c]:(g||f)&&d.each(A.borderPanes,function(m,D){h=w[D];k=h.customHotkey;q=h.customHotkeyModifier;if((f&&"SHIFT"==q||g&&"CTRL"==q||g&&f)&&k&&c===(isNaN(k)||9>=k?k.toUpperCase().charCodeAt(0):k))return l=D,!1});if(!l||!F[l]||!w[l].closable||t[l].isHidden)return!0;ya(l);b.stopPropagation();return b.returnValue=!1}function B(b){if(Y()){this&&this.tagName&&(b=this);var c;x(b)?c=F[b]:d(b).data("layoutRole")?
c=d(b):d(b).parents().each(function(){if(d(this).data("layoutRole"))return c=d(this),!1});if(c&&c.length){var e=c.data("layoutEdge");b=t[e];b.cssSaved&&E(e);if(b.isSliding||b.isResizing||b.isClosed)b.cssSaved=!1;else{var f={zIndex:w.zIndexes.resizer_normal+1},g={},h=c.css("overflow"),k=c.css("overflowX"),q=c.css("overflowY");"visible"!=h&&(g.overflow=h,f.overflow="visible");k&&!k.match(/(visible|auto)/)&&(g.overflowX=k,f.overflowX="visible");q&&!q.match(/(visible|auto)/)&&(g.overflowY=k,f.overflowY=
"visible");b.cssSaved=g;c.css(f);d.each(A.allPanes,function(l,m){m!=e&&E(m)})}}}}function E(b){if(Y()){this&&this.tagName&&(b=this);var c;x(b)?c=F[b]:d(b).data("layoutRole")?c=d(b):d(b).parents().each(function(){if(d(this).data("layoutRole"))return c=d(this),!1});if(c&&c.length){b=c.data("layoutEdge");b=t[b];var e=b.cssSaved||{};b.isSliding||b.isResizing||c.css("zIndex",w.zIndexes.pane_normal);c.css(e);b.cssSaved=!1}}}var I=d.layout.browser,A=d.layout.config,M=d.layout.cssWidth,r=d.layout.cssHeight,
z=d.layout.getElementDimensions,L=d.layout.getElementStyles,Q=d.layout.getEventObject,P=d.layout.parsePaneName,w=d.extend(!0,{},d.layout.defaults);w.effects=d.extend(!0,{},d.layout.effects);var t={id:"layout"+d.now(),initialized:!1,paneResizing:!1,panesSliding:{},container:{innerWidth:0,innerHeight:0,outerWidth:0,outerHeight:0,layoutWidth:0,layoutHeight:0},north:{childIdx:0},south:{childIdx:0},east:{childIdx:0},west:{childIdx:0},center:{childIdx:0}},R={north:null,south:null,east:null,west:null,center:null},
O={data:{},set:function(b,c,e){O.clear(b);O.data[b]=setTimeout(c,e)},clear:function(b){var c=O.data;c[b]&&(clearTimeout(c[b]),delete c[b])}},S=function(b,c,e){var f=w;(f.showErrorMessages&&!e||e&&f.showDebugMessages)&&d.layout.msg(f.name+" / "+b,!1!==c);return!1},N=function(b,c,e){var f=c&&x(c),g=f?t[c]:t,h=f?w[c]:w,k=w.name,q=b+(b.match(/_/)?"":"_end"),l=q.match(/_end$/)?q.substr(0,q.length-4):"",m=h[q]||h[l],D="NC",H=[],G=f?F[c]:0;if(f&&!G)return D;f||"boolean"!==typeof c||(e=c,c="");if(m)try{x(m)&&
(m.match(/,/)?(H=m.split(","),m=eval(H[0])):m=eval(m)),"function"===typeof m&&(D=H.length?m(H[1]):f?m(c,F[c],g,h,k):m(T,g,h,k))}catch(V){S(w.errors.callbackError.replace(/EVENT/,String.prototype.trim((c||"")+" "+q)),!1),"string"===typeof V&&string.length&&S("Exception:  "+V,!1)}e||!1===D||(f?(h=w[c],g=t[c],G.triggerHandler("layoutpane"+q,[c,G,g,h,k]),l&&G.triggerHandler("layoutpane"+l,[c,G,g,h,k])):(K.triggerHandler("layout"+q,[T,g,h,k]),l&&K.triggerHandler("layout"+l,[T,g,h,k])));f&&"onresize_end"===
b&&Xa(c+"",!0);return D},fa=function(b){if(!I.mozilla){var c=F[b];"IFRAME"===t[b].tagName?c.css(A.hidden).css(A.visible):c.find("IFRAME").css(A.hidden).css(A.visible)}},ua=function(b){var c=F[b];b=A[b].dir;c={minWidth:1001-M(c,1E3),minHeight:1001-r(c,1E3)};"horz"===b&&(c.minSize=c.minHeight);"vert"===b&&(c.minSize=c.minWidth);return c},lb=function(b,c,e){var f=b;x(b)?f=F[b]:b.jquery||(f=d(b));b=r(f,c);f.css({height:b,visibility:"visible"});0<b&&0<f.innerWidth()?e&&f.data("autoHidden")&&(f.show().data("autoHidden",
!1),I.mozilla||f.css(A.hidden).css(A.visible)):e&&!f.data("autoHidden")&&f.hide().data("autoHidden",!0)},oa=function(b,c,e){e||(e=A[b].dir);x(c)&&c.match(/%/)&&(c="100%"===c?-1:parseInt(c,10)/100);if(0===c)return 0;if(1<=c)return parseInt(c,10);var f=w,g=0;"horz"==e?g=J.innerHeight-(F.north?f.north.spacing_open:0)-(F.south?f.south.spacing_open:0):"vert"==e&&(g=J.innerWidth-(F.west?f.west.spacing_open:0)-(F.east?f.east.spacing_open:0));if(-1===c)return g;if(0<c)return u(g*c);if("center"==b)return 0;
e="horz"===e?"height":"width";f=F[b];b="height"===e?ia[b]:!1;g=d.layout.showInvisibly(f);var h=f.css(e),k=b?b.css(e):0;f.css(e,"auto");b&&b.css(e,"auto");c="height"===e?f.outerHeight():f.outerWidth();f.css(e,h).css(g);b&&b.css(e,k);return c},pa=function(b,c){var e=F[b],f=w[b],g=t[b],h=c?f.spacing_open:0;f=c?f.spacing_closed:0;return!e||g.isHidden?0:g.isClosed||g.isSliding&&c?f:"horz"===A[b].dir?e.outerHeight()+h:e.outerWidth()+h},ka=function(b,c){if(Y()){var e=w[b],f=t[b],g=A[b],h=g.dir;g.sizeType.toLowerCase();
c=void 0!=c?c:f.isSliding;g=e.spacing_open;var k=A.oppositeEdge[b],q=t[k],l=F[k],m=!l||!1===q.isVisible||q.isSliding?0:"horz"==h?l.outerHeight():l.outerWidth();k=(!l||q.isHidden?0:w[k][!1!==q.isClosed?"spacing_closed":"spacing_open"])||0;q="horz"==h?J.innerHeight:J.innerWidth;l=ua("center");l="horz"==h?p(w.center.minHeight,l.minHeight):p(w.center.minWidth,l.minWidth);c=q-g-(c?0:oa("center",l,h)+m+k);h=f.minSize=p(oa(b,e.minSize),ua(b).minSize);c=f.maxSize=v(e.maxSize?oa(b,e.maxSize):1E5,c);f=f.resizerPosition=
{};g=J.inset.top;m=J.inset.left;k=J.innerWidth;q=J.innerHeight;e=e.spacing_open;switch(b){case "north":f.min=g+h;f.max=g+c;break;case "west":f.min=m+h;f.max=m+c;break;case "south":f.min=g+q-c-e;f.max=g+q-h-e;break;case "east":f.min=m+k-c-e,f.max=m+k-h-e}}},Oa=function(b,c){b=d(b);var e=b.data("layoutRole"),f=b.data("layoutEdge"),g=w[f][e+"Class"];f="-"+f;var h=b.hasClass(g+"-closed")?"-closed":"-open",k="-closed"===h?"-open":"-closed";h=g+"-hover "+(g+f+"-hover ")+(g+h+"-hover ")+(g+f+h+"-hover ");
c&&(h+=g+k+"-hover "+(g+f+k+"-hover "));"resizer"==e&&b.hasClass(g+"-sliding")&&(h+=g+"-sliding-hover "+(g+f+"-sliding-hover "));return String.prototype.trim.call(h)},Pa=function(b,c){c=d(c||this);b&&"toggler"===c.data("layoutRole")&&b.stopPropagation();c.addClass(Oa(c))},ma=function(b,c){b=d(c||this);b.removeClass(Oa(b,!0))},Ya=function(b){b=d(this).data("layoutEdge");var c=t[b];d(document);c.isResizing||t.paneResizing||w.maskPanesEarly&&Da(b,{resizing:!0})},Za=function(b,c){var e=c||this,f=d(e).data("layoutEdge"),
g=f+"ResizerLeave";d(document);O.clear(f+"_openSlider");O.clear(g);c?w.maskPanesEarly&&!t.paneResizing&&Ga():O.set(g,function(){Za(b,e)},200)},Y=function(){return t.initialized||t.creatingLayout?!0:Ha()},Ha=function(b){var c=w;if(!K.is(":visible"))return!b&&I.webkit&&"BODY"===K[0].tagName&&setTimeout(function(){Ha(!0)},50),!1;if(!$a("center").length)return S(c.errors.centerPaneMissing);t.creatingLayout=!0;d.extend(J,z(K,c.inset));mb();c.scrollToBookmarkOnLoad&&(b=self.location,b.hash&&b.replace(b.hash));
if(T.hasParentLayout)c.resizeWithWindow=!1;else if(c.resizeWithWindow)d(window).on("resize."+aa,nb);delete t.creatingLayout;t.initialized=!0;C(T,d.layout.onReady);N("onload_end");return!0},Qa=function(b,c){var e=P.call(this,b),f=F[e];if(f){var g=ia[e],h=t[e];b=w[e];var k=w.stateManagement||{};c=c?b.children=c:b.children;if(d.isPlainObject(c))c=[c];else if(!c||!Array.isArray(c))return;d.each(c,function(q,l){d.isPlainObject(l)&&(l.containerSelector?f.find(l.containerSelector):g||f).each(function(){var m=
d(this),D=m.data("layout");if(!D){ab({container:m,options:l},h);if(k.includeChildren&&t.stateData[e]){D=(t.stateData[e].children||{})[l.instanceKey];var H=l.stateManagement||(l.stateManagement={autoLoad:!0});!0===H.autoLoad&&D&&(H.autoSave=!1,H.includeChildren=!0,H.autoLoad=d.extend(!0,{},D))}(D=m.layout(l))&&Ia(e,D)}})})}},ab=function(b,c){var e=b.container;b=b.options;var f=b.stateManagement,g=b.instanceKey||e.data("layoutInstanceKey");g||(g=(f&&f.cookie?f.cookie.name:"")||b.name);g=g?g.replace(/[^\w-]/gi,
"_").replace(/_{2,}/g,"_"):"layout"+ ++c.childIdx;b.instanceKey=g;e.data("layoutInstanceKey",g);return g},Ia=function(b,c){var e=F[b],f=R[b],g=t[b];d.isPlainObject(f)&&(d.each(f,function(h,k){k.destroyed&&delete f[h]}),d.isEmptyObject(f)&&(f=R[b]=null));c||f||(c=e.data("layout"));c&&(c.hasParentLayout=!0,e=c.options,ab(c,g),f||(f=R[b]={}),f[e.instanceKey]=c.container.data("layout"));T[b].children=R[b];c||Qa(b)},nb=function(){var b=w,c=Number(b.resizeWithWindowDelay);10>c&&(c=100);O.clear("winResize");
O.set("winResize",function(){O.clear("winResize");O.clear("winResizeRepeater");var e=z(K,b.inset);e.innerWidth===J.innerWidth&&e.innerHeight===J.innerHeight||va()},c);O.data.winResizeRepeater||bb()},bb=function(){var b=Number(w.resizeWithWindowMaxDelay);0<b&&O.set("winResizeRepeater",function(){bb();va()},b)},cb=function(){N("onunload_start");C(T,d.layout.onUnload);N("onunload_end")},ob=function(){var b=K[0],c=d("html"),e=J.tagName=b.tagName,f=J.id=b.id,g=J.className=b.className;b=w;var h=b.name,
k={},q=K.data("parentLayout"),l=K.data("layoutEdge"),m=q&&l,D=d.layout.cssNum;J.ref=(b.name?b.name+" layout / ":"")+e+(f?"#"+f:g?".["+g+"]":"");J.isBody="BODY"===e;m||J.isBody||(e=K.closest("."+d.layout.defaults.panes.paneClass),q=e.data("parentLayout"),l=e.data("layoutEdge"),m=q&&l);K.data({layout:T,layoutContainer:aa}).addClass(b.containerClass);e={destroy:"",initPanes:"",resizeAll:"resizeAll",resize:"resizeAll"};for(h in e)K.on("layout"+h.toLowerCase()+"."+aa,T[e[h]||h]);m&&(T.hasParentLayout=
!0,q.refreshChildren(l,T));K.data("layoutCSS")||(J.isBody?(K.data("layoutCSS",d.extend(L(K,"position,margin,padding,border"),{height:K.css("height"),overflow:K.css("overflow"),overflowX:K.css("overflowX"),overflowY:K.css("overflowY")})),c.data("layoutCSS",d.extend(L(c,"padding"),{height:"auto",overflow:c.css("overflow"),overflowX:c.css("overflowX"),overflowY:c.css("overflowY")}))):K.data("layoutCSS",L(K,"position,margin,padding,border,top,bottom,left,right,width,height,overflow,overflowX,overflowY")));
try{k={overflow:"hidden",overflowX:"hidden",overflowY:"hidden"};K.css(k);if(b.inset&&!d.isPlainObject(b.inset)){var H=parseInt(b.inset,10)||0;b.inset={top:H,bottom:H,left:H,right:H}}if(J.isBody)b.outset?d.isPlainObject(b.outset)||(H=parseInt(b.outset,10)||0,b.outset={top:H,bottom:H,left:H,right:H}):b.outset={top:D(c,"paddingTop"),bottom:D(c,"paddingBottom"),left:D(c,"paddingLeft"),right:D(c,"paddingRight")},c.css(k).css({height:"100%",border:"none",padding:0,margin:0}),K.css({width:"auto",height:"auto",
margin:0,position:"absolute"}),K.css(b.outset),d.extend(J,z(K,b.inset));else{var G=K.css("position");G&&G.match(/(fixed|absolute|relative)/)||K.css("position","relative");K.is(":visible")&&(d.extend(J,z(K,b.inset)),1>J.innerHeight&&S(b.errors.noContainerHeight.replace(/CONTAINER/,J.ref)))}D(K,"minWidth")&&K.parent().css("overflowX","auto");D(K,"minHeight")&&K.parent().css("overflowY","auto")}catch(V){}},db=function(b){b=b?b.split(","):A.borderPanes;d.each(b,function(c,e){c=w[e];if(c.enableCursorHotkey||
c.customHotkey)return d(document).on("keydown."+aa,y),!1})},pb=function(){function b(l){var m=w[l],D=w.panes;m.fxSettings||(m.fxSettings={});D.fxSettings||(D.fxSettings={});d.each(["_open","_close","_size"],function(H,G){var V="fxName"+G;H="fxSpeed"+G;G="fxSettings"+G;var W=m[V]=m[V]||D[V]||m.fxName||D.fxName||"none",ca=d.effects&&(d.effects[W]||d.effects.effect&&d.effects.effect[W]);"none"!==W&&w.effects[W]&&ca||(W=m[V]="none");W=w.effects[W]||{};V=W.all||null;W=W[l]||null;m[H]=m[H]||D[H]||m.fxSpeed||
D.fxSpeed||null;m[G]=d.extend(!0,{},V,W,D.fxSettings,m.fxSettings,D[G],m[G])});delete m.fxName;delete m.fxSpeed;delete m.fxSettings}var c,e,f;n=d.layout.transformData(n,!0);n=d.layout.backwardCompatibility.renameAllOptions(n);if(!d.isEmptyObject(n.panes)){var g=d.layout.optionsMap.noDefault;var h=0;for(e=g.length;h<e;h++){var k=g[h];delete n.panes[k]}g=d.layout.optionsMap.layout;h=0;for(e=g.length;h<e;h++)k=g[h],delete n.panes[k]}g=d.layout.optionsMap.layout;var q=d.layout.config.optionRootKeys;for(k in n)h=
n[k],0>d.inArray(k,q)&&0>d.inArray(k,g)&&(n.panes[k]||(n.panes[k]=d.isPlainObject(h)?d.extend(!0,{},h):h),delete n[k]);d.extend(!0,w,n);d.each(A.allPanes,function(l,m){A[m]=d.extend(!0,{},A.panes,A[m]);c=w.panes;f=w[m];if("center"===m)for(g=d.layout.optionsMap.center,l=0,e=g.length;l<e;l++)k=g[l],n.center[k]||!n.panes[k]&&f[k]||(f[k]=c[k]);else f=w[m]=d.extend(!0,{},c,f),b(m),f.resizerClass||(f.resizerClass="ui-layout-resizer"),f.togglerClass||(f.togglerClass="ui-layout-toggler");f.paneClass||(f.paneClass=
"ui-layout-pane")});h=n.zIndex;q=w.zIndexes;0<h&&(q.pane_normal=h,q.content_mask=p(h+1,q.content_mask),q.resizer_normal=p(h+2,q.resizer_normal));delete w.panes},$a=function(b){b=w[b].paneSelector;if("#"===b.substr(0,1))return K.find(b).eq(0);var c=K.children(b).eq(0);return c.length?c:K.children("form:first").children(b).eq(0)},mb=function(b){P(b);d.each(A.allPanes,function(c,e){eb(e,!0)});Ra();d.each(A.borderPanes,function(c,e){F[e]&&t[e].isVisible&&(ka(e),qa(e))});ra("center");d.each(A.allPanes,
function(c,e){fb(e)})},eb=function(b,c){if(c||Y()){c=w[b];var e=t[b],f=A[b],g=f.dir,h="center"===b,k={},q=F[b];q?Sa(b,!1,!0,!1):ia[b]=!1;q=F[b]=$a(b);if(q.length){q.data("layoutCSS")||q.data("layoutCSS",L(q,"position,top,left,bottom,right,width,height,overflow,zIndex,display,backgroundColor,padding,margin,border"));T[b]={name:b,pane:F[b],content:ia[b],options:w[b],state:t[b],children:R[b]};q.data({parentLayout:T,layoutPane:T[b],layoutEdge:b,layoutRole:"pane"}).css(f.cssReq).css("zIndex",new String(w.zIndexes.pane_normal)).css(c.applyDemoStyles?
f.cssDemo:{}).addClass(c.paneClass+" "+c.paneClass+"-"+b).on("mouseenter."+aa,Pa).on("mouseleave."+aa,ma);f={hide:"",show:"",toggle:"",close:"",open:"",slideOpen:"",slideClose:"",slideToggle:"",size:"sizePane",sizePane:"sizePane",sizeContent:"",sizeHandles:"",enableClosable:"",disableClosable:"",enableSlideable:"",disableSlideable:"",enableResizable:"",disableResizable:"",swapPanes:"swapPanes",swap:"swapPanes",move:"swapPanes",removePane:"removePane",remove:"removePane",createChildren:"",resizeChildren:"",
resizeAll:"resizeAll",resizeLayout:"resizeAll"};for(m in f)q.on("layoutpane"+m.toLowerCase()+"."+aa,T[f[m]||m]);Ta(b,!1);if(!h){var l=e.size=oa(b,c.size);var m=oa(b,c.minSize)||1;h=oa(b,c.maxSize)||1E5;0<l&&(l=p(v(l,h),m));e.autoResize=c.autoResize;e.isClosed=!1;e.isSliding=!1;e.isResizing=!1;e.isHidden=!1;e.pins||(e.pins=[])}e.tagName=q[0].tagName;e.edge=b;e.noRoom=!1;e.isVisible=!0;gb(b);"horz"===g?k.height=r(q,l):"vert"===g&&(k.width=M(q,l));q.css(k);"horz"!=g&&ra(b,!0);t.initialized&&(Ra(b),db(b));
c.initClosed&&c.closable&&!c.initHidden?ja(b,!0,!0):c.initHidden||c.initClosed?za(b):e.noRoom||q.css("display","block");if(c.showOverflowOnHover)q.on("hover",B,E);t.initialized&&fb(b)}else F[b]=!1}},fb=function(b){var c=F[b],e=t[b],f=w[b];c&&(c.data("layout")&&Ia(b,c.data("layout")),e.isVisible&&(t.initialized?va():Aa(b),f.triggerEventsOnLoad?N("onresize_end",b):Xa(b,!0)),f.initChildren&&f.children&&Qa(b))},gb=function(b){b=b?b.split(","):A.borderPanes;d.each(b,function(c,e){c=F[e];var f=X[e],g=t[e],
h=A[e].side,k={};if(c){switch(e){case "north":k.top=J.inset.top;k.left=J.inset.left;k.right=J.inset.right;break;case "south":k.bottom=J.inset.bottom;k.left=J.inset.left;k.right=J.inset.right;break;case "west":k.left=J.inset.left;break;case "east":k.right=J.inset.right}c.css(k);f&&g.isClosed?f.css(h,J.inset[h]):f&&!g.isHidden&&f.css(h,J.inset[h]+pa(e))}})},Ra=function(b){b=b?b.split(","):A.borderPanes;d.each(b,function(c,e){c=F[e];X[e]=!1;ea[e]=!1;if(c){c=w[e];var f=t[e],g="#"===c.paneSelector.substr(0,
1)?c.paneSelector.substr(1):"",h=c.resizerClass,k=c.togglerClass,q="-"+e,l=T[e],m=l.resizer=X[e]=d("\x3cdiv\x3e\x3c/div\x3e");l=l.toggler=c.closable?ea[e]=d("\x3cdiv\x3e\x3c/div\x3e"):!1;!f.isVisible&&c.slidable&&m.attr("title",c.tips.Slide).css("cursor",c.sliderCursor);m.attr("id",g?g+"-resizer":"").data({parentLayout:T,layoutPane:T[e],layoutEdge:e,layoutRole:"resizer"}).css(A.resizers.cssReq).css("zIndex",new String(w.zIndexes.resizer_normal)).css(c.applyDemoStyles?A.resizers.cssDemo:{}).addClass(h+
" "+h+q).on("hover",Pa,ma).on("hover",Ya,Za).on("mousedown",d.layout.disableTextSelection).on("mouseup",d.layout.enableTextSelection).appendTo(K);d.fn.disableSelection&&m.disableSelection();if(c.resizerDblClickToggle)m.on("dblclick."+aa,ya);l&&(l.attr("id",g?g+"-toggler":"").data({parentLayout:T,layoutPane:T[e],layoutEdge:e,layoutRole:"toggler"}).css(A.togglers.cssReq).css(c.applyDemoStyles?A.togglers.cssDemo:{}).addClass(k+" "+k+q).on("hover",Pa,ma).on("mouseenter",Ya).appendTo(m),c.togglerContent_open&&
d("\x3cspan\x3e"+c.togglerContent_open+"\x3c/span\x3e").data({layoutEdge:e,layoutRole:"togglerContent"}).data("layoutRole","togglerContent").data("layoutEdge",e).addClass("content content-open").css("display","none").appendTo(l),c.togglerContent_closed&&d("\x3cspan\x3e"+c.togglerContent_closed+"\x3c/span\x3e").data({layoutEdge:e,layoutRole:"togglerContent"}).addClass("content content-closed").css("display","none").appendTo(l),hb(e));qb(e);f.isVisible?Ua(e):(Ja(e),wa(e,!0))}});Ba()},Ta=function(b,
c){if(Y()){var e=w[b],f=e.contentSelector,g=T[b],h=F[b];if(f)var k=g.content=ia[b]=e.findNestedContent?h.find(f).eq(0):h.children(f).eq(0);k&&k.length?(k.data("layoutRole","content"),k.data("layoutCSS")||k.data("layoutCSS",L(k,"height")),k.css(A.content.cssReq),e.applyDemoStyles&&(k.css(A.content.cssDemo),h.css(A.content.cssDemoPane)),h.css("overflowX").match(/(scroll|auto)/)&&h.css("overflow","hidden"),t[b].content={},!1!==c&&Aa(b)):g.content=ia[b]=!1}},qb=function(b){var c=d.layout.plugins.draggable;
b=b?b.split(","):A.borderPanes;d.each(b,function(f,g){var h=w[g];if(!c||!F[g]||!h.resizable)return h.resizable=!1,!0;var k=t[g],q=w.zIndexes;f=A[g];var l="horz"==f.dir?"top":"left",m=X[g],D=h.resizerClass,H=0,G,V,W=D+"-drag",ca=D+"-"+g+"-drag",xa=D+"-dragging",Z=D+"-"+g+"-dragging",ba=D+"-dragging-limit",da=D+"-"+g+"-dragging-limit",na=!1;k.isClosed||m.attr("title",h.tips.Resize).css("cursor",h.resizerCursor);m.draggable({containment:K[0],axis:"horz"==f.dir?"y":"x",delay:0,distance:1,grid:h.resizingGrid,
helper:"clone",opacity:h.resizerDragOpacity,addClasses:!1,iframeFix:h.draggableIframeFix,zIndex:q.resizer_drag,start:function(Ka,ha){h=w[g];k=t[g];V=h.livePaneResizing;if(!1===N("ondrag_start",g))return!1;k.isResizing=!0;t.paneResizing=g;O.clear(g+"_closeSlider");ka(g);G=k.resizerPosition;H=ha.position[l];m.addClass(W+" "+ca);na=!1;Da(g,{resizing:!0})},drag:function(Ka,ha){na||(ha.helper.addClass(xa+" "+Z).css({right:"auto",bottom:"auto"}).children().css("visibility","hidden"),na=!0,k.isSliding&&
F[g].css("zIndex",q.pane_sliding));var Ea=0;ha.position[l]<G.min?(ha.position[l]=G.min,Ea=-1):ha.position[l]>G.max&&(ha.position[l]=G.max,Ea=1);Ea?(ha.helper.addClass(ba+" "+da),window.defaultStatus=0<Ea&&g.match(/(north|west)/)||0>Ea&&g.match(/(south|east)/)?h.tips.maxSizeWarning:h.tips.minSizeWarning):(ha.helper.removeClass(ba+" "+da),window.defaultStatus="");V&&Math.abs(ha.position[l]-H)>=h.liveResizingTolerance&&(H=ha.position[l],e(Ka,ha,g))},stop:function(Ka,ha){d("body").enableSelection();window.defaultStatus=
"";m.removeClass(W+" "+ca);k.isResizing=!1;t.paneResizing=!1;e(Ka,ha,g,!0)}})});var e=function(f,g,h,k){var q=g.position,l=A[h];f=w[h];g=t[h];switch(h){case "north":var m=q.top;break;case "west":m=q.left;break;case "south":m=J.layoutHeight-q.top-f.spacing_open;break;case "east":m=J.layoutWidth-q.left-f.spacing_open}m-=J.inset[l.side];k?(!1!==N("ondrag_end",h)&&La(h,m,!1,!0),Ga(!0),g.isSliding&&Da(h,{resizing:!0})):Math.abs(m-g.size)<f.liveResizingTolerance||(La(h,m,!1,!0),la.each(ib))}},ib=function(){var b=
d(this),c=b.data("layoutMask");c=t[c];"IFRAME"==c.tagName&&c.isVisible&&b.css({top:c.offsetTop,left:c.offsetLeft,width:c.outerWidth,height:c.outerHeight})},Da=function(b,c){var e=A[b],f=["center"],g=w.zIndexes,h=d.extend({objectsOnly:!1,animation:!1,resizing:!0,sliding:t[b].isSliding},c),k,q;h.resizing&&f.push(b);h.sliding&&f.push(A.oppositeEdge[b]);"horz"===e.dir&&(f.push("west"),f.push("east"));d.each(f,function(l,m){q=t[m];k=w[m];q.isVisible&&(k.maskObjects||!h.objectsOnly&&k.maskContents)&&rb(m).each(function(){ib.call(this);
this.style.zIndex=q.isSliding?g.pane_sliding+1:g.pane_normal+1;this.style.display="block"})})},Ga=function(b){if(b||!t.paneResizing)la.hide();else if(!b&&!d.isEmptyObject(t.panesSliding)){b=la.length-1;for(var c,e;0<=b;b--)e=la.eq(b),c=e.data("layoutMask"),w[c].maskObjects||e.hide()}},rb=function(b){for(var c=d([]),e,f=0,g=la.length;f<g;f++)e=la.eq(f),e.data("layoutMask")===b&&(c=c.add(e));if(c.length)return c;c=F[b];e=t[b];f=w[b];g=w.zIndexes;var h;if(f.maskContents||f.maskObjects){for(h=0;h<(f.maskObjects?
2:1);h++){var k=f.maskObjects&&0==h;var q=document.createElement(k?"iframe":"div");var l=d(q).data("layoutMask",b);q.className="ui-layout-mask ui-layout-mask-"+b;var m=q.style;m.background="#FFF";m.position="absolute";m.display="block";k?(q.src="about:blank",q.frameborder=0,m.border=0,m.opacity=0,m.filter="Alpha(Opacity\x3d'0')"):(m.opacity=.001,m.filter="Alpha(Opacity\x3d'1')");"IFRAME"==e.tagName?(m.zIndex=g.pane_normal+1,K.append(q)):(l.addClass("ui-layout-mask-inside-pane"),m.zIndex=f.maskZindex||
g.content_mask,m.top=0,m.left=0,m.width="100%",m.height="100%",c.append(q));la=la.add(q)}b=la}else b=d([]);return b},Sa=function(b,c,e,f){if(Y()){b=P.call(this,b);var g=F[b],h=ia[b],k=X[b],q=ea[b];g&&d.isEmptyObject(g.data())&&(g=!1);h&&d.isEmptyObject(h.data())&&(h=!1);k&&d.isEmptyObject(k.data())&&(k=!1);q&&d.isEmptyObject(q.data())&&(q=!1);g&&g.stop(!0,!0);var l=w[b],m=R[b],D=d.isPlainObject(m)&&!d.isEmptyObject(m);f=void 0!==f?f:l.destroyChildren;D&&f&&(d.each(m,function(H,G){G.destroyed||G.destroy(!0);
G.destroyed&&delete m[H]}),d.isEmptyObject(m)&&(m=R[b]=null,D=!1));g&&c&&!D?g.remove():g&&g[0]&&(c=l.paneClass,f=c+"-"+b,c=[c,c+"-open",c+"-closed",c+"-sliding",f,f+"-open",f+"-closed",f+"-sliding"],d.merge(c,Oa(g,!0)),g.removeClass(c.join(" ")).removeData("parentLayout").removeData("layoutPane").removeData("layoutRole").removeData("layoutEdge").removeData("autoHidden").off("."+aa),D&&h?(h.width(h.width()),d.each(m,function(H,G){G.resizeAll()})):h&&h.css(h.data("layoutCSS")).removeData("layoutCSS").removeData("layoutRole"),
g.data("layout")||g.css(g.data("layoutCSS")).removeData("layoutCSS"));q&&q.remove();k&&k.remove();T[b]=F[b]=ia[b]=X[b]=ea[b]=!1;e||va()}},Ma=function(b){var c=F[b],e=c[0].style;w[b].useOffscreenClose?(c.data(A.offscreenReset)||c.data(A.offscreenReset,{left:e.left,right:e.right}),c.css(A.offscreenCSS)):c.hide().removeData(A.offscreenReset)},jb=function(b){var c=F[b];b=w[b];var e=A.offscreenCSS,f=c.data(A.offscreenReset),g=c[0].style;c.show().removeData(A.offscreenReset);b.useOffscreenClose&&f&&(g.left==
e.left&&(g.left=f.left),g.right==e.right&&(g.right=f.right))},za=function(b,c){if(Y()){b=P.call(this,b);var e=w[b],f=t[b],g=F[b],h=X[b];"center"===b||!g||f.isHidden||t.initialized&&!1===N("onhide_start",b)||(f.isSliding=!1,delete t.panesSliding[b],h&&h.hide(),!t.initialized||f.isClosed?(f.isClosed=!0,f.isHidden=!0,f.isVisible=!1,t.initialized||Ma(b),ra("horz"===A[b].dir?"":"center"),(t.initialized||e.triggerEventsOnLoad)&&N("onhide_end",b)):(f.isHiding=!0,ja(b,!1,c)))}},Ca=function(b,c,e,f){if(Y()){b=
P.call(this,b);var g=t[b],h=F[b];"center"!==b&&h&&g.isHidden&&!1!==N("onshow_start",b)&&(g.isShowing=!0,g.isSliding=!1,delete t.panesSliding[b],!1===c?ja(b,!0):sa(b,!1,e,f))}},ya=function(b,c){if(Y()){var e=Q(b);b=P.call(this,b);var f=t[b];e&&e.stopImmediatePropagation();f.isHidden?Ca(b):f.isClosed?sa(b,!!c):ja(b)}},sb=function(b,c){var e=t[b];Ma(b);e.isClosed=!0;e.isVisible=!1;c&&Ja(b)},ja=function(b,c,e,f){function g(){l.isMoving=!1;wa(h,!0);var G=A.oppositeEdge[h];t[G].noRoom&&(ka(G),qa(G));f||
!t.initialized&&!q.triggerEventsOnLoad||(D||N("onclose_end",h),D&&N("onshow_end",h),H&&N("onhide_end",h))}var h=P.call(this,b);if("center"!==h)if(!t.initialized&&F[h])sb(h,!0);else if(Y()){var k=F[h],q=w[h],l=t[h],m,D,H;K.queue(function(G){if(!k||!q.closable&&!l.isShowing&&!l.isHiding||!c&&l.isClosed&&!l.isShowing)return G();var V=!l.isShowing&&!1===N("onclose_start",h);D=l.isShowing;H=l.isHiding;delete l.isShowing;delete l.isHiding;if(V)return G();m=!e&&!l.isClosed&&"none"!=q.fxName_close;l.isMoving=
!0;l.isClosed=!0;l.isVisible=!1;H?l.isHidden=!0:D&&(l.isHidden=!1);l.isSliding?Fa(h,!1):ra("horz"===A[h].dir?"":"center",!1);Ja(h);m?(Na(h,!0),k.hide(q.fxName_close,q.fxSettings_close,q.fxSpeed_close,function(){Na(h,!1);l.isClosed&&g();G()})):(Ma(h),g(),G())})}},Ja=function(b){if(X[b]){var c=X[b],e=ea[b],f=w[b],g=t[b],h=A[b].side,k=f.resizerClass,q=f.togglerClass,l="-"+b;c.css(h,J.inset[h]).removeClass(k+"-open "+k+l+"-open").removeClass(k+"-sliding "+k+l+"-sliding").addClass(k+"-closed "+k+l+"-closed");
g.isHidden&&c.hide();f.resizable&&d.layout.plugins.draggable&&c.draggable("disable").removeClass("ui-state-disabled").css("cursor","default").attr("title","");e&&(e.removeClass(q+"-open "+q+l+"-open").addClass(q+"-closed "+q+l+"-closed").attr("title",f.tips.Open),e.children(".content-open").hide(),e.children(".content-closed").css("display","block"));Va(b,!1);t.initialized&&Ba()}},sa=function(b,c,e,f){function g(){l.isMoving=!1;fa(h);l.isSliding||ra("vert"==A[h].dir?"center":"",!1);Ua(h)}if(Y()){var h=
P.call(this,b),k=F[h],q=w[h],l=t[h],m,D;"center"!==h&&K.queue(function(H){if(!k||!q.resizable&&!q.closable&&!l.isShowing||l.isVisible&&!l.isSliding)return H();if(l.isHidden&&!l.isShowing)H(),Ca(h,!0);else{l.autoResize&&l.size!=q.size?ta(h,q.size,!0,!0,!0):ka(h,c);var G=N("onopen_start",h);if("abort"===G)return H();"NC"!==G&&ka(h,c);if(l.minSize>l.maxSize)return Va(h,!1),!f&&q.tips.noRoomToOpen&&alert(q.tips.noRoomToOpen),H();c?Fa(h,!0):l.isSliding?Fa(h,!1):q.slidable&&wa(h,!1);l.noRoom=!1;qa(h);D=
l.isShowing;delete l.isShowing;m=!e&&l.isClosed&&"none"!=q.fxName_open;l.isMoving=!0;l.isVisible=!0;l.isClosed=!1;D&&(l.isHidden=!1);m?(Na(h,!0),k.show(q.fxName_open,q.fxSettings_open,q.fxSpeed_open,function(){Na(h,!1);l.isVisible&&g();H()})):(jb(h),g(),H())}})}},Ua=function(b,c){var e=F[b],f=X[b],g=ea[b],h=w[b],k=t[b],q=A[b].side,l=h.resizerClass,m=h.togglerClass,D="-"+b;f.css(q,J.inset[q]+pa(b)).removeClass(l+"-closed "+l+D+"-closed").addClass(l+"-open "+l+D+"-open");k.isSliding?f.addClass(l+"-sliding "+
l+D+"-sliding"):f.removeClass(l+"-sliding "+l+D+"-sliding");ma(0,f);h.resizable&&d.layout.plugins.draggable?f.draggable("enable").css("cursor",h.resizerCursor).attr("title",h.tips.Resize):k.isSliding||f.css("cursor","default");g&&(g.removeClass(m+"-closed "+m+D+"-closed").addClass(m+"-open "+m+D+"-open").attr("title",h.tips.Close),ma(0,g),g.children(".content-closed").hide(),g.children(".content-open").css("display","block"));Va(b,!k.isSliding);d.extend(k,z(e));t.initialized&&(Ba(),Aa(b,!0));!c&&
(t.initialized||h.triggerEventsOnLoad)&&e.is(":visible")&&(N("onopen_end",b),k.isShowing&&N("onshow_end",b),t.initialized&&N("onresize_end",b))},kb=function(b){function c(){g.isClosed?g.isMoving||sa(f,!0):Fa(f,!0)}if(Y()){var e=Q(b),f=P.call(this,b),g=t[f];b=w[f].slideDelay_open;"center"!==f&&(e&&e.stopImmediatePropagation(),g.isClosed&&e&&"mouseenter"===e.type&&0<b?O.set(f+"_openSlider",c,b):c())}},Wa=function(b){function c(){g.isClosed?Fa(f,!1):g.isMoving||ja(f)}if(Y()){var e=Q(b),f=P.call(this,
b);b=w[f];var g=t[f],h=g.isMoving?1E3:300;"center"!==f&&(g.isClosed||g.isResizing||("click"===b.slideTrigger_close?c():b.preventQuickSlideClose&&g.isMoving||b.preventPrematureSlideClose&&e&&d.layout.isMouseOverElem(e,F[f])||(e?O.set(f+"_closeSlider",c,p(b.slideDelay_close,h)):c())))}},Na=function(b,c){var e=F[b],f=t[b],g=w.zIndexes;c?(Da(b,{animation:!0,objectsOnly:!0}),e.css({zIndex:g.pane_animate}),"south"==b?e.css({top:J.inset.top+J.innerHeight-e.outerHeight()}):"east"==b&&e.css({left:J.inset.left+
J.innerWidth-e.outerWidth()})):(Ga(),e.css({zIndex:f.isSliding?g.pane_sliding:g.pane_normal}),"south"==b?e.css({top:"auto"}):"east"!=b||e.css("left").match(/\-99999/)||e.css({left:"auto"}))},wa=function(b,c){var e=w[b];b=X[b];var f=e.slideTrigger_open.toLowerCase();if(b&&(!c||e.slidable)){f.match(/mouseover/)?f=e.slideTrigger_open="mouseenter":f.match(/(click|dblclick|mouseenter)/)||(f=e.slideTrigger_open="click");if(e.resizerDblClickToggle&&f.match(/click/))b[c?"off":"on"]("dblclick."+aa,ya);b[c?
"on":"off"](f+"."+aa,kb).css("cursor",c?e.sliderCursor:"default").attr("title",c?e.tips.Slide:"")}},Fa=function(b,c){function e(D){O.clear(b+"_closeSlider");D.stopPropagation()}var f=w[b],g=t[b],h=w.zIndexes,k=f.slideTrigger_close.toLowerCase(),q=c?"on":"off",l=F[b],m=X[b];O.clear(b+"_closeSlider");c?(g.isSliding=!0,t.panesSliding[b]=!0,wa(b,!1)):(g.isSliding=!1,delete t.panesSliding[b]);l.css("zIndex",c?h.pane_sliding:h.pane_normal);m.css("zIndex",c?h.pane_sliding+2:h.resizer_normal);k.match(/(click|mouseleave)/)||
(k=f.slideTrigger_close="mouseleave");m[q](k,Wa);"mouseleave"===k&&(l[q]("mouseleave."+aa,Wa),m[q]("mouseenter."+aa,e),l[q]("mouseenter."+aa,e));c?"click"!==k||f.resizable||(m.css("cursor",c?f.sliderCursor:"default"),m.attr("title",c?f.tips.Close:"")):O.clear(b+"_closeSlider")},qa=function(b,c,e,f){c=w[b];var g=t[b],h=A[b],k=F[b],q=X[b],l="vert"===h.dir,m;if("center"===b||l&&g.noVerticalRoom)(m=0<=g.maxHeight)&&g.noRoom?(jb(b),q&&q.show(),g.isVisible=!0,g.noRoom=!1,l&&(g.noVerticalRoom=!1),fa(b)):
m||g.noRoom||(Ma(b),q&&q.hide(),g.isVisible=!1,g.noRoom=!0);"center"!==b&&(g.minSize<=g.maxSize?(g.size>g.maxSize?ta(b,g.maxSize,e,!0,f):g.size<g.minSize?ta(b,g.minSize,e,!0,f):q&&g.isVisible&&k.is(":visible")&&(e=g.size+J.inset[h.side],d.layout.cssNum(q,h.side)!=e&&q.css(h.side,e)),g.noRoom&&(g.wasOpen&&c.closable?c.autoReopen?sa(b,!1,!0,!0):g.noRoom=!1:Ca(b,g.wasOpen,!0,!0))):g.noRoom||(g.noRoom=!0,g.wasOpen=!g.isClosed&&!g.isSliding,g.isClosed||(c.closable?ja(b,!0,!0):za(b,!0))))},La=function(b,
c,e,f,g){if(Y()){b=P.call(this,b);var h=w[b],k=t[b];g=g||h.livePaneResizing&&!k.isResizing;"center"!==b&&(k.autoResize=!1,ta(b,c,e,f,g))}},ta=function(b,c,e,f,g){function h(){var Z="width"===G?m.outerWidth():m.outerHeight();Z=[{pane:k,count:1,target:c,actual:Z,correct:c===Z,attempt:c,cssSize:xa}];for(var ba=Z[0],da,na="Inaccurate size after resizing the "+k+"-pane.";!ba.correct;){da={pane:k,count:ba.count+1,target:c};da.attempt=ba.actual>c?p(0,ba.attempt-(ba.actual-c)):p(0,ba.attempt+(c-ba.actual));
da.cssSize=("horz"==A[k].dir?r:M)(F[k],da.attempt);m.css(G,da.cssSize);da.actual="width"==G?m.outerWidth():m.outerHeight();da.correct=c===da.actual;1===Z.length&&(S(na,!1,!0),S(ba,!1,!0));S(da,!1,!0);if(3<Z.length)break;Z.push(da);ba=Z[Z.length-1]}l.size=c;d.extend(l,z(m));l.isVisible&&m.is(":visible")&&(D&&D.css(H,c+J.inset[H]),Aa(k));!e&&!V&&t.initialized&&l.isVisible&&N("onresize_end",k);e||(l.isSliding||ra("horz"==A[k].dir?"":"center",V,g),Ba());ba=A.oppositeEdge[k];c<ca&&t[ba].noRoom&&(ka(ba),
qa(ba,!1,e));1<Z.length&&S(na+"\nSee the Error Console for details.",!0,!0)}if(Y()){var k=P.call(this,b),q=w[k],l=t[k],m=F[k],D=X[k],H=A[k].side,G=A[k].sizeType.toLowerCase(),V=l.isResizing&&!q.triggerEventsDuringLiveResize,W=!0!==f&&q.animatePaneSizing,ca,xa;"center"!==k&&K.queue(function(Z){ka(k);ca=l.size;c=oa(k,c);c=p(c,oa(k,q.minSize));c=v(c,l.maxSize);if(c<l.minSize)Z(),qa(k,!1,e);else{if(!g&&c===ca)return Z();l.newSize=c;!e&&t.initialized&&l.isVisible&&N("onresize_start",k);xa=("horz"==A[k].dir?
r:M)(F[k],c);if(W&&m.is(":visible")){var ba=d.layout.effects.size[k]||d.layout.effects.size.all;ba=q.fxSettings_size.easing||ba.easing;var da=w.zIndexes,na={};na[G]=xa+"px";l.isMoving=!0;m.css({zIndex:da.pane_animate}).show().animate(na,q.fxSpeed_size,ba,function(){m.css({zIndex:l.isSliding?da.pane_sliding:da.pane_normal});l.isMoving=!1;delete l.newSize;h();Z()})}else m.css(G,xa),delete l.newSize,m.is(":visible")?h():l.size=c,Z()}})}},ra=function(b,c,e){b=(b?b:"east,west,center").split(",");d.each(b,
function(f,g){if(F[g]){var h=w[g];f=t[g];var k=F[g],q={},l=d.layout.showInvisibly(k),m={top:pa("north",!0),bottom:pa("south",!0),left:pa("west",!0),right:pa("east",!0),width:0,height:0};m.width=J.innerWidth-m.left-m.right;m.height=J.innerHeight-m.bottom-m.top;m.top+=J.inset.top;m.bottom+=J.inset.bottom;m.left+=J.inset.left;m.right+=J.inset.right;d.extend(f,z(k));if("center"===g){if(!e&&f.isVisible&&m.width===f.outerWidth&&m.height===f.outerHeight)return k.css(l),!0;d.extend(f,ua(g),{maxWidth:m.width,
maxHeight:m.height});q=m;f.newWidth=q.width;f.newHeight=q.height;q.width=M(k,q.width);q.height=r(k,q.height);var D=0<=q.width&&0<=q.height;if(!t.initialized&&h.minWidth>m.width){h=h.minWidth-f.outerWidth;m=w.east.minSize||0;var H=w.west.minSize||0,G=t.east.size,V=t.west.size,W=G,ca=V;0<h&&t.east.isVisible&&G>m&&(W=p(G-m,G-h),h-=G-W);0<h&&t.west.isVisible&&V>H&&(ca=p(V-H,V-h),h-=V-ca);if(0===h){G&&G!=m&&ta("east",W,!0,!0,e);V&&V!=H&&ta("west",ca,!0,!0,e);ra("center",c,e);k.css(l);return}}}else{f.isVisible&&
!f.noVerticalRoom&&d.extend(f,z(k),ua(g));if(!e&&!f.noVerticalRoom&&m.height===f.outerHeight)return k.css(l),!0;q.top=m.top;q.bottom=m.bottom;f.newSize=m.height;q.height=r(k,m.height);f.maxHeight=q.height;D=0<=f.maxHeight;D||(f.noVerticalRoom=!0)}D?(!c&&t.initialized&&N("onresize_start",g),k.css(q),"center"!==g&&Ba(g),!f.noRoom||f.isClosed||f.isHidden||qa(g),f.isVisible&&(d.extend(f,z(k)),t.initialized&&Aa(g))):!f.noRoom&&f.isVisible&&qa(g);k.css(l);delete f.newSize;delete f.newWidth;delete f.newHeight;
if(!f.isVisible)return!0;"center"===g&&(f=!I.boxModel,F.north&&(f||"IFRAME"==t.north.tagName)&&F.north.css("width",M(F.north,J.innerWidth)),F.south&&(f||"IFRAME"==t.south.tagName)&&F.south.css("width",M(F.south,J.innerWidth)));!c&&t.initialized&&N("onresize_end",g)}})},va=function(b){P(b);if(K.is(":visible"))if(t.initialized){if(!0===b&&d.isPlainObject(w.outset)&&K.css(w.outset),d.extend(J,z(K,w.inset)),J.outerHeight){!0===b&&gb();if(!1===N("onresizeall_start"))return!1;var c,e,f;d.each(["south",
"north","east","west"],function(g,h){if(F[h]){e=w[h];f=t[h];g=!1;var k=d(window).width();null!==e&&"undefined"!==e&&e.responsive&&e.responsive.enabled&&(k>=e.responsive.sizes.lg&&(g="lg"===e.responsive.when||"md"===e.responsive.when||"sm"===e.responsive.when||"xs"===e.responsive.when?!1:!0),k>=e.responsive.sizes.md&&k<e.responsive.sizes.lg&&(g="md"===e.responsive.when||"sm"===e.responsive.when||"xs"===e.responsive.when?!1:!0),k>=e.responsive.sizes.sm&&k<e.responsive.sizes.md&&(g="sm"===e.responsive.when||
"xs"===e.responsive.when?!1:!0),k>=e.responsive.sizes.xs&&k<e.responsive.sizes.sm&&(g="xs"===e.responsive.when?!1:!0));f.autoResize&&f.size!==e.size?(g&&f.isVisible?(e.closable?ja(h,!0,!e.responsiveAnimate):za(h,!e.responsiveAnimate),f.responded=!0):f.responded&&(e.closable?sa(h,!1,!e.responsiveAnimate):Ca(h,!0,!e.responsiveAnimate),f.responded=!1),ta(h,e.size,!0,!0,!0)):(ka(h),g?(e.closable?ja(h,!0,!e.responsiveAnimate):za(h,!e.responsiveAnimate),f.responded=!0):f.responded&&(e.closable?sa(h,!1,
!e.responsiveAnimate):Ca(h,!0,!e.responsiveAnimate),f.responded=!1),qa(h,!1,!0,!0))}});ra("",!0,!0);Ba();d.each(A.allPanes,function(g,h){(c=F[h])&&t[h].isVisible&&N("onresize_end",h)});N("onresizeall_end")}}else Ha()},Xa=function(b,c){b=P.call(this,b);w[b].resizeChildren&&(c||Ia(b),c=R[b],d.isPlainObject(c)&&d.each(c,function(e,f){f.destroyed||f.resizeAll()}))},Aa=function(b,c){Y()&&(b=(b=P.call(this,b))?b.split(","):A.allPanes,d.each(b,function(e,f){function g(D){return p(l.css.paddingBottom,parseInt(D.css("marginBottom"),
10)||0)}function h(){var D=w[f].contentIgnoreSelector;D=k.nextAll().not(".ui-layout-mask").not(D||":lt(0)");var H=D.filter(":visible"),G=H.filter(":last");m={top:k[0].offsetTop,height:k.outerHeight(),numFooters:D.length,hiddenFooters:D.length-H.length,spaceBelow:0};m.spaceAbove=m.top;m.bottom=m.top+m.height;m.spaceBelow=G.length?G[0].offsetTop+G.outerHeight()-m.bottom+g(G):g(k)}e=F[f];var k=ia[f],q=w[f],l=t[f],m=l.content;if(!e||!k||!e.is(":visible"))return!0;if(!k.length&&(Ta(f,!1),!k))return;if(!1!==
N("onsizecontent_start",f)){if(!l.isMoving&&!l.isResizing||q.liveContentResizing||c||void 0==m.top)h(),0<m.hiddenFooters&&"hidden"===e.css("overflow")&&(e.css("overflow","visible"),h(),e.css("overflow","hidden"));e=l.innerHeight-(m.spaceAbove-l.css.paddingTop)-(m.spaceBelow-l.css.paddingBottom);k.is(":visible")&&m.height==e||(lb(k,e,!0),m.height=e);t.initialized&&N("onsizecontent_end",f)}}))},Ba=function(b){b=(b=P.call(this,b))?b.split(","):A.borderPanes;d.each(b,function(c,e){c=w[e];var f=t[e],g=
F[e],h=X[e],k=ea[e],q;if(g&&h){e=A[e].dir;var l=f.isClosed?"_closed":"_open",m=c["spacing"+l],D=c["togglerAlign"+l];l=c["togglerLength"+l];if(0===m)h.hide();else{f.noRoom||f.isHidden||h.show();if("horz"===e){var H=J.innerWidth;f.resizerLength=H;g=d.layout.cssNum(g,"left");h.css({width:M(h,H),height:r(h,m),left:-9999<g?g:J.inset.left})}else H=g.outerHeight(),f.resizerLength=H,h.css({height:r(h,H),width:M(h,m),top:J.inset.top+pa("north",!0)});ma(c,h);if(k){if(0===l||f.isSliding&&c.hideTogglerOnSlide){k.hide();
return}k.show();if(!(0<l)||"100%"===l||l>H)l=H,D=0;else if(x(D))switch(D){case "top":case "left":D=0;break;case "bottom":case "right":D=H-l;break;default:D=u((H-l)/2)}else g=parseInt(D,10),D=0<=D?g:H-l+g;if("horz"===e){var G=M(k,l);k.css({width:G,height:r(k,m),left:D,top:0});k.children(".content").each(function(){q=d(this);q.css("marginLeft",u((G-q.outerWidth())/2))})}else{var V=r(k,l);k.css({height:V,width:M(k,m),top:D,left:0});k.children(".content").each(function(){q=d(this);q.css("marginTop",u((V-
q.outerHeight())/2))})}ma(0,k)}t.initialized||!c.initHidden&&!f.isHidden||(h.hide(),k&&k.hide())}}})},hb=function(b){if(Y()){var c=P.call(this,b);b=ea[c];var e=w[c];b&&(e.closable=!0,b.on("click."+aa,function(f){f.stopPropagation();ya(c)}).css("visibility","visible").css("cursor","pointer").attr("title",t[c].isClosed?e.tips.Open:e.tips.Close).show())}},Va=function(b,c){d.layout.plugins.buttons&&d.each(t[b].pins,function(e,f){d.layout.buttons.setPinState(T,d(f),b,c)})},K=d(this).eq(0);if(!K.length)return S(w.errors.containerMissing);
if(K.data("layoutContainer")&&K.data("layout"))return K.data("layout");var F={},ia={},X={},ea={},la=d([]),J=t.container,aa=t.id,T={options:w,state:t,container:K,panes:F,contents:ia,resizers:X,togglers:ea,hide:za,show:Ca,toggle:ya,open:sa,close:ja,slideOpen:kb,slideClose:Wa,slideToggle:function(b){b=P.call(this,b);ya(b,!0)},setSizeLimits:ka,_sizePane:ta,sizePane:La,sizeContent:Aa,swapPanes:function(b,c){function e(q){var l=F[q],m=ia[q];return l?{pane:q,P:l?l[0]:!1,C:m?m[0]:!1,state:d.extend(!0,{},
t[q]),options:d.extend(!0,{},w[q])}:!1}function f(q,l){if(q){var m=q.P,D=q.C,H=q.pane,G=A[l],V=d.extend(!0,{},t[l]),W=w[l],ca={resizerCursor:W.resizerCursor};d.each(["fxName","fxSpeed","fxSettings"],function(xa,Z){ca[Z+"_open"]=W[Z+"_open"];ca[Z+"_close"]=W[Z+"_close"];ca[Z+"_size"]=W[Z+"_size"]});F[l]=d(m).data({layoutPane:T[l],layoutEdge:l}).css(A.hidden).css(G.cssReq);ia[l]=D?d(D):!1;w[l]=d.extend(!0,{},q.options,ca);t[l]=d.extend(!0,{},q.state);m.className=m.className.replace(new RegExp(W.paneClass+
"-"+H,"g"),W.paneClass+"-"+l);Ra(l);G.dir!=A[H].dir?(m=k[l]||0,ka(l),m=p(m,t[l].minSize),La(l,m,!0,!0)):X[l].css(G.side,J.inset[G.side]+(t[l].isVisible?pa(l):0));q.state.isVisible&&!V.isVisible?Ua(l,!0):(Ja(l),wa(l,!0));q=null}}if(Y())if(b=P.call(this,b),t[b].edge=c,t[c].edge=b,!1===N("onswap_start",b)||!1===N("onswap_start",c))t[b].edge=b,t[c].edge=c;else{var g=e(b),h=e(c),k={};k[b]=g?g.state.size:0;k[c]=h?h.state.size:0;F[b]=!1;F[c]=!1;t[b]={};t[c]={};ea[b]&&ea[b].remove();ea[c]&&ea[c].remove();
X[b]&&X[b].remove();X[c]&&X[c].remove();X[b]=X[c]=ea[b]=ea[c]=!1;f(g,c);f(h,b);g=h=k=null;F[b]&&F[b].css(A.visible);F[c]&&F[c].css(A.visible);va();N("onswap_end",b);N("onswap_end",c)}},showMasks:Da,hideMasks:Ga,initContent:Ta,addPane:eb,removePane:Sa,createChildren:Qa,refreshChildren:Ia,enableClosable:hb,disableClosable:function(b,c){if(Y()){b=P.call(this,b);var e=ea[b];e&&(w[b].closable=!1,t[b].isClosed&&sa(b,!1,!0),e.off("."+aa).css("visibility",c?"hidden":"visible").css("cursor","default").attr("title",
""))}},enableSlidable:function(b){if(Y()){b=P.call(this,b);var c=X[b];c&&c.data("draggable")&&(w[b].slidable=!0,t[b].isClosed&&wa(b,!0))}},disableSlidable:function(b){if(Y()){b=P.call(this,b);var c=X[b];c&&(w[b].slidable=!1,t[b].isSliding?ja(b,!1,!0):(wa(b,!1),c.css("cursor","default").attr("title",""),ma(null,c[0])))}},enableResizable:function(b){if(Y()){b=P.call(this,b);var c=X[b],e=w[b];c&&c.data("draggable")&&(e.resizable=!0,c.draggable("enable"),t[b].isClosed||c.css("cursor",e.resizerCursor).attr("title",
e.tips.Resize))}},disableResizable:function(b){if(Y()){b=P.call(this,b);var c=X[b];c&&c.data("draggable")&&(w[b].resizable=!1,c.draggable("disable").css("cursor","default").attr("title",""),ma(null,c[0]))}},allowOverflow:B,resetOverflow:E,destroy:function(b,c){d(window).off("."+aa);d(document).off("."+aa);"object"===typeof b?P(b):c=b;K.clearQueue().removeData("layout").removeData("layoutContainer").removeClass(w.containerClass).off("."+aa);la.remove();d.each(A.allPanes,function(f,g){Sa(g,!1,!0,c)});
K.data("layoutCSS")&&!K.data("layoutRole")&&K.css(K.data("layoutCSS")).removeData("layoutCSS");"BODY"===J.tagName&&(K=d("html")).data("layoutCSS")&&K.css(K.data("layoutCSS")).removeData("layoutCSS");C(T,d.layout.onDestroy);cb();for(var e in T)e.match(/^(container|options)$/)||delete T[e];T.destroyed=!0;return T},initPanes:Y,resizeAll:va,runCallbacks:N,hasParentLayout:!1,children:R,north:!1,south:!1,west:!1,east:!1,center:!1};return"cancel"===function(){pb();var b=w,c=t;c.creatingLayout=!0;C(T,d.layout.onCreate);
if(!1===N("onload_start"))return"cancel";ob();db();d(window).on("unload."+aa,cb);C(T,d.layout.onLoad);b.initPanes&&Ha();delete c.creatingLayout;va();d.each(["south","north","east","west"],function(e,f){F[f]&&(b=w[f],c=t[f],b.initHidden?za(f):b.initClosed&&ja(f))});return t.initialized}()?null:T}})(U);(function(d){if(d.layout){(function(){if(!window.google||!google.gears){var p=null;if("undefined"!=typeof GearsFactory)p=new GearsFactory;else try{p=new ActiveXObject("Gears.Factory"),-1!=p.getBuildInfo().indexOf("ie_mobile")&&
p.privateSetGlobalObject(this)}catch(u){"undefined"!=typeof navigator.mimeTypes&&navigator.mimeTypes["application/x-googlegears"]&&(p=document.createElement("object"),p.style.display="none",p.width=0,p.height=0,p.type="application/x-googlegears",document.documentElement.appendChild(p))}p&&(window.google||(google={}),google.gears||(google.gears={factory:p}))}})();Persist=function(){var p=function(){var r=["expires","path","domain"],z=escape,L=unescape,Q=document,P=function(t,R){var O,S=[],N=2<arguments.length?
arguments[2]:{};S.push(z(t)+"\x3d"+z(R));for(var fa=0;fa<r.length;fa++){var ua=r[fa];(O=N[ua])&&S.push(ua+"\x3d"+O)}N.secure&&S.push("secure");return S.join("; ")};var w={set:function(t,R){var O=2<arguments.length?arguments[2]:{},S=new Date;S.setTime(S.getTime());var N={};if(O.expires)if(-1==O.expires)N.expires=-1;else{var fa=864E5*O.expires;N.expires=new Date(S.getTime()+fa);N.expires=N.expires.toGMTString()}S=["path","domain","secure"];for(fa=0;fa<S.length;fa++)O[S[fa]]&&(N[S[fa]]=O[S[fa]]);O=P(t,
R,N);Q.cookie=O;return R},has:function(t){t=z(t);var R=Q.cookie,O=R.indexOf(t+"\x3d");R=R.substring(0,t.length);return!O&&t!=R||0>O?!1:!0},get:function(t){t=z(t);var R=Q.cookie,O=R.indexOf(t+"\x3d"),S=O+t.length+1,N=R.substring(0,t.length);if(!O&&t!=N||0>O)return null;t=R.indexOf(";",S);0>t&&(t=R.length);return L(R.substring(S,t))},remove:function(t){var R=w.get(t);Q.cookie=P(t,"",{expires:"Thu, 01-Jan-1970 00:00:01 GMT"});return R},keys:function(){for(var t=Q.cookie.split("; "),R,O=[],S=0;S<t.length;S++)R=
t[S].split("\x3d"),O.push(L(R[0]));return O},all:function(){for(var t=Q.cookie.split("; "),R,O=[],S=0;S<t.length;S++)R=t[S].split("\x3d"),O.push([L(R[0]),L(R[1])]);return O},version:"0.2.1",enabled:!1};w.enabled=navigator.cookieEnabled;return w}();var u=function(){return Array.prototype.indexOf?function(r,z){return Array.prototype.indexOf.call(r,z)}:function(r,z){for(var L=0,Q=r.length;L<Q;L++)if(r[L]==z)return L;return-1}}();var x=function(){};var C=function(r){return"PS"+r.replace(/_/g,"__").replace(/ /g,
"_s")};var n="localstorage globalstorage gears cookie ie flash".split(" "),y=/^[a-z][a-z0-9_ \-]+$/i,B="init get set remove load save iterate".split(" "),E={autostart:!0};var I={gears:{size:-1,test:function(){return window.google&&window.google.gears?!0:!1},methods:{init:function(){var r=this.db=google.gears.factory.create("beta.database");r.open(C(this.name));r.execute("CREATE TABLE IF NOT EXISTS persist_data (k TEXT UNIQUE NOT NULL PRIMARY KEY, v TEXT NOT NULL)").close()},get:function(r){var z=
this.db;z.execute("BEGIN").close();r=z.execute("SELECT v FROM persist_data WHERE k \x3d ?",[r]);var L=r.isValidRow()?r.field(0):null;r.close();z.execute("COMMIT").close();return L},set:function(r,z){var L=this.db;L.execute("BEGIN").close();L.execute("DELETE FROM persist_data WHERE k \x3d ?",[r]).close();L.execute("INSERT INTO persist_data(k, v) VALUES (?, ?)",[r,z]).close();L.execute("COMMIT").close();return z},remove:function(r){var z=this.db;z.execute("BEGIN").close();z.execute("DELETE FROM persist_data WHERE k \x3d ?",
[r]).close();z.execute("COMMIT").close();return!0},iterate:function(r,z){var L;for(L=this.db.execute("SELECT * FROM persist_data");L.isValidRow();)r.call(z||this,L.field(0),L.field(1)),L.next();L.close()}}},globalstorage:{size:5242880,test:function(){return window.globalStorage?!0:!1},methods:{key:function(r){return C(this.name)+C(r)},init:function(){this.store=globalStorage[this.o.domain]},get:function(r){r=this.key(r);return this.store.getItem(r)},set:function(r,z){r=this.key(r);this.store.setItem(r,
z);return z},remove:function(r){r=this.key(r);var z=this.store.getItem[r];this.store.removeItem(r);return z}}},localstorage:{size:-1,test:function(){try{if(window.localStorage&&void 0==window.localStorage.setItem("persistjs_test_local_storage",null))if(window.localStorage.removeItem("persistjs_test_local_storage"),/Firefox[\/\s](\d+\.\d+)/.test(navigator.userAgent)){if(9<=RegExp.$1)return!0;if("file:"==window.location.protocol)return!1}else return!0;else return!1;return window.localStorage?!0:!1}catch(r){return!1}},
methods:{key:function(r){return this.name+"\x3e"+r},init:function(){this.store=localStorage},get:function(r){r=this.key(r);return this.store.getItem(r)},set:function(r,z){r=this.key(r);this.store.setItem(r,z);return z},remove:function(r){r=this.key(r);var z=this.store.getItem(r);this.store.removeItem(r);return z},iterate:function(r,z){for(var L=this.store,Q,P,w=0;w<L.length;w++)Q=L.key(w),P=Q.split("\x3e"),2==P.length&&P[0]==this.name&&r.call(z||this,P[1],L.getItem(Q))}}},ie:{prefix:"_persist_data-",
size:65536,test:function(){return window.ActiveXObject?!0:!1},make_userdata:function(r){var z=document.createElement("div");z.id=r;z.style.display="none";z.addBehavior("#default#userdata");document.body.appendChild(z);return z},methods:{init:function(){var r=I.ie.prefix+C(this.name);this.el=I.ie.make_userdata(r);this.o.defer&&this.load()},get:function(r){r=C(r);this.o.defer||this.load();return this.el.getAttribute(r)},set:function(r,z){r=C(r);this.el.setAttribute(r,z);this.o.defer||this.save();return z},
remove:function(r){r=C(r);this.o.defer||this.load();var z=this.el.getAttribute(r);this.el.removeAttribute(r);this.o.defer||this.save();return z},load:function(){this.el.load(C(this.name))},save:function(){this.el.save(C(this.name))}}},cookie:{delim:":",size:4E3,test:function(){return M.Cookie.enabled?!0:!1},methods:{key:function(r){return this.name+I.cookie.delim+r},get:function(r,z){r=this.key(r);return p.get(r)},set:function(r,z,L){r=this.key(r);p.set(r,z,this.o);return z},remove:function(r,z){r=
this.key(r);return z=p.remove(r)}}},flash:{test:function(){return swfobject?8<=swfobject.getFlashPlayerVersion().major?!0:!1:!1},methods:{init:function(){if(!I.flash.el){var r=document.createElement("div");r.id="_persist_flash_wrap";var z=document.createElement("div");z.id="_persist_flash";r.appendChild(z);document.body.appendChild(r);I.flash.el=swfobject.createSWF({id:"_persist_flash",data:this.o.swf_path||"persist.swf",width:1,height:1},E,"_persist_flash")}this.el=I.flash.el},get:function(r){r=
C(r);return this.el.get(this.name,r)},set:function(r,z){r=C(r);return this.el.set(this.name,r,z)},remove:function(r){r=C(r);return this.el.remove(this.name,r)}}}};var A=function(){var r,z=n;var L=0;for(var Q=B.length;L<Q;L++)M.Store.prototype[B[L]]=x;M.type=null;M.size=-1;Q=0;for(var P=z.length;!M.type&&Q<P;Q++)if(L=I[z[Q]],L.test())for(r in M.type=z[Q],M.size=L.size,L.methods)M.Store.prototype[r]=L.methods[r];M._init=!0};var M={VERSION:"0.3.1",type:null,size:0,add:function(r){I[r.id]=r;n=[r.id].concat(n);
A()},remove:function(r){var z=u(n,r);0>z||(n.splice(z,1),delete I[r],A())},Cookie:p,Store:function(r,z){if(!y.exec(r))throw Error("Invalid name");if(!M.type)throw Error("No suitable storage found");z=z||{};this.name=r;z.domain=z.domain||location.hostname||"localhost";z.domain=z.domain.replace(/:\d+$/,"");z.domain="localhost"==z.domain?"":z.domain;this.o=z;z.expires=z.expires||730;z.path=z.path||"/";this.o.search_order&&(n=this.o.search_order,A());this.init()}};A();return M}();var v=new Persist.Store("LayoutProperties");
d.layout.plugins.stateManagement=!0;d.layout.defaults.stateManagement={enabled:!1,autoSave:!0,autoLoad:!0,stateKeys:"north.size,south.size,east.size,west.size,north.isClosed,south.isClosed,east.isClosed,west.isClosed,north.isHidden,south.isHidden,east.isHidden,west.isHidden",storeLocation:"localstorage",cookie:{name:""}};d.layout.optionsMap.layout.push("stateManagement");d.layout.state={config:{allPanes:"north,south,west,east,center"},saveCookie:function(p,u,x){var C=p.options,n=C.stateManagement;
x=d.extend({},n.cookie,x||{});p=p.state.stateData=p.readState(u||n.stateKeys);v.set(x.name||C.name||"Layout",JSON.stringify(p));v.save();return d.extend({},p)},deleteCookie:function(p){p=p.options;v.remove(p.stateManagement.cookie.name||p.name||"Layout")},readCookie:function(p){p=p.options;return(p=v.get(p.stateManagement.cookie.name||p.name||"Layout"))?JSON.parse(p):{}},loadCookie:function(p){var u=d.layout.state.readCookie(p);u&&!d.isEmptyObject(u)&&(p.state.stateData=d.extend({},u),p.loadState(u));
return u},loadState:function(p,u,x){u=d.layout.transformData(u);d.extend(!0,p.options,u);if(p.state.initialized){var C,n,y,B,E=!1===x;d.each(d.layout.state.config.allPanes.split(","),function(I,A){C=u[A];"object"==typeof C&&(n=C.size,B=C.initClosed,y=C.initHidden,(0<n||"auto"==n)&&p.sizePane(A,n,!1,null,E),!0===y?p.hide(A,a):!1===B?p.open(A,!1,E):!0===B?p.close(A,!1,E):!1===y&&p.show(A,!1,E))})}},readState:function(p,u){var x={},C={isClosed:"initClosed",isHidden:"initHidden"},n=p.state;u||(u=p.options.stateManagement.stateKeys);
Array.isArray(u)&&(u=u.join(","));u=u.replace(/__/g,".").split(",");for(var y=0,B=u.length;y<B;y++){var E=u[y].split(".");p=E[0];E=E[1];if(!(0>d.layout.state.config.allPanes.indexOf(p))){var I=n[p][E];void 0!=I&&("isClosed"==E&&n[p].isSliding&&(I=!0),(x[p]||(x[p]={}))[C[E]?C[E]:E]=I)}}return x},_create:function(p){d.extend(p,{readCookie:function(){return d.layout.state.readCookie(p)},deleteCookie:function(){d.layout.state.deleteCookie(p)},saveCookie:function(x,C){return d.layout.state.saveCookie(p,
x,C)},loadCookie:function(){return d.layout.state.loadCookie(p)},loadState:function(x,C){d.layout.state.loadState(p,x,C)},readState:function(x){return d.layout.state.readState(p,x)}});p.state.stateData={};var u=p.options.stateManagement;u.enabled&&(u.autoLoad?p.loadCookie():p.state.stateData=p.readCookie())},_unload:function(p){var u=p.options.stateManagement;u.enabled&&(u.autoSave?p.saveCookie():p.state.stateData=p.readState())}};d.layout.onCreate.push(d.layout.state._create);d.layout.onUnload.push(d.layout.state._unload)}})(U);
(function(d){d.layout&&(d.layout.plugins.buttons=!0,d.layout.defaults.autoBindCustomButtons=!1,d.layout.optionsMap.layout.push("autoBindCustomButtons"),d.layout.buttons={config:{borderPanes:"north,south,west,east"},init:function(v){var p=v.options.name||"",u;d.each("toggle open close pin toggle-slide open-slide".split(" "),function(x,C){d.each(d.layout.buttons.config.borderPanes.split(","),function(n,y){d(".ui-layout-button-"+C+"-"+y).each(function(){u=d(this).data("layoutName")||d(this).attr("layoutName");
if(void 0==u||u===p)v.onButton(this,C,y)})})})},get:function(v,p,u,x){p=d(p);v=v.options;p.length&&0<=d.layout.buttons.config.borderPanes.indexOf(u)&&(x=v[u].buttonClass+"-"+x,p.addClass(x+" "+x+"-"+u).data("layoutName",v.name));return p},bind:function(v,p,u,x){var C=d.layout.buttons;switch(u.toLowerCase()){case "toggle":C.addToggle(v,p,x);break;case "open":C.addOpen(v,p,x);break;case "close":C.addClose(v,p,x);break;case "pin":C.addPin(v,p,x);break;case "toggle-slide":C.addToggle(v,p,x,!0);break;
case "open-slide":C.addOpen(v,p,x,!0)}return v},addToggle:function(v,p,u,x){d.layout.buttons.get(v,p,u,"toggle").on("click",function(C){v.toggle(u,!!x);C.stopPropagation()});return v},addSlideToggle:function(v,p,u,x){d.layout.buttons.get(v,p,u,"slideToggle").on("click",function(C){v.slideToggle(u,!!x);C.stopPropagation()});return v},addOpen:function(v,p,u,x){d.layout.buttons.get(v,p,u,"open").attr("title",v.options[u].tips.Open).on("click",function(C){v.open(u,!!x);C.stopPropagation()});return v},
addClose:function(v,p,u){d.layout.buttons.get(v,p,u,"close").attr("title",v.options[u].tips.Close).on("click",function(x){v.close(u);x.stopPropagation()});return v},addPin:function(v,p,u){var x=d.layout.buttons.get(v,p,u,"pin");if(x.length){var C=v.state[u];x.on("click",function(n){d.layout.buttons.setPinState(v,d(this),u,C.isSliding||C.isClosed);C.isSliding||C.isClosed?v.open(u):v.close(u);n.stopPropagation()});d.layout.buttons.setPinState(v,x,u,!C.isClosed&&!C.isSliding);C.pins.push(p)}return v},
setPinState:function(v,p,u,x){var C=p.attr("pin");if(!C||x!==("down"==C)){C=v.options[u];v=C.tips;C=C.buttonClass+"-pin";var n=C+"-"+u;u=C+"-up "+n+"-up";C=C+"-down "+n+"-down";p.attr("pin",x?"down":"up").attr("title",x?v.Unpin:v.Pin).removeClass(x?u:C).addClass(x?C:u)}},syncPinBtns:function(v,p,u){d.each(state[p].pins,function(x,C){d.layout.buttons.setPinState(v,d(C),p,u)})},_load:function(v){d.extend(v,{bindButton:function(u,x,C){return d.layout.buttons.on(v,u,x,C)},addToggleBtn:function(u,x,C){return d.layout.buttons.addToggle(v,
u,x,C)},addSlideToggleBtn:function(u,x,C){return d.layout.buttons.addSlideToggle(v,u,x,C)},addOpenBtn:function(u,x,C){return d.layout.buttons.addOpen(v,u,x,C)},addCloseBtn:function(u,x){return d.layout.buttons.addClose(v,u,x)},addPinBtn:function(u,x){return d.layout.buttons.addPin(v,u,x)}});for(var p=0;4>p;p++)v.state[d.layout.buttons.config.borderPanes[p]].pins=[];v.options.autoBindCustomButtons&&d.layout.buttons.init(v)},_unload:function(v){}},d.layout.onLoad.push(d.layout.buttons._load))})(U);
(function(d){d.layout.plugins.browserZoom=!0;d.layout.defaults.browserZoomCheckInterval=1E3;d.layout.optionsMap.layout.push("browserZoomCheckInterval");d.layout.browserZoom={_init:function(v){!1!==d.layout.browserZoom.ratio()&&d.layout.browserZoom._setTimer(v)},_setTimer:function(v){if(!v.destroyed){var p=v.options,u=v.state;setTimeout(function(){if(!v.destroyed&&p.resizeWithWindow){var x=d.layout.browserZoom.ratio();x!==u.browserZoom&&(u.browserZoom=x,v.resizeAll());d.layout.browserZoom._setTimer(v)}},
v.hasParentLayout?5E3:Math.max(p.browserZoomCheckInterval,100))}},ratio:function(){function v(I,A){return(parseInt(I,10)/parseInt(A,10)*100).toFixed()}var p=window,u=screen,x=document,C=x.documentElement||x.body,n=d.layout.browser,y,B,E;return u.deviceXDPI&&u.systemXDPI?v(u.deviceXDPI,u.systemXDPI):n.webkit&&(y=x.body.getBoundingClientRect)?v(y.left-y.right,x.body.offsetWidth):n.webkit&&(B=p.outerWidth)?v(B,p.innerWidth):(B=u.width)&&(E=C.clientWidth)?v(B,E):!1}};d.layout.onReady.push(d.layout.browserZoom._init)})(U);
(function(d){d.effects&&(d.layout.defaults.panes.useOffscreenClose=!1,d.layout.plugins&&(d.layout.plugins.effects.slideOffscreen=!0),d.layout.effects.slideOffscreen=d.extend(!0,{},d.layout.effects.slide),d.effects.slideOffscreen=function(v){return this.queue(function(){var p=d.effects,u=v.options,x=d(this),C=x.data("layoutEdge"),n=x.data("parentLayout").state;C=n[C].size;var y=this.style,B="show"==p.setMode(x,u.mode||"show");p=u.direction||"left";var E="up"==p||"down"==p?"top":"left",I="up"==p||"left"==
p,A=d.layout.config.offscreenCSS||{},M=d.layout.config.offscreenReset,r={};r[E]=(B?I?"+\x3d":"-\x3d":I?"-\x3d":"+\x3d")+C;B?(x.data("offscreenResetTop",{top:y.top,bottom:y.bottom}),I?x.css(E,isNaN(C)?"-"+C:-C):"right"===p?x.css({left:n.container.layoutWidth,right:"auto"}):x.css({top:n.container.layoutHeight,bottom:"auto"}),"top"===E&&x.css(x.data(M)||{})):(x.data("offscreenResetTop",{top:y.top,bottom:y.bottom}),x.data(M,{left:y.left,right:y.right}));x.show().animate(r,{queue:!1,duration:v.duration,
easing:u.easing,complete:function(){x.data("offscreenResetTop")&&x.css(x.data("offscreenResetTop")).removeData("offscreenResetTop");B?x.css(x.data(M)||{}).removeData(M):x.css(A);v.callback&&v.callback.apply(this,arguments);x.dequeue()}})})})})(U);(function(d){var v=d.layout;v.callbacks||(v.callbacks={});v.callbacks.resizePaneAccordions=function(p,u){(u.jquery?u:d(u.newPanel||u.panel)).find(".ui-accordion:visible").each(function(){var x=d(this);x.data("accordion")&&x.accordion("resize");x.data("ui-accordion")&&
x.accordion("refresh")})}})(U);(function(d){d.layout.callbacks.resizeDataTables=function(v,p){var u=p.jquery?p[0]:p.panel;d(u).is(":visible")&&d(d.fn.dataTable.fnTables(!0)).each(function(x,C){d.contains(u,C)&&d(C).dataTable().fnAdjustColumnSizing()})}})(U);(function(d){var v=d.layout;v.callbacks||(v.callbacks={});v.callbacks.resizeTabLayout=function(p,u){(u.jquery?u:d(u.newPanel||u.panel)).filter(":visible").find(".ui-layout-container:visible").addBack().each(function(){var x=d(this).data("layout");
x&&(x.options.resizeWithWindow=!1,x.resizeAll())})}})(U);return U});
PrimeFaces.widget.ExtLayout=PrimeFaces.widget.DeferredWidget.extend({init:function(U){this._super(U);this.cfg=U;this.id=U.id;this.jq=$(U.forTarget);this.stateHiddenField=null;this.jqId=PrimeFaces.escapeClientId(this.id);if(this.cfg.full){var d=$(this.cfg.centerSelector).parents(".ui-dialog-content");this.jq=1==d.length?d:$("body")}else this.jq=this.cfg.parent?$(PrimeFaces.escapeClientId(this.cfg.parent)):$(this.jqId);U.clientState?this.cfg.options.stateManagement={enabled:!0,autoSave:!0,autoLoad:!0,
storeLocation:"sessionStorage",cookie:{name:encodeURIComponent("Layout-"+this.id)}}:U.serverState&&(this.stateHiddenField=$(this.jqId+"_state"));this.renderDeferred()},_render:function(){this.layout=this.jq.layout(this.cfg.options);this.cfg.serverState&&this.layout.loadState(this.cfg.state);this.cfg.full||this.jq.css("overflow","visible");this.bindEvents(this.jq)},bindEvents:function(U){var d=this;U.find(".ui-layout-pane").on("layoutpaneonopen",function(){var v=d.cfg.behaviors?d.cfg.behaviors.open:
null;if(v){var p=$(this).data("combinedposition");v.call(d,{params:[{name:d.id+"_pane",value:p}]})}d.cfg.serverState&&d.stateHiddenField.val(JSON.stringify(d.layout.readState()))}).on("layoutpaneonclose",function(){var v=d.cfg.behaviors?d.cfg.behaviors.close:null;if(v){var p=$(this).data("combinedposition");v.call(d,{params:[{name:d.id+"_pane",value:p}]})}d.cfg.serverState&&d.stateHiddenField.val(JSON.stringify(d.layout.readState()))}).on("layoutpaneonresize",function(){var v=$(this).data("layoutPane");
if(v&&!v.state.isClosed&&!v.state.isHidden){var p=d.cfg.behaviors?d.cfg.behaviors.resize:null;if(p){var u=$(this).data("combinedposition");p.call(d,{params:[{name:d.id+"_pane",value:u},{name:d.id+"_width",value:v.state.innerWidth},{name:d.id+"_height",value:v.state.innerHeight}]})}d.cfg.serverState&&d.stateHiddenField.val(JSON.stringify(d.layout.readState()))}})},toggle:function(U){this.jq.find(".ui-layout-pane").each(function(){var d=$(this).data("combinedposition");if(d&&d===U)return $(this).trigger("layoutpanetoggle"),
!1})},close:function(U){for(var d=this.jq.find(".ui-layout-pane"),v=d.length,p=0;p<v;p++){var u=$(d[p]).data("combinedposition");if(u&&u===U){$(d[p]).trigger("layoutpaneclose");break}}},open:function(U){for(var d=this.jq.find(".ui-layout-pane"),v=d.length,p=0;p<v;p++){var u=$(d[p]).data("combinedposition");if(u&&u===U){$(d[p]).trigger("layoutpaneopen");break}}},sizePane:function(U,d){for(var v=this.jq.find(".ui-layout-pane"),p=v.length,u=0;u<p;u++){var x=$(v[u]).data("combinedposition");if(x&&x===
U){$(v[u]).trigger("layoutpanesize",[d]);break}}},sizeContent:function(U){for(var d=this.jq.find(".ui-layout-pane"),v=d.length,p=0;p<v;p++){var u=$(d[p]).data("combinedposition");if(u&&u===U){$(d[p]).trigger("layoutpanesizecontent");break}}},resizeAll:function(){this.layout&&this.layout.resizeAll()}});